/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (GET_MODE (x3) != E_V8QImode)
        return -1;
      return 0;

    case E_V4HImode:
      if (GET_MODE (x3) != E_V4HImode)
        return -1;
      return 1;

    case E_V2SImode:
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 2;

    case E_V2SFmode:
      if (pattern1 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 3;

    case E_V4UQQmode:
      if (pattern1 (x3, 
E_V4UQQmode) != 0)
        return -1;
      return 4;

    case E_V2UHQmode:
      if (pattern1 (x3, 
E_V2UHQmode) != 0)
        return -1;
      return 5;

    case E_UQQmode:
      if (pattern1 (x3, 
E_UQQmode) != 0)
        return -1;
      return 6;

    case E_UHQmode:
      if (pattern1 (x3, 
E_UHQmode) != 0)
        return -1;
      return 7;

    case E_V2UHAmode:
      if (pattern1 (x3, 
E_V2UHAmode) != 0)
        return -1;
      return 8;

    case E_UHAmode:
      if (pattern1 (x3, 
E_UHAmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 19)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return pattern21 (x1); /* [-1, 3] */
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern34 (x3, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern34 (x3, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern34 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern52 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern51 (x3, 
i1, 
i2, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern51 (x3, 
i3, 
i4, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      return pattern49 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8BImode:
      if (pattern49 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4BImode:
      if (pattern49 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern72 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern72 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !vpr_register_operand (operands[3], E_V8BImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != i1
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != XOR
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern38 (x3, 
i1, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern38 (x3, 
i2, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern148 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (GET_MODE (x3) != E_V8HFmode)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern148 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 5;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !mve_imm_16 (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern166 (x3, 
E_V8HFmode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern167 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arm_low_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!arm_low_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[2], E_V16QImode)
          || !s_register_operand (operands[3], E_V16QImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern237 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !const_neon_scalar_shift_amount_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!const_int_M_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  if (!const_int_M_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!arm_add_operand (operands[3], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_CC_Zmode:
          return pattern259 (x1, 
E_CC_Zmode); /* [-1, 1] */

        case E_SImode:
          res = pattern259 (x1, 
E_SImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case MEM:
      operands[2] = x3;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_CC_Zmode:
          res = pattern260 (x1, 
E_CC_Zmode);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_SImode:
          res = pattern260 (x1, 
E_SImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern275 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!power_of_two_operand (operands[3], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return pattern278 (x1); /* [-1, 9] */

    case ABS:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ABS)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern279 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern279 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern279 (x1, 
E_V8HFmode, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V4HImode:
          if (pattern279 (x1, 
E_V4HFmode, 
E_V4HImode) != 0)
            return -1;
          return 13;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern294 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[3] = x4;
      if (!arm_comparison_operator (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (!arm_comparison_operator (x5, E_SImode))
        return -1;
      operands[6] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 100
          || GET_MODE (x7) != E_CCmode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || pattern290 (x3) != 0)
        return -1;
      return 0;

    case MEM:
      res = pattern293 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern311 (x6, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern311 (x6, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern311 (x6, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V4UQQmode:
      if (pattern310 (x6, 
E_V4UQQmode) != 0)
        return -1;
      return 3;

    case E_V2UHQmode:
      if (pattern310 (x6, 
E_V2UHQmode) != 0)
        return -1;
      return 4;

    case E_UQQmode:
      if (pattern310 (x6, 
E_UQQmode) != 0)
        return -1;
      return 5;

    case E_UHQmode:
      if (pattern310 (x6, 
E_UHQmode) != 0)
        return -1;
      return 6;

    case E_V2UHAmode:
      if (pattern310 (x6, 
E_V2UHAmode) != 0)
        return -1;
      return 7;

    case E_UHAmode:
      if (pattern310 (x6, 
E_UHAmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern330 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  operands[3] = x7;
  if (!mve_imm_selective_upto_8 (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x2, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[4] = x9;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return pattern329 (x5); /* [-1, 2] */
}

int
pattern344 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern352 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern352 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern352 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern361 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (!subreg_lowpart_operator (x5, E_VOIDmode))
    return -1;
  operands[5] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[4] = x9;
  if (!s_register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[4] = x8;
      x9 = XEXP (x8, 0);
      operands[5] = x9;
      return 0;

    case MULT:
    case ASHIFT:
    case ASHIFTRT:
      if (!sat_shift_operator (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[6] = x8;
      x9 = XEXP (x8, 0);
      operands[7] = x9;
      x10 = XEXP (x5, 0);
      operands[4] = x10;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern397 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern404 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern411 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 2);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern418 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern426 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !s_register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !s_register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern437 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern445 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern464 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode
      || !register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode
      || !register_operand (operands[1], E_V4SFmode)
      || !register_operand (operands[2], E_V8BFmode)
      || !register_operand (operands[3], E_V8BFmode))
    return -1;
  return 0;
}

int
pattern472 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern483 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const_int_vcde3_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern492 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern491 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern491 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern491 (x1, 
E_DImode, 
E_SImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern499 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != 2147483648L)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CONST_INT
      || XWINT (x6, 0) != 2147483648L)
    return -1;
  x7 = XEXP (x2, 1);
  if (XWINT (x7, 0) != 32L
      || pattern498 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
    return -1;
  return 0;
}

int
pattern510 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern516 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !s_register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern515 (x4, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern528 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 14
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern534 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[3], E_V4BFmode))
        return -1;
      return 0;

    case E_V8BFmode:
      if (!register_operand (operands[3], E_V8BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern544 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern556 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern567 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern574 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MINUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern578 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern595 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != 2147483648L)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CONST_INT
      || XWINT (x6, 0) != 2147483648L)
    return -1;
  x7 = XEXP (x2, 1);
  if (XWINT (x7, 0) != 32L
      || pattern594 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
    return -1;
  return 0;
}

int
pattern603 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 14
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern624 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern635 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern647 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern655 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  switch (pattern548 (x6, 
MULT))
    {
    case 0:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      x9 = XEXP (x8, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XEXP (x8, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      if (
#line 2306 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6))
        return 59; /* *mulsi3_compare0 */
      if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
        return -1;
      return 60; /* *mulsi3_compare0_v6 */

    case 1:
      if (
#line 2333 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6))
        return 61; /* *mulsi_compare0_scratch */
      if (!
#line 2346 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
        return -1;
      return 62; /* *mulsi_compare0_scratch_v6 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern385 (x1) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!arm_carry_operation (operands[3], E_SImode)
          || !
#line 1405 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 25; /* *addsi3_carryin_clobercc */

    case MULT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (!s_register_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[4] = x7;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          if (pattern386 (x8, 
LSHIFTRT, 
E_SImode, 
TRUNCATE, 
PLUS) != 0)
            return -1;
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != PLUS
              || GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != MULT
              || GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x11, 1);
          if (GET_CODE (x13) != ZERO_EXTEND
              || GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x10, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x15 = XEXP (x4, 1);
          operands[5] = x15;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          operands[1] = x6;
          x16 = XEXP (x5, 0);
          operands[2] = x16;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x17 = XEXP (x12, 0);
          if (GET_MODE (x17) != E_DImode)
            return -1;
          x18 = XEXP (x12, 1);
          if (GET_MODE (x18) != E_DImode)
            return -1;
          x19 = XEXP (x8, 1);
          operands[3] = x19;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x20 = XEXP (x13, 0);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          switch (GET_CODE (x17))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x18) != SIGN_EXTEND)
                return -1;
              x21 = XEXP (x17, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x22 = XEXP (x18, 0);
              if (!rtx_equal_p (x22, operands[5])
                  || !
#line 2485 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 69; /* smlal */

            case ZERO_EXTEND:
              if (GET_CODE (x18) != ZERO_EXTEND)
                return -1;
              x21 = XEXP (x17, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x22 = XEXP (x18, 0);
              if (!rtx_equal_p (x22, operands[5])
                  || !
#line 2485 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 70; /* umlal */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_CODE (x15) != SIGN_EXTEND
              || GET_MODE (x15) != E_SImode
              || pattern549 (x5, 
E_CCmode, 
104, 
28) != 0)
            return -1;
          x23 = XEXP (x7, 0);
          operands[1] = x23;
          if (!s_register_operand (operands[1], E_HImode))
            return -1;
          x24 = XEXP (x15, 0);
          operands[2] = x24;
          if (!s_register_operand (operands[2], E_HImode))
            return -1;
          operands[3] = x6;
          if (!
#line 2618 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
            return -1;
          return 78; /* arm_smlabb_setq */

        case ASHIFTRT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x25 = XEXP (x7, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || pattern549 (x5, 
E_CCmode, 
104, 
28) != 0)
            return -1;
          x23 = XEXP (x7, 0);
          operands[1] = x23;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          operands[3] = x6;
          switch (GET_CODE (x15))
            {
            case SIGN_EXTEND:
              x24 = XEXP (x15, 0);
              operands[2] = x24;
              if (!s_register_operand (operands[2], E_HImode)
                  || !
#line 2666 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 80; /* arm_smlatb_setq */

            case ASHIFTRT:
              x26 = XEXP (x15, 1);
              if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x24 = XEXP (x15, 0);
              operands[2] = x24;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 2716 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 82; /* arm_smlatt_setq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 52 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 941; /* *thumb1_adddi3 */

    case MEM:
      switch (pattern293 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3141; /* atomic_add_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3146; /* atomic_add_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3151; /* atomic_add_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3156; /* atomic_add_fetchdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 100)
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (GET_MODE (x5) != E_CCmode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != MINUS
          || GET_MODE (x8) != E_SImode
          || GET_MODE (x3) != E_CCmode)
        return -1;
      operands[1] = x4;
      if (!arm_rhs_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x6;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x8, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 2082 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 47; /* subsi3_compare */

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || pattern287 (x1, 
CLOBBER, 
E_CC_NVmode, 
100) != 0
          || GET_MODE (x3) != E_CC_NVmode)
        return -1;
      x12 = XEXP (x4, 0);
      operands[1] = x12;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case PLUS:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x13 = XEXP (x6, 0);
          operands[3] = x13;
          if (!arm_borrow_operation (operands[3], E_DImode))
            return -1;
          x14 = XEXP (x6, 1);
          switch (GET_CODE (x14))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              operands[2] = x15;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 1763 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 33; /* cmpsi3_carryin_CC_NVout */

            case CONST_INT:
              operands[2] = x14;
              if (!arm_adcimm_operand (operands[2], E_DImode)
                  || !
#line 1780 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 35; /* cmpsi3_imm_carryin_CC_NVout */

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[2] = x6;
          if (!arm_borrow_operation (operands[2], E_DImode)
              || !
#line 1795 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 37; /* cmpsi3_0_carryin_CC_NVout */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 100
          || GET_MODE (x5) != E_CC_Bmode
          || GET_MODE (x3) != E_CC_Bmode)
        return -1;
      x12 = XEXP (x4, 0);
      operands[1] = x12;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case PLUS:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x13 = XEXP (x6, 0);
          if (!arm_borrow_operation (x13, E_DImode))
            return -1;
          x14 = XEXP (x6, 1);
          switch (GET_CODE (x14))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              operands[2] = x15;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x7))
                {
                case CLOBBER:
                  operands[3] = x13;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!scratch_operand (operands[0], E_SImode)
                      || !
#line 1763 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 34; /* cmpsi3_carryin_CC_Bout */

                case SET:
                  x8 = XEXP (x7, 1);
                  if (pattern574 (x8) != 0)
                    return -1;
                  operands[4] = x13;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x11 = XEXP (x8, 1);
                  x16 = XEXP (x11, 0);
                  operands[3] = x16;
                  if (!arm_borrow_operation (operands[3], E_SImode))
                    return -1;
                  x10 = XEXP (x8, 0);
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  x17 = XEXP (x11, 1);
                  if (!rtx_equal_p (x17, operands[2])
                      || !
#line 2145 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 52; /* usubvsi3_borrow */

                default:
                  return -1;
                }

            case CONST_INT:
              x7 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x7))
                {
                case CLOBBER:
                  operands[3] = x13;
                  operands[2] = x14;
                  if (!arm_adcimm_operand (operands[2], E_DImode))
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!scratch_operand (operands[0], E_SImode)
                      || !
#line 1780 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 36; /* cmpsi3_imm_carryin_CC_Bout */

                case SET:
                  x8 = XEXP (x7, 1);
                  if (pattern574 (x8) != 0)
                    return -1;
                  operands[5] = x13;
                  operands[3] = x14;
                  if (!const_int_operand (operands[3], E_DImode))
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x11 = XEXP (x8, 1);
                  x16 = XEXP (x11, 0);
                  operands[4] = x16;
                  if (!arm_borrow_operation (operands[4], E_SImode))
                    return -1;
                  x17 = XEXP (x11, 1);
                  operands[2] = x17;
                  if (!arm_adcimm_operand (operands[2], E_SImode))
                    return -1;
                  x10 = XEXP (x8, 0);
                  if (!rtx_equal_p (x10, operands[1])
                      || !
#line 2162 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[2]) & 0xffffffff) == UINTVAL (operands[3])))
                    return -1;
                  return 53; /* usubvsi3_borrow_imm */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[2] = x6;
          if (!arm_borrow_operation (operands[2], E_DImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1795 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 38; /* cmpsi3_0_carryin_CC_Bout */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 100)
        return -1;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[2] = x12;
          if (s_register_operand (operands[2], E_SImode))
            {
              res = recog_3 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x12;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x6, 0))
            {
            case -1L:
              if (pattern417 (x1, 
E_CC_RSBmode, 
NEG) != 0)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!s_register_operand (operands[0], E_SImode))
                return -1;
              x8 = XEXP (x7, 1);
              x10 = XEXP (x8, 0);
              if (!rtx_equal_p (x10, operands[1])
                  || !
#line 5197 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 169; /* negsi2_0compare */

            case 0L:
              if (GET_MODE (x5) != E_CC_NZmode
                  || GET_MODE (x3) != E_CC_NZmode)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              switch (pattern548 (x7, 
NOT))
                {
                case 0:
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x8 = XEXP (x7, 1);
                  x10 = XEXP (x8, 0);
                  if (!rtx_equal_p (x10, operands[1])
                      || !
#line 5417 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 174; /* *notsi_compare0 */

                case 1:
                  if (!
#line 5428 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 175; /* *notsi_compare0_scratch */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[3] = x12;
          if (!shift_operator (operands[3], E_SImode)
              || XWINT (x6, 0) != 0L
              || GET_MODE (x5) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          x18 = XEXP (x12, 0);
          operands[1] = x18;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x19 = XEXP (x12, 1);
          operands[2] = x19;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          switch (pattern548 (x7, 
NOT))
            {
            case 0:
              x8 = XEXP (x7, 1);
              x10 = XEXP (x8, 0);
              switch (GET_CODE (x10))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x10, operands[3]))
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!s_register_operand (operands[0], E_SImode)
                      || !
#line 4813 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 155; /* *not_shiftsi_compare0 */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 4828 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 156; /* *not_shiftsi_compare0_scratch */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern288 (x2) != 0)
        return -1;
      x12 = XEXP (x4, 0);
      if (s_register_operand (x12, E_SImode))
        {
          res = recog_5 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x4) != MULT
          || GET_MODE (x4) != E_SImode)
        return -1;
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x20 = XEXP (x4, 1);
      operands[2] = x20;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (pattern548 (x7, 
MULT))
        {
        case 0:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x7, 1);
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x8, 1);
          if (!rtx_equal_p (x11, operands[2])
              || !
#line 1443 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size))
            return -1;
          return 1062; /* *thumb2_mulsi_short_compare0 */

        case 1:
          if (!
#line 1455 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size))
            return -1;
          return 1063; /* *thumb2_mulsi_short_compare0_scratch */

        default:
          return -1;
        }

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      switch (GET_CODE (x4))
        {
        case PLUS:
          res = recog_6 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MINUS:
          res = recog_7 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IOR:
          res = recog_9 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case XOR:
          res = recog_10 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x4;
      if (!shiftable_operator (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x4, 0);
      if (!shift_operator (x12, E_SImode))
        return -1;
      operands[3] = x12;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern288 (x2) != 0)
        return -1;
      x18 = XEXP (x12, 0);
      operands[4] = x18;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x19 = XEXP (x12, 1);
      operands[5] = x19;
      if (!shift_amount_operand (operands[5], E_SImode))
        return -1;
      x20 = XEXP (x4, 1);
      operands[2] = x20;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case SET:
          x8 = XEXP (x7, 1);
          switch (GET_CODE (x8))
            {
            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!s_register_operand (operands[0], E_SImode)
                  || !
#line 9737 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 329; /* *arith_shiftsi_compare0 */

            default:
              return -1;
            }

        case CLOBBER:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 9754 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 330; /* *arith_shiftsi_compare0_scratch */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
      if (pnum_clobbers == NULL
          || XWINT (x7, 0) != 0L
          || GET_MODE (x2) != E_CC_NZmode
          || GET_MODE (x3) != E_CC_NZmode
          || !arm_rhs_operand (operands[2], E_SImode)
          || !
#line 4785 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 153; /* *shiftsi3_compare0_scratch */

    case REG:
    case SUBREG:
      operands[0] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_CC_SWPmode
          || GET_MODE (x3) != E_CC_SWPmode
          || !shift_amount_operand (operands[2], E_SImode)
          || !
#line 7911 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 274; /* *cmpsi_shiftsi_swp */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  switch (REGNO (x4))
    {
    case 100:
      switch (GET_MODE (x4))
        {
        case E_CCFPmode:
          switch (pattern362 (x2, 
E_CCFPmode))
            {
            case 0:
              if (!
#line 1749 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 861; /* *cmpsf_split_vfp */

            case 1:
              if (!
#line 1779 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 863; /* *cmpdf_split_vfp */

            default:
              return -1;
            }

        case E_CCFPEmode:
          switch (pattern362 (x2, 
E_CCFPEmode))
            {
            case 0:
              if (!
#line 1764 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 862; /* *cmpsf_trap_split_vfp */

            case 1:
              if (!
#line 1794 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 864; /* *cmpdf_trap_split_vfp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 101:
      switch (GET_MODE (x4))
        {
        case E_CCFPmode:
          switch (pattern362 (x2, 
E_CCFPmode))
            {
            case 0:
              if (!
#line 1815 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 865; /* *cmpsf_vfp */

            case 1:
              if (!
#line 1839 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 867; /* *cmpdf_vfp */

            default:
              return -1;
            }

        case E_CCFPEmode:
          switch (pattern362 (x2, 
E_CCFPEmode))
            {
            case 0:
              if (!
#line 1827 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 866; /* *cmpsf_trap_vfp */

            case 1:
              if (!
#line 1851 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 868; /* *cmpdf_trap_vfp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!arm_rhs_operand (operands[2], E_SImode)
          || !
#line 3797 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 112; /* *iorsi3_compare0_scratch */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern341 (x1) != 0
          || !
#line 10415 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 343; /* *cmp_ior */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[2] = x3;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 2261 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 56; /* *mul */

        case E_V4HImode:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          operands[1] = x3;
          if (register_operand (operands[1], E_V4HImode)
              && register_operand (operands[0], E_V4HImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (register_operand (operands[2], E_V4HImode)
                  && 
#line 481 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 570; /* *mulv4hi3_iwmmxt */
            }
          if (!s_register_operand (operands[1], E_V4HImode)
              || !s_register_operand (operands[0], E_V4HImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!s_register_operand (operands[2], E_V4HImode)
              || !
#line 543 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
            return -1;
          return 1183; /* *mulv4hi3_neon */

        case E_V2SImode:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          operands[1] = x3;
          if (register_operand (operands[1], E_V2SImode)
              && register_operand (operands[0], E_V2SImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (register_operand (operands[2], E_V2SImode)
                  && 
#line 361 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return 709; /* iwmmxt_wmulwl */
            }
          if (!s_register_operand (operands[1], E_V2SImode)
              || !s_register_operand (operands[0], E_V2SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!s_register_operand (operands[2], E_V2SImode)
              || !
#line 543 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
            return -1;
          return 1185; /* *mulv2si3_neon */

        case E_HFmode:
          if (pattern300 (x2, 
E_HFmode) != 0
              || !
#line 1103 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 804; /* mulhf3 */

        case E_SFmode:
          if (pattern300 (x2, 
E_SFmode) != 0
              || !
#line 1113 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 805; /* *mulsf3_vfp */

        case E_DFmode:
          if (pattern300 (x2, 
E_DFmode) != 0
              || !
#line 1123 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 806; /* *muldf3_vfp */

        case E_V8QImode:
          if (pattern300 (x2, 
E_V8QImode) != 0
              || !
#line 543 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
            return -1;
          return 1181; /* *mulv8qi3_neon */

        case E_V16QImode:
          if (pattern300 (x2, 
E_V16QImode) != 0)
            return -1;
          if (
#line 543 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
            return 1182; /* *mulv16qi3_neon */
          if (!
#line 991 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3672; /* mve_vmulqv16qi */

        case E_V8HImode:
          if (pattern300 (x2, 
E_V8HImode) != 0)
            return -1;
          if (
#line 543 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
            return 1184; /* *mulv8hi3_neon */
          if (!
#line 991 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3675; /* mve_vmulqv8hi */

        case E_V4SImode:
          if (pattern300 (x2, 
E_V4SImode) != 0)
            return -1;
          if (
#line 543 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
            return 1186; /* *mulv4si3_neon */
          if (!
#line 991 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3678; /* mve_vmulqv4si */

        case E_V2SFmode:
          if (pattern300 (x2, 
E_V2SFmode) != 0
              || !
#line 543 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 1187; /* *mulv2sf3_neon */

        case E_V4SFmode:
          if (pattern300 (x2, 
E_V4SFmode) != 0)
            return -1;
          if (
#line 543 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return 1188; /* *mulv4sf3_neon */
          if (!
#line 1399 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3833; /* mve_vmulq_fv4sf */

        case E_V8HFmode:
          if (pattern300 (x2, 
E_V8HFmode) != 0)
            return -1;
          if (
#line 1635 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return 1534; /* neon_vmulfv8hf */
          if (!
#line 1399 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3830; /* mve_vmulq_fv8hf */

        case E_V4HFmode:
          if (pattern300 (x2, 
E_V4HFmode) != 0
              || !
#line 1635 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1535; /* neon_vmulfv4hf */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case SIGN_EXTEND:
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern424 (x2) != 0
                      || GET_MODE (x4) != E_SImode
                      || !s_register_operand (operands[2], E_HImode)
                      || !
#line 2528 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                    return -1;
                  return 73; /* mulhisi3 */

                case E_V8HImode:
                  if (pattern425 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 6495 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 3000; /* neon_vec_smult_v8qi */

                case E_V4SImode:
                  if (pattern425 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6495 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 3002; /* neon_vec_smult_v4hi */

                case E_V2DImode:
                  if (pattern425 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6495 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 3004; /* neon_vec_smult_v2si */

                default:
                  return -1;
                }

            case ASHIFTRT:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x7 = XEXP (x4, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  || pattern424 (x2) != 0)
                return -1;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 2554 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 75; /* *mulhisi3bt */

            default:
              return -1;
            }

        case VEC_SELECT:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != SIGN_EXTEND)
            return -1;
          switch (pattern343 (x2))
            {
            case 0:
              if (vect_par_constant_low (operands[2], E_V16QImode)
                  && 
#line 6355 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2976; /* neon_vec_smult_lo_v16qi */
              if (!vect_par_constant_high (operands[2], E_V16QImode)
                  || !
#line 6389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2982; /* neon_vec_smult_hi_v16qi */

            case 1:
              if (vect_par_constant_low (operands[2], E_V8HImode)
                  && 
#line 6355 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2978; /* neon_vec_smult_lo_v8hi */
              if (!vect_par_constant_high (operands[2], E_V8HImode)
                  || !
#line 6389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2984; /* neon_vec_smult_hi_v8hi */

            case 2:
              if (vect_par_constant_low (operands[2], E_V4SImode)
                  && 
#line 6355 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2980; /* neon_vec_smult_lo_v4si */
              if (!vect_par_constant_high (operands[2], E_V4SImode)
                  || !
#line 6389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2986; /* neon_vec_smult_hi_v4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern267 (x2, 
16) != 0)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_HImode)
              || !
#line 2541 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
            return -1;
          return 74; /* *mulhisi3tb */

        case ASHIFTRT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2568 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
            return -1;
          return 76; /* *mulhisi3tt */

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (pattern368 (x2, 
E_HFmode) != 0
              || !
#line 1133 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST && !flag_rounding_math))
            return -1;
          return 807; /* *mulsf3neghf_vfp */

        case E_SFmode:
          if (pattern368 (x2, 
E_SFmode) != 0
              || !
#line 1153 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && !flag_rounding_math))
            return -1;
          return 809; /* *mulsf3negsf_vfp */

        case E_DFmode:
          if (pattern368 (x2, 
E_DFmode) != 0
              || !
#line 1173 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE
  && !flag_rounding_math))
            return -1;
          return 811; /* *muldf3negdf_vfp */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern268 (x2))
        {
        case 0:
          if (!
#line 1865 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math))
            return -1;
          return 869; /* *combine_vcvt_f32_u32 */

        case 1:
          if (!
#line 1878 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math
  && !TARGET_VFP_SINGLE))
            return -1;
          return 871; /* *combine_vcvt_f64_u32 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern268 (x2))
        {
        case 0:
          if (!
#line 1865 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math))
            return -1;
          return 870; /* *combine_vcvt_f32_s32 */

        case 1:
          if (!
#line 1878 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math
  && !TARGET_VFP_SINGLE))
            return -1;
          return 872; /* *combine_vcvt_f64_s32 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTEND)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          switch (pattern343 (x2))
            {
            case 0:
              if (vect_par_constant_low (operands[2], E_V16QImode)
                  && 
#line 6355 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2977; /* neon_vec_umult_lo_v16qi */
              if (!vect_par_constant_high (operands[2], E_V16QImode)
                  || !
#line 6389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2983; /* neon_vec_umult_hi_v16qi */

            case 1:
              if (vect_par_constant_low (operands[2], E_V8HImode)
                  && 
#line 6355 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2979; /* neon_vec_umult_lo_v8hi */
              if (!vect_par_constant_high (operands[2], E_V8HImode)
                  || !
#line 6389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2985; /* neon_vec_umult_hi_v8hi */

            case 2:
              if (vect_par_constant_low (operands[2], E_V4SImode)
                  && 
#line 6355 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2981; /* neon_vec_umult_lo_v4si */
              if (!vect_par_constant_high (operands[2], E_V4SImode)
                  || !
#line 6389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2987; /* neon_vec_umult_hi_v4si */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern425 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                  || !
#line 6495 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 3001; /* neon_vec_umult_v8qi */

            case E_V4SImode:
              if (pattern425 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                  || !
#line 6495 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 3003; /* neon_vec_umult_v4hi */

            case E_V2DImode:
              if (pattern425 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                  || !
#line 6495 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 3005; /* neon_vec_umult_v2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (register_operand (operands[0], E_SImode)
      && 
#line 12292 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_HARD_TP))
    return 405; /* load_tp_hard */
  if (pnum_clobbers == NULL
      || GET_CODE (x4) != REG
      || REGNO (x4) != 0
      || GET_MODE (x4) != E_SImode)
    return -1;
  if (
#line 12314 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_SOFT_TP && TARGET_FDPIC))
    {
      *pnum_clobbers = 4;
      return 407; /* load_tp_soft_fdpic */
    }
  if (!
#line 12326 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_SOFT_TP && !TARGET_FDPIC))
    return -1;
  *pnum_clobbers = 3;
  return 408; /* load_tp_soft */
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern369 (x2, 
E_V8QImode, 
E_V8HImode) != 0
          || !
#line 3179 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4830; /* mve_vstrq_truncate_v8qi */

    case E_V4QImode:
      if (pattern369 (x2, 
E_V4QImode, 
E_V4SImode) != 0
          || !
#line 3179 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4831; /* mve_vstrq_truncate_v4qi */

    case E_V4HImode:
      if (pattern369 (x2, 
E_V4HImode, 
E_V4SImode) != 0
          || !
#line 3179 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4832; /* mve_vstrq_truncate_v4hi */

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  *pnum_clobbers = 2;
  return 308; /* *stack_protect_combined_set_insn */
}

 int
recog_138 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern162 (x1, 
E_OImode) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!neon_struct_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V8QImode
          || !
#line 6105 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2926; /* neon_vld4_dupv8qi */

    case E_V4HImode:
      if (!neon_struct_operand (operands[1], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V4HImode
          || !
#line 6105 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2927; /* neon_vld4_dupv4hi */

    case E_V4HFmode:
      if (!neon_struct_operand (operands[1], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V4HFmode
          || !
#line 6105 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2928; /* neon_vld4_dupv4hf */

    case E_V4BFmode:
      if (!neon_struct_operand (operands[1], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V4BFmode
          || !(
#line 6105 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2929; /* neon_vld4_dupv4bf */

    case E_V4SImode:
      if (!neon_struct_operand (operands[1], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V2SImode
          || !
#line 6105 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2930; /* neon_vld4_dupv2si */

    case E_V4SFmode:
      if (!neon_struct_operand (operands[1], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V2SFmode
          || !
#line 6105 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2931; /* neon_vld4_dupv2sf */

    case E_OImode:
      if (!neon_struct_operand (operands[1], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_DImode
          || !
#line 6105 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2932; /* neon_vld4_dupdi */

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      if (!vpr_register_operand (operands[0], E_V16BImode)
          || GET_MODE (x3) != E_V16BImode
          || !vpr_register_operand (operands[2], E_V16BImode)
          || !
#line 1256 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3774; /* mve_vctp8q_mv16bi */

    case E_V8BImode:
      if (!vpr_register_operand (operands[0], E_V8BImode)
          || GET_MODE (x3) != E_V8BImode
          || !vpr_register_operand (operands[2], E_V8BImode)
          || !
#line 1256 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3775; /* mve_vctp16q_mv8bi */

    case E_V4BImode:
      if (!vpr_register_operand (operands[0], E_V4BImode)
          || GET_MODE (x3) != E_V4BImode
          || !vpr_register_operand (operands[2], E_V4BImode)
          || !
#line 1256 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3776; /* mve_vctp32q_mv4bi */

    case E_V2QImode:
      if (!vpr_register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !vpr_register_operand (operands[2], E_V2QImode)
          || !
#line 1256 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3777; /* mve_vctp64q_mv2qi */

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern162 (x1, 
E_EImode) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_BLKmode:
      if (!neon_struct_operand (operands[1], E_BLKmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5773 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2858; /* neon_vld3_dupv8qi */

        case E_V4HImode:
          if (!
#line 5773 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2859; /* neon_vld3_dupv4hi */

        case E_V4HFmode:
          if (!
#line 5773 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2860; /* neon_vld3_dupv4hf */

        case E_V4BFmode:
          if (!(
#line 5773 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2861; /* neon_vld3_dupv4bf */

        case E_V2SImode:
          if (!
#line 5773 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2862; /* neon_vld3_dupv2si */

        case E_V2SFmode:
          if (!
#line 5773 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2863; /* neon_vld3_dupv2sf */

        default:
          return -1;
        }

    case E_EImode:
      if (!neon_struct_operand (operands[1], E_EImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_DImode
          || !
#line 5773 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2864; /* neon_vld3_dupdi */

    default:
      return -1;
    }
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0
          || !
#line 1351 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1435; /* neon_vpadd_internalv8qi */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0
          || !
#line 1351 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1436; /* neon_vpadd_internalv4hi */

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0
          || !
#line 1351 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1437; /* neon_vpadd_internalv2si */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 1351 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1438; /* neon_vpadd_internalv2sf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 1366 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1439; /* neon_vpaddv4hf */

    default:
      return -1;
    }
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2342; /* neon_vrshru_nv8qi */

    case 1:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2346; /* neon_vrshru_nv16qi */

    case 2:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2350; /* neon_vrshru_nv4hi */

    case 3:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2354; /* neon_vrshru_nv8hi */

    case 4:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2358; /* neon_vrshru_nv2si */

    case 5:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2362; /* neon_vrshru_nv4si */

    case 6:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2366; /* neon_vrshru_ndi */

    case 7:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2370; /* neon_vrshru_nv2di */

    default:
      return -1;
    }
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2276; /* neon_vshluv8qi */

    case 1:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2280; /* neon_vshluv16qi */

    case 2:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2284; /* neon_vshluv4hi */

    case 3:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2288; /* neon_vshluv8hi */

    case 4:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2292; /* neon_vshluv2si */

    case 5:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2296; /* neon_vshluv4si */

    case 6:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2300; /* neon_vshludi */

    case 7:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2304; /* neon_vshluv2di */

    default:
      return -1;
    }
}

 int
recog_185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 1600 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1508; /* neon_vqaddsv8qi */

    case 1:
      if (!
#line 1600 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1510; /* neon_vqaddsv16qi */

    case 2:
      if (!
#line 1600 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1512; /* neon_vqaddsv4hi */

    case 3:
      if (!
#line 1600 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1514; /* neon_vqaddsv8hi */

    case 4:
      if (!
#line 1600 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1516; /* neon_vqaddsv2si */

    case 5:
      if (!
#line 1600 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1518; /* neon_vqaddsv4si */

    case 6:
      if (!
#line 1600 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1520; /* neon_vqaddsdi */

    case 7:
      if (!
#line 1600 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1522; /* neon_vqaddsv2di */

    default:
      return -1;
    }
}

 int
recog_196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern131 (x1))
    {
    case 0:
      if (!
#line 939 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1383; /* ashlv8qi3_signed */

    case 1:
      if (!
#line 939 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1384; /* ashlv16qi3_signed */

    case 2:
      if (!
#line 939 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1385; /* ashlv4hi3_signed */

    case 3:
      if (!
#line 939 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1386; /* ashlv8hi3_signed */

    case 4:
      if (!
#line 939 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1387; /* ashlv2si3_signed */

    case 5:
      if (!
#line 939 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1388; /* ashlv4si3_signed */

    case 6:
      if (!
#line 939 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1389; /* ashlv2di3_signed */

    default:
      return -1;
    }
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern147 (x1))
    {
    case 0:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1881; /* neon_vpadalsv8qi */

    case 1:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1883; /* neon_vpadalsv16qi */

    case 2:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1885; /* neon_vpadalsv4hi */

    case 3:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1887; /* neon_vpadalsv8hi */

    case 4:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1889; /* neon_vpadalsv2si */

    case 5:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1891; /* neon_vpadalsv4si */

    default:
      return -1;
    }
}

 int
recog_217 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1486; /* neon_vhaddsv8qi */

    case 1:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1490; /* neon_vhaddsv16qi */

    case 2:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1494; /* neon_vhaddsv4hi */

    case 3:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1498; /* neon_vhaddsv8hi */

    case 4:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1502; /* neon_vhaddsv2si */

    case 5:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1506; /* neon_vhaddsv4si */

    default:
      return -1;
    }
}

 int
recog_228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 2516 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1759; /* neon_vcalev2sf_insn_unspec */

    case 1:
      if (!
#line 2516 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1763; /* neon_vcalev4sf_insn_unspec */

    case 2:
      if (!
#line 2557 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1775; /* neon_vcalev8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2557 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1779; /* neon_vcalev4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern132 (x1))
    {
    case 0:
      if (!
#line 1389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1444; /* neon_vpsmaxv8qi */

    case 1:
      if (!
#line 1389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1445; /* neon_vpsmaxv4hi */

    case 2:
      if (!
#line 1389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1446; /* neon_vpsmaxv2si */

    case 3:
      if (!
#line 1389 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1447; /* neon_vpsmaxv2sf */

    default:
      return -1;
    }
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern232 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4891; /* mve_vldrq_gather_offset_z_v16qi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4892; /* mve_vldrq_gather_offset_z_v8hi */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4893; /* mve_vldrq_gather_offset_z_v4si */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8HFmode) != 0
          || !
#line 3480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4894; /* mve_vldrq_gather_offset_z_v8hf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V4BImode, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 3480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4895; /* mve_vldrq_gather_offset_z_v4sf */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4896; /* mve_vldrq_gather_offset_z_v2di */

    default:
      return -1;
    }
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_ccde2_operand (operands[4], E_SImode))
    return -1;
  switch (pattern426 (x3))
    {
    case 0:
      if (!
#line 4562 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 145; /* arm_cx2asi */

    case 1:
      if (!
#line 4562 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 146; /* arm_cx2adi */

    default:
      return -1;
    }
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != NEG
          || GET_MODE (x7) != E_SImode)
        return -1;
      operands[0] = x5;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      x10 = XEXP (x9, 0);
      operands[3] = x10;
      if (!
#line 1308 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 977; /* *negated_cbranchsi4 */

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x5;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      x10 = XEXP (x9, 0);
      operands[3] = x10;
      if (XWINT (x11, 0) == 1L)
        {
          x13 = XEXP (x6, 2);
          operands[2] = x13;
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 1347 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 978; /* *tbit_cbranch */
            }
        }
      x13 = XEXP (x6, 2);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 1392 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      *pnum_clobbers = 1;
      return 979; /* *tlobits_cbranch */

    case AND:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[3] = x5;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x6, 1);
      operands[1] = x11;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!
#line 1435 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 980; /* *tstsi3_cbranch */

    default:
      return -1;
    }
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!arm_general_register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 2);
  operands[3] = x5;
  if (!reg_or_zero_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (x4))
    {
    case NOT:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 966 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_COND_ARITH))
        return -1;
      return 1040; /* *thumb2_csinv */

    case PLUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 981 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_COND_ARITH))
        return -1;
      return 1041; /* *thumb2_csinc */

    case NEG:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 995 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_COND_ARITH))
        return -1;
      return 1042; /* *thumb2_csneg */

    default:
      return -1;
    }
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      res = recog_269 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (arm_comparison_operator (x3, E_VOIDmode))
    {
      res = recog_274 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x3;
  if (arm_comparison_operation (operands[1], E_VOIDmode))
    {
      res = recog_275 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_276 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL
      && pattern269 (x1) == 0
      && 
#line 10807 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
    {
      *pnum_clobbers = 1;
      return 351; /* movcond */
    }
  operands[3] = x3;
  if (arm_comparison_operator (operands[3], E_VOIDmode))
    {
      res = recog_277 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL
      && pattern269 (x1) == 0
      && 
#line 1012 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
    {
      *pnum_clobbers = 1;
      return 1043; /* *thumb2_movcond */
    }
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  operands[0] = x3;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (s_register_operand (operands[1], E_SImode))
    {
      if (equality_operator (operands[0], E_VOIDmode)
          && x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (
#line 1108 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && TARGET_HAVE_CBZ))
            return 974; /* thumb1_cbz */
        }
      if (arm_comparison_operator (operands[0], E_VOIDmode))
        {
          operands[2] = x4;
          if (thumb1_cmp_operand (operands[2], E_SImode))
            {
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (
#line 1191 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return 975; /* cbranchsi4_insn */
            }
        }
    }
  if (pnum_clobbers == NULL
      || !s_register_operand (x8, E_SImode))
    return -1;
  operands[1] = x8;
  operands[4] = x3;
  if (arm_comparison_operator (operands[4], E_VOIDmode))
    {
      operands[2] = x4;
      if (thumb1_cmpneg_operand (operands[2], E_SImode))
        {
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (
#line 1271 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 976; /* cbranchsi4_scratch */
            }
        }
    }
  operands[0] = x8;
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  switch (GET_CODE (x3))
    {
    case EQ:
      if (!
#line 1467 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1064; /* *thumb2_cbz */

    case NE:
      if (!
#line 1491 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1065; /* *thumb2_cbnz */

    default:
      return -1;
    }
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 378:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1936; /* neon_vcmla0v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1940; /* neon_vcmla0v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4229; /* mve_vcmlaq_fv8hf */

            case 2:
              if (!
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1944; /* neon_vcmla0v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1948; /* neon_vcmla0v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4233; /* mve_vcmlaq_fv4sf */

            default:
              return -1;
            }

        case 379:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1937; /* neon_vcmla90v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1941; /* neon_vcmla90v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4230; /* mve_vcmlaq_rot90_fv8hf */

            case 2:
              if (!
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1945; /* neon_vcmla90v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1949; /* neon_vcmla90v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4234; /* mve_vcmlaq_rot90_fv4sf */

            default:
              return -1;
            }

        case 380:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1938; /* neon_vcmla180v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1942; /* neon_vcmla180v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4231; /* mve_vcmlaq_rot180_fv8hf */

            case 2:
              if (!
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1946; /* neon_vcmla180v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1950; /* neon_vcmla180v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4235; /* mve_vcmlaq_rot180_fv4sf */

            default:
              return -1;
            }

        case 381:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1939; /* neon_vcmla270v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1943; /* neon_vcmla270v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4232; /* mve_vcmlaq_rot270_fv8hf */

            case 2:
              if (!
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1947; /* neon_vcmla270v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2891 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1951; /* neon_vcmla270v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4236; /* mve_vcmlaq_rot270_fv4sf */

            default:
              return -1;
            }

        case 370:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern484 (x2, 
E_V4BFmode, 
E_V2SFmode) != 0
                  || !
#line 6635 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                return -1;
              return 3023; /* neon_vbfdotv2sf */

            case E_V4SFmode:
              if (pattern484 (x2, 
E_V8BFmode, 
E_V4SFmode) != 0
                  || !
#line 6635 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                return -1;
              return 3024; /* neon_vbfdotv4sf */

            default:
              return -1;
            }

        case 394:
          if (pattern464 (x2) != 0
              || !
#line 6759 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3038; /* neon_vmmlav8bf */

        case 395:
          if (pattern464 (x2) != 0
              || !
#line 6770 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3039; /* neon_vfmabv8bf */

        case 396:
          if (pattern464 (x2) != 0
              || !
#line 6770 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3040; /* neon_vfmatv8bf */

        default:
          return -1;
        }

    case 3:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      switch (XINT (x3, 1))
        {
        case 378:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1952; /* neon_vcmla_lane0v4hf */

            case 1:
              if (!
#line 2918 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1972; /* neon_vcmla_laneq0v4hf */

            case 2:
              if (!(
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1956; /* neon_vcmla_lane0v8hf */

            case 3:
              if (!
#line 2933 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1976; /* neon_vcmlaq_lane0v8hf */

            case 4:
              if (!
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1960; /* neon_vcmla_lane0v2sf */

            case 5:
              if (!
#line 2918 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1968; /* neon_vcmla_laneq0v2sf */

            case 6:
              if (!
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1964; /* neon_vcmla_lane0v4sf */

            case 7:
              if (!
#line 2933 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1980; /* neon_vcmlaq_lane0v4sf */

            default:
              return -1;
            }

        case 379:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1953; /* neon_vcmla_lane90v4hf */

            case 1:
              if (!
#line 2918 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1973; /* neon_vcmla_laneq90v4hf */

            case 2:
              if (!(
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1957; /* neon_vcmla_lane90v8hf */

            case 3:
              if (!
#line 2933 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1977; /* neon_vcmlaq_lane90v8hf */

            case 4:
              if (!
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1961; /* neon_vcmla_lane90v2sf */

            case 5:
              if (!
#line 2918 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1969; /* neon_vcmla_laneq90v2sf */

            case 6:
              if (!
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1965; /* neon_vcmla_lane90v4sf */

            case 7:
              if (!
#line 2933 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1981; /* neon_vcmlaq_lane90v4sf */

            default:
              return -1;
            }

        case 380:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1954; /* neon_vcmla_lane180v4hf */

            case 1:
              if (!
#line 2918 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1974; /* neon_vcmla_laneq180v4hf */

            case 2:
              if (!(
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1958; /* neon_vcmla_lane180v8hf */

            case 3:
              if (!
#line 2933 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1978; /* neon_vcmlaq_lane180v8hf */

            case 4:
              if (!
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1962; /* neon_vcmla_lane180v2sf */

            case 5:
              if (!
#line 2918 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1970; /* neon_vcmla_laneq180v2sf */

            case 6:
              if (!
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1966; /* neon_vcmla_lane180v4sf */

            case 7:
              if (!
#line 2933 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1982; /* neon_vcmlaq_lane180v4sf */

            default:
              return -1;
            }

        case 381:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1955; /* neon_vcmla_lane270v4hf */

            case 1:
              if (!
#line 2918 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1975; /* neon_vcmla_laneq270v4hf */

            case 2:
              if (!(
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1959; /* neon_vcmla_lane270v8hf */

            case 3:
              if (!
#line 2933 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1979; /* neon_vcmlaq_lane270v8hf */

            case 4:
              if (!
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1963; /* neon_vcmla_lane270v2sf */

            case 5:
              if (!
#line 2918 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1971; /* neon_vcmla_laneq270v2sf */

            case 6:
              if (!
#line 2903 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1967; /* neon_vcmla_lane270v4sf */

            case 7:
              if (!
#line 2933 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1983; /* neon_vcmlaq_lane270v4sf */

            default:
              return -1;
            }

        case 370:
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              switch (pattern534 (x2, 
E_V4BFmode, 
E_V2SFmode))
                {
                case 0:
                  if (!
#line 6648 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3025; /* neon_vbfdot_lanev4bfv2sf */

                case 1:
                  if (!
#line 6661 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3027; /* neon_vbfdot_lanev8bfv2sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern534 (x2, 
E_V8BFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!
#line 6648 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3026; /* neon_vbfdot_lanev4bfv4sf */

                case 1:
                  if (!
#line 6661 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3028; /* neon_vbfdot_lanev8bfv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 395:
          if (pattern486 (x2) != 0
              || !
#line 6782 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3041; /* neon_vfmab_lanev8bf */

        case 396:
          if (pattern486 (x2) != 0
              || !
#line 6782 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3042; /* neon_vfmat_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !
#line 66 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 942; /* *thumb1_addsi3 */

    case MINUS:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!reg_or_int_operand (operands[2], E_SImode)
          || !
#line 146 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 944; /* thumb1_subsi3_insn */

    case AND:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 192 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 947; /* *thumb1_andsi3_insn */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!arm_comparison_operator (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          if (!s_register_operand (operands[3], E_SImode)
              || !
#line 618 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          return 1032; /* *thumb2_and_scc */

        default:
          return -1;
        }

    case IOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 250 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 949; /* *thumb1_iorsi3_insn */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!arm_comparison_operator (x3, E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          if (!cc_register (x6, E_VOIDmode))
            return -1;
          operands[2] = x6;
          operands[1] = x3;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          if (s_register_operand (operands[3], E_SImode)
              && 
#line 646 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it))
            return 1033; /* *thumb2_ior_scc */
          operands[3] = x6;
          operands[2] = x3;
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 677 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it))
            return -1;
          return 1034; /* *thumb2_ior_scc_strict_it */

        default:
          return -1;
        }

    case XOR:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 264 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 950; /* *thumb1_xorsi3_insn */

    default:
      return -1;
    }
}

 int
recog_295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  if (register_operand (operands[0], E_SImode))
    {
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (register_operand (operands[1], E_V8QImode)
              && 
#line 725 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 588; /* iwmmxt_textrmub */
          break;

        case E_HImode:
          if (register_operand (operands[1], E_V4HImode)
              && 
#line 747 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 590; /* iwmmxt_textrmuh */
          break;

        default:
          break;
        }
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  switch (pattern469 (x3))
    {
    case 0:
      if (!
#line 3241 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2040; /* neon_vget_lanev8qi_zext_internal */

    case 1:
      if (
#line 3287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2049; /* neon_vget_lanev16qi_zext_internal */
      if (!
#line 4212 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))))
        return -1;
      return 5016; /* *mve_vec_extract_zext_internalv16qi */

    case 2:
      if (!
#line 3241 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2041; /* neon_vget_lanev4hi_zext_internal */

    case 3:
      if (
#line 3287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2050; /* neon_vget_lanev8hi_zext_internal */
      if (!
#line 4212 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 5017; /* *mve_vec_extract_zext_internalv8hi */

    case 4:
      if (!
#line 3241 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2042; /* neon_vget_lanev2si_zext_internal */

    case 5:
      if (
#line 3287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2052; /* neon_vget_lanev4si_zext_internal */
      if (!
#line 4212 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
        return -1;
      return 5018; /* *mve_vec_extract_zext_internalv4si */

    case 6:
      if (!
#line 3241 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2043; /* neon_vget_lanev2sf_zext_internal */

    case 7:
      if (!
#line 3287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2053; /* neon_vget_lanev4sf_zext_internal */

    case 8:
      if (!
#line 3287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2051; /* neon_vget_lanev8hf_zext_internal */

    default:
      return -1;
    }
}

 int
recog_298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFTRT
      || GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_TImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V16QImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != MULT
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != ZERO_EXTRACT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x9 = XEXP (x7, 2);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x6, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
      || !register_operand (operands[0], E_V8QImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x12 = XEXP (x5, 1);
  operands[2] = x12;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x13 = XEXP (x7, 0);
  operands[3] = x13;
  if (register_operand (operands[3], E_SImode)
      && 
#line 1656 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
    return 678; /* iwmmxt_walignr */
  if (GET_CODE (x13) != REG
      || GET_MODE (x13) != E_SImode)
    return -1;
  switch (REGNO (x13))
    {
    case 96:
      if (!
#line 1671 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 679; /* iwmmxt_walignr0 */

    case 97:
      if (!
#line 1686 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 680; /* iwmmxt_walignr1 */

    case 98:
      if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 681; /* iwmmxt_walignr2 */

    case 99:
      if (!
#line 1716 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 682; /* iwmmxt_walignr3 */

    default:
      return -1;
    }
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == ZERO_EXTRACT
          && GET_MODE (x3) == E_SImode)
        {
          x4 = XEXP (x3, 0);
          operands[0] = x4;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (XWINT (x2, 0) == 0L)
                {
                  x5 = XEXP (x3, 1);
                  operands[1] = x5;
                  if (const_int_M_operand (operands[1], E_SImode))
                    {
                      x6 = XEXP (x3, 2);
                      operands[2] = x6;
                      if (const_int_M_operand (operands[2], E_SImode)
                          && 
#line 3500 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_arch_thumb2))
                        return 98; /* insv_zero */
                    }
                }
              x5 = XEXP (x3, 1);
              if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 16])
                {
                  x6 = XEXP (x3, 2);
                  if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    {
                      operands[1] = x2;
                      if (const_int_operand (operands[1], E_SImode)
                          && 
#line 12371 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_HAVE_MOVT))
                        return 410; /* *arm_movtas_ze */
                    }
                }
            }
        }
      break;

    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTRACT:
          if (pattern247 (x3) == 0)
            {
              operands[3] = x2;
              if (s_register_operand (operands[3], E_SImode)
                  && 
#line 3524 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_arch_thumb2))
                return 99; /* insv_t2 */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x3;
          if (nonimmediate_soft_df_operand (operands[0], E_DFmode))
            {
              operands[1] = x2;
              if (soft_df_operand (operands[1], E_DFmode)
                  && 
#line 7627 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
                return 271; /* *movdf_soft_insn */
            }
          break;

        case PC:
          operands[0] = x2;
          if (s_register_operand (operands[0], E_SImode)
              && 
#line 9629 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 315; /* *arm_indirect_jump */
          if (memory_operand (operands[0], E_SImode)
              && 
#line 9638 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 316; /* *load_indirect_jump */
          if (register_operand (operands[0], E_SImode))
            {
              if (
#line 2018 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return 1000; /* *thumb1_indirect_jump */
              if (
#line 604 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1031; /* *thumb2_indirect_jump */
            }
          break;

        default:
          break;
        }
      break;

    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (
#line 8591 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 288; /* *arm_jump */
          if (
#line 1845 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 990; /* *thumb_jump */
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_di_operand (operands[0], E_DImode)
          && di_operand (operands[1], E_DImode)
          && 
#line 6345 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !(TARGET_HARD_FLOAT)
   && !(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT)
   && !TARGET_IWMMXT
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
        return 255; /* *arm_movdi */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && general_operand (operands[1], E_SImode)
          && 
#line 6557 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
        return 257; /* *arm_movsi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && 
#line 7212 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM
   && arm_arch4 && !TARGET_HARD_FLOAT
   && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
        return 265; /* *movhi_insn_arch4 */
      if (s_register_operand (operands[0], E_HImode)
          && arm_rhs_operand (operands[1], E_HImode)
          && 
#line 7239 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_HARD_FLOAT))
        return 266; /* *movhi_bytes */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 7356 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (   register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode))))
        return 267; /* *arm_movqi_insn */
      break;

    case E_HFmode:
      if (nonimmediate_operand (operands[0], E_HFmode)
          && general_operand (operands[1], E_HFmode)
          && 
#line 7403 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
        return 268; /* *arm32_movhf */
      break;

    case E_BFmode:
      if (nonimmediate_operand (operands[0], E_BFmode)
          && general_operand (operands[1], E_BFmode)
          && 
#line 7403 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
        return 269; /* *arm32_movbf */
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && general_operand (operands[1], E_SFmode)
          && 
#line 7502 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE
   && (!MEM_P (operands[0])
       || register_operand (operands[1], SFmode))))
        return 270; /* *arm_movsf_soft_insn */
      break;

    default:
      break;
    }
  operands[0] = x3;
  if (cc_register (operands[0], E_VOIDmode)
      && rtx_equal_p (x2, operands[0])
      && 
#line 7942 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return 276; /* *deleted_compare */
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_di_operand (operands[0], E_DImode)
          && di_operand (operands[1], E_DImode))
        {
          if (
#line 103 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
            return 537; /* *iwmmxt_arm_movdi */
          if (
#line 344 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_VFP_BASE
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))
   && !((TARGET_NEON || TARGET_HAVE_MVE) && CONST_INT_P (operands[1])
       && simd_immediate_valid_for_move (operands[1], DImode, NULL, NULL))))
            return 767; /* *movdi_vfp */
        }
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && general_operand (operands[1], E_V2SImode)
          && 
#line 229 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 540; /* movv2si_internal */
      break;

    case E_V4HImode:
      if (nonimmediate_operand (operands[0], E_V4HImode)
          && general_operand (operands[1], E_V4HImode)
          && 
#line 229 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 541; /* movv4hi_internal */
      break;

    case E_V8QImode:
      if (nonimmediate_operand (operands[0], E_V8QImode)
          && general_operand (operands[1], E_V8QImode)
          && 
#line 229 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 542; /* movv8qi_internal */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode))
        {
          if (
#line 29 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 753; /* *arm_movhi_vfp */
          if (
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 754; /* *thumb2_movhi_vfp */
          if (
#line 135 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 759; /* *arm_movhi_fp16 */
          if (
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 760; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V16BImode:
      if (nonimmediate_operand (operands[0], E_V16BImode)
          && general_operand (operands[1], E_V16BImode))
        {
          if (
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))))
            return 755; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))))
            return 761; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V8BImode:
      if (nonimmediate_operand (operands[0], E_V8BImode)
          && general_operand (operands[1], E_V8BImode))
        {
          if (
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))))
            return 756; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))))
            return 762; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V4BImode:
      if (nonimmediate_operand (operands[0], E_V4BImode)
          && general_operand (operands[1], E_V4BImode))
        {
          if (
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode))))
            return 757; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode))))
            return 763; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V2QImode:
      if (nonimmediate_operand (operands[0], E_V2QImode)
          && general_operand (operands[1], E_V2QImode))
        {
          if (
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))))
            return 758; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))))
            return 764; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_HFmode:
      if (nonimmediate_operand (operands[0], E_HFmode)
          && general_operand (operands[1], E_HFmode))
        {
          if (
#line 407 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
            return 768; /* *movhf_vfp_hf16 */
          if (
#line 488 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT && TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
            return 770; /* *movhf_vfp_neon */
          if (
#line 544 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT
   && !TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
            return 772; /* *movhf_vfp */
        }
      break;

    case E_BFmode:
      if (nonimmediate_operand (operands[0], E_BFmode)
          && general_operand (operands[1], E_BFmode))
        {
          if (
#line 407 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
            return 769; /* *movbf_vfp_bf16 */
          if (
#line 488 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT && TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
            return 771; /* *movbf_vfp_neon */
          if (
#line 544 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT
   && !TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
            return 773; /* *movbf_vfp */
        }
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode))
        {
          if (general_operand (operands[1], E_SFmode)
              && 
#line 600 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode))))
            return 774; /* *movsf_vfp */
          if (hard_sf_operand (operands[1], E_SFmode)
              && 
#line 636 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode))))
            return 775; /* *thumb2_movsf_vfp */
        }
      break;

    case E_DFmode:
      if (nonimmediate_soft_df_operand (operands[0], E_DFmode))
        {
          if (soft_df_operand (operands[1], E_DFmode)
              && 
#line 674 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
            return 776; /* *movdf_vfp */
          if (hard_df_operand (operands[1], E_DFmode)
              && 
#line 725 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
            return 777; /* *thumb2_movdf_vfp */
        }
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case MEM:
      if (pattern248 (x2, 
8) == 0
          && register_operand (operands[0], E_SImode))
        {
          x7 = XEXP (x2, 0);
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          if (register_operand (operands[1], E_SImode))
            {
              x9 = XVECEXP (x7, 0, 2);
              operands[2] = x9;
              if (
#line 6771 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 263; /* tls_load_dot_plus_eight */
            }
        }
      break;

    case CONST_VECTOR:
      res = recog_297 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SUBREG:
      res = recog_298 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (nonimmediate_operand (operands[0], E_SImode))
    {
      operands[1] = x2;
      if (general_operand (operands[1], E_SImode))
        {
          if (
#line 158 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
            return 538; /* *iwmmxt_movsi_insn */
          if (
#line 238 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode))))
            return 765; /* *arm_movsi_vfp */
          if (
#line 283 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode))))
            return 766; /* *thumb2_movsi_vfp */
        }
    }
  if (GET_CODE (x2) == REG
      && REGNO (x2) == 101
      && GET_CODE (x3) == REG
      && REGNO (x3) == 100
      && 
#line 1637 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
    return 855; /* *movcc_vfp */
  operands[1] = x2;
  res = recog_299 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  if (GET_MODE (x2) == E_SImode)
    {
      switch (GET_CODE (x2))
        {
        case REG:
          if (REGNO (x2) == 15
              && s_register_operand (operands[0], E_SImode)
              && 
#line 2075 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 1003; /* *thumb1_movpc_insn */
          break;

        case MEM:
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) == POST_INC
              && GET_MODE (x7) == E_SImode)
            {
              x10 = XEXP (x7, 0);
              if (GET_CODE (x10) == REG
                  && REGNO (x10) == 13
                  && GET_MODE (x10) == E_SImode
                  && low_register_operand (operands[0], E_SImode)
                  && 
#line 223 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && (reload_in_progress || reload_completed)))
                return 1013; /* *thumb2_pop_single */
            }
          break;

        default:
          break;
        }
    }
  operands[1] = x2;
  if (general_operand (operands[1], E_SImode)
      && nonimmediate_operand (operands[0], E_SImode)
      && 
#line 238 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
    return 1014; /* *thumb2_movsi_insn */
  if (pnum_clobbers != NULL
      && const_int_operand (operands[1], E_SImode)
      && low_register_operand (operands[0], E_SImode)
      && 
#line 1289 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
    {
      *pnum_clobbers = 1;
      return 1056; /* *thumb2_movsi_shortim */
    }
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], E_SImode)
      || GET_CODE (x2) != MEM
      || pattern248 (x2, 
4) != 0)
    return -1;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x7, 0, 2);
  operands[3] = x9;
  if (!
#line 274 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  *pnum_clobbers = 1;
  return 1015; /* tls_load_dot_plus_four */
}

 int
recog_308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case NE:
      res = recog_266 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case EQ:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3400; /* mve_vcmpeqq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3408; /* mve_vcmpeqq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3750; /* mve_vcmpeqq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3416; /* mve_vcmpeqq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3756; /* mve_vcmpeqq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3424; /* mve_vcmpeqq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3432; /* mve_vcmpeqq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3762; /* mve_vcmpeqq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3440; /* mve_vcmpeqq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3768; /* mve_vcmpeqq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case GE:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3401; /* mve_vcmpgeq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3409; /* mve_vcmpgeq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3751; /* mve_vcmpgeq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3417; /* mve_vcmpgeq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3757; /* mve_vcmpgeq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3425; /* mve_vcmpgeq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3433; /* mve_vcmpgeq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3763; /* mve_vcmpgeq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3441; /* mve_vcmpgeq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3769; /* mve_vcmpgeq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case GEU:
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3402; /* mve_vcmpcsq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3410; /* mve_vcmpcsq_v8hi */
          break;

        case 2:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3418; /* mve_vcmpcsq_v4si */
          break;

        case 3:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3426; /* mve_vcmpcsq_n_v16qi */
          break;

        case 4:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3434; /* mve_vcmpcsq_n_v8hi */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3442; /* mve_vcmpcsq_n_v4si */
          break;

        default:
          break;
        }
      break;

    case GT:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3403; /* mve_vcmpgtq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3411; /* mve_vcmpgtq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3752; /* mve_vcmpgtq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3419; /* mve_vcmpgtq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3758; /* mve_vcmpgtq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3427; /* mve_vcmpgtq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3435; /* mve_vcmpgtq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3764; /* mve_vcmpgtq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3443; /* mve_vcmpgtq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3770; /* mve_vcmpgtq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case GTU:
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3404; /* mve_vcmphiq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3412; /* mve_vcmphiq_v8hi */
          break;

        case 2:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3420; /* mve_vcmphiq_v4si */
          break;

        case 3:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3428; /* mve_vcmphiq_n_v16qi */
          break;

        case 4:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3436; /* mve_vcmphiq_n_v8hi */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3444; /* mve_vcmphiq_n_v4si */
          break;

        default:
          break;
        }
      break;

    case LE:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3405; /* mve_vcmpleq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3413; /* mve_vcmpleq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3753; /* mve_vcmpleq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3421; /* mve_vcmpleq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3759; /* mve_vcmpleq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3429; /* mve_vcmpleq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3437; /* mve_vcmpleq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3765; /* mve_vcmpleq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3445; /* mve_vcmpleq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3771; /* mve_vcmpleq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case LT:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3406; /* mve_vcmpltq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3414; /* mve_vcmpltq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3754; /* mve_vcmpltq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3422; /* mve_vcmpltq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3760; /* mve_vcmpltq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3430; /* mve_vcmpltq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3438; /* mve_vcmpltq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3766; /* mve_vcmpltq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3446; /* mve_vcmpltq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3772; /* mve_vcmpltq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  operands[1] = x3;
  if (arm_comparison_operator_mode (operands[1], E_SImode))
    {
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (cc_register (operands[2], E_VOIDmode)
              && 
#line 8092 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 279; /* *mov_scc */
        }
    }
  if (pnum_clobbers != NULL
      && arm_comparison_operator (operands[1], E_SImode))
    {
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (s_register_operand (operands[2], E_SImode))
        {
          x4 = XEXP (x3, 1);
          operands[3] = x4;
          if (arm_add_operand (operands[3], E_SImode)
              && 
#line 9952 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            {
              *pnum_clobbers = 1;
              return 336; /* *compare_scc */
            }
        }
    }
  if (GET_CODE (x3) == LTU
      && GET_MODE (x3) == E_SImode)
    {
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (s_register_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (thumb1_cmp_operand (operands[2], E_SImode)
              && 
#line 1789 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 988; /* cstoresi_ltu_thumb1 */
        }
    }
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  operands[1] = x3;
  if (!arm_comparison_operator_mode (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!cc_register (operands[2], E_VOIDmode)
      || !
#line 326 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  return 1018; /* *thumb2_mov_scc */
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      return recog_263 (x1, insn, pnum_clobbers);

    case 1:
      return recog_265 (x1, insn, pnum_clobbers);

    case 2:
      return recog_262 (x1, insn, pnum_clobbers);

    case 4:
      return recog_264 (x1, insn, pnum_clobbers);

    case 5:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (XINT (x2, 1))
        {
        case 103:
          if (!const_int_coproc_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x7 = XVECEXP (x2, 0, 3);
          operands[4] = x7;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x8 = XVECEXP (x2, 0, 4);
          operands[5] = x8;
          if (!const_int_ccde3_operand (operands[5], E_SImode))
            return -1;
          switch (pattern426 (x2))
            {
            case 0:
              if (!
#line 4587 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
                return -1;
              return 149; /* arm_cx3asi */

            case 1:
              if (!
#line 4587 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
                return -1;
              return 150; /* arm_cx3adi */

            default:
              return -1;
            }

        case 115:
          switch (pattern302 (x2))
            {
            case 0:
              if (!
#line 446 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 716; /* iwmmxt_wqmiabb */

            case 1:
              if (!
#line 459 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 717; /* iwmmxt_wqmiabt */

            case 2:
              if (!
#line 472 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 718; /* iwmmxt_wqmiatb */

            case 3:
              if (!
#line 485 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 719; /* iwmmxt_wqmiatt */

            default:
              return -1;
            }

        case 114:
          switch (pattern302 (x2))
            {
            case 0:
              if (!
#line 498 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 720; /* iwmmxt_wqmiabbn */

            case 1:
              if (!
#line 511 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 721; /* iwmmxt_wqmiabtn */

            case 2:
              if (!
#line 524 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 722; /* iwmmxt_wqmiatbn */

            case 3:
              if (!
#line 537 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 723; /* iwmmxt_wqmiattn */

            default:
              return -1;
            }

        case 105:
          if (!const_int_coproc_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          x7 = XVECEXP (x2, 0, 3);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 4);
          operands[5] = x8;
          switch (GET_CODE (operands[4]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern512 (x2, 
E_SImode) != 0
                      || !
#line 2251 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
                    return -1;
                  return 939; /* arm_vcx3asi */

                case E_DImode:
                  if (pattern512 (x2, 
E_DImode) != 0
                      || !
#line 2251 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
                    return -1;
                  return 940; /* arm_vcx3adi */

                case E_V16QImode:
                  if (pattern482 (x2) != 0
                      || !register_operand (operands[4], E_V16QImode)
                      || !const_int_mve_cde3_operand (operands[5], E_SImode)
                      || !
#line 4500 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
                    return -1;
                  return 5050; /* arm_vcx3qav16qi */

                default:
                  return -1;
                }

            case CONST_INT:
              if (!const_int_mve_cde2_operand (operands[4], E_SImode)
                  || pattern482 (x2) != 0
                  || !vpr_register_operand (operands[5], E_V16BImode)
                  || !
#line 4528 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
                return -1;
              return 5054; /* arm_vcx2qa_p_v16qi */

            default:
              return -1;
            }

        case 104:
          if (GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[0], E_V16QImode)
              || !const_int_coproc_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          x7 = XVECEXP (x2, 0, 3);
          operands[4] = x7;
          if (!const_int_mve_cde2_operand (operands[4], E_SImode))
            return -1;
          x8 = XVECEXP (x2, 0, 4);
          operands[5] = x8;
          if (!vpr_register_operand (operands[5], E_V16BImode)
              || !
#line 4528 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
            return -1;
          return 5053; /* arm_vcx2q_p_v16qi */

        default:
          return -1;
        }

    case 6:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_int_coproc_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!register_operand (operands[4], E_V16QImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      if (!const_int_mve_cde3_operand (operands[5], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[6] = x9;
      if (!vpr_register_operand (operands[6], E_V16BImode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 104:
          if (!
#line 4544 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
            return -1;
          return 5055; /* arm_vcx3q_p_v16qi */

        case 105:
          if (!
#line 4544 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
            return -1;
          return 5056; /* arm_vcx3qa_p_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode))
        return -1;
      if (
#line 208 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
        return 539; /* *cond_iwmmxt_movsi_insn */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6557 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode)))))
        return -1;
      return 6566; /* *p *arm_movsi_insn */

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7212 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM
   && arm_arch4 && !TARGET_HARD_FLOAT
   && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6569; /* *p *movhi_insn_arch4 */
      if (s_register_operand (operands[0], E_HImode)
          && arm_rhs_operand (operands[1], E_HImode)
          && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7239 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_HARD_FLOAT)))
        return 6570; /* *p *movhi_bytes */
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 29 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6891; /* *p *arm_movhi_vfp */
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6892; /* *p *thumb2_movhi_vfp */
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6897; /* *p *arm_movhi_fp16 */
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6898; /* *p *thumb2_movhi_fp16 */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 289 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
  && (register_operand (operands[0], HImode)
     || register_operand (operands[1], HImode)))))
        return -1;
      return 6982; /* *p *thumb2_movhi_insn */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7356 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (   register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode)))))
        return -1;
      return 6571; /* *p *arm_movqi_insn */

    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !general_operand (operands[1], E_HFmode))
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7403 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode)))))
        return 6572; /* *p *arm32_movhf */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 407 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode)))))
        return -1;
      return 6906; /* *p *movhf_vfp_hf16 */

    case E_BFmode:
      if (!nonimmediate_operand (operands[0], E_BFmode)
          || !general_operand (operands[1], E_BFmode))
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7403 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode)))))
        return 6573; /* *p *arm32_movbf */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 407 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode)))))
        return -1;
      return 6907; /* *p *movbf_vfp_bf16 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode))
        return -1;
      if (general_operand (operands[1], E_SFmode))
        {
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7502 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE
   && (!MEM_P (operands[0])
       || register_operand (operands[1], SFmode)))))
            return 6574; /* *p *arm_movsf_soft_insn */
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 600 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode)))))
            return 6908; /* *p *movsf_vfp */
        }
      if (!hard_sf_operand (operands[1], E_SFmode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 636 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode)))))
        return -1;
      return 6909; /* *p *thumb2_movsf_vfp */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 229 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6678; /* *p movv2si_internal */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 229 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6679; /* *p movv4hi_internal */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 229 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6680; /* *p movv8qi_internal */

    case E_V16BImode:
      if (!nonimmediate_operand (operands[0], E_V16BImode)
          || !general_operand (operands[1], E_V16BImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode)))))
        return 6893; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode)))))
        return -1;
      return 6899; /* *p *thumb2_movhi_fp16 */

    case E_V8BImode:
      if (!nonimmediate_operand (operands[0], E_V8BImode)
          || !general_operand (operands[1], E_V8BImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode)))))
        return 6894; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode)))))
        return -1;
      return 6900; /* *p *thumb2_movhi_fp16 */

    case E_V4BImode:
      if (!nonimmediate_operand (operands[0], E_V4BImode)
          || !general_operand (operands[1], E_V4BImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode)))))
        return 6895; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode)))))
        return -1;
      return 6901; /* *p *thumb2_movhi_fp16 */

    case E_V2QImode:
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !general_operand (operands[1], E_V2QImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode)))))
        return 6896; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode)))))
        return -1;
      return 6902; /* *p *thumb2_movhi_fp16 */

    case E_DImode:
      if (!nonimmediate_di_operand (operands[0], E_DImode)
          || !di_operand (operands[1], E_DImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_VFP_BASE
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))
   && !((TARGET_NEON || TARGET_HAVE_MVE) && CONST_INT_P (operands[1])
       && simd_immediate_valid_for_move (operands[1], DImode, NULL, NULL)))))
        return -1;
      return 6905; /* *p *movdi_vfp */

    case E_DFmode:
      if (!nonimmediate_soft_df_operand (operands[0], E_DFmode)
          || !soft_df_operand (operands[1], E_DFmode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 674 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode)))))
        return -1;
      return 6910; /* *p *movdf_vfp */

    default:
      return -1;
    }
}

 int
recog_342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_DUPLICATE:
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      x9 = XEXP (x4, 2);
      operands[3] = x9;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      switch (GET_CODE (x10))
        {
        case TRUNCATE:
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern584 (x4, 
E_V8QImode, 
E_QImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 676 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6723; /* *p iwmmxt_tinsrb */

            case E_V4HImode:
              if (pattern584 (x4, 
E_V4HImode, 
E_HImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 693 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6724; /* *p iwmmxt_tinsrh */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x10;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x4) != E_V2SImode
              || GET_MODE (x5) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 710 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6725; /* *p iwmmxt_tinsrw */

        default:
          return -1;
        }

    case VEC_SELECT:
      x12 = XEXP (x5, 1);
      if (GET_CODE (x12) != PARALLEL)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != PARALLEL)
        return -1;
      x9 = XEXP (x4, 2);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      x14 = XEXP (x8, 0);
      operands[2] = x14;
      switch (XVECLEN (x12, 0))
        {
        case 8:
          if (pattern585 (x12) != 0)
            return -1;
          x15 = XVECEXP (x12, 0, 4);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x16 = XVECEXP (x12, 0, 5);
          if (GET_CODE (x16) != CONST_INT)
            return -1;
          x17 = XVECEXP (x12, 0, 6);
          if (GET_CODE (x17) != CONST_INT)
            return -1;
          x18 = XVECEXP (x12, 0, 7);
          if (GET_CODE (x18) != CONST_INT
              || pattern605 (x13, 
8) != 0)
            return -1;
          x19 = XVECEXP (x13, 0, 4);
          if (GET_CODE (x19) != CONST_INT)
            return -1;
          x20 = XVECEXP (x13, 0, 5);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x21 = XVECEXP (x13, 0, 6);
          if (GET_CODE (x21) != CONST_INT)
            return -1;
          x22 = XVECEXP (x13, 0, 7);
          if (GET_CODE (x22) != CONST_INT
              || XWINT (x9, 0) != 85L
              || pattern618 (x4, 
E_V8QImode) != 0)
            return -1;
          x23 = XVECEXP (x12, 0, 0);
          switch (XWINT (x23, 0))
            {
            case 4L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 5L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 1L
                  || XWINT (x15, 0) != 6L
                  || XWINT (x16, 0) != 2L
                  || XWINT (x17, 0) != 7L
                  || XWINT (x18, 0) != 3L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 0L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 4L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 1L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 5L
                  || XWINT (x19, 0) != 2L
                  || XWINT (x20, 0) != 6L
                  || XWINT (x21, 0) != 3L
                  || XWINT (x22, 0) != 7L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1029 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6759; /* *p iwmmxt_wunpckihb */

            case 0L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 4L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 1L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 5L
                  || XWINT (x15, 0) != 2L
                  || XWINT (x16, 0) != 6L
                  || XWINT (x17, 0) != 3L
                  || XWINT (x18, 0) != 7L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 4L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 0L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 5L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 1L
                  || XWINT (x19, 0) != 6L
                  || XWINT (x20, 0) != 2L
                  || XWINT (x21, 0) != 7L
                  || XWINT (x22, 0) != 3L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1093 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6762; /* *p iwmmxt_wunpckilb */

            default:
              return -1;
            }

        case 4:
          if (pattern585 (x12) != 0
              || pattern605 (x13, 
4) != 0
              || XWINT (x9, 0) != 5L
              || pattern618 (x4, 
E_V4HImode) != 0)
            return -1;
          x23 = XVECEXP (x12, 0, 0);
          switch (XWINT (x23, 0))
            {
            case 2L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 3L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 1L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 0L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 2L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 1L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 3L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1049 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6760; /* *p iwmmxt_wunpckihh */

            case 0L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 2L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 1L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 3L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 2L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 0L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 3L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 1L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1113 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6763; /* *p iwmmxt_wunpckilh */

            default:
              return -1;
            }

        case 2:
          x23 = XVECEXP (x12, 0, 0);
          if (GET_CODE (x23) != CONST_INT)
            return -1;
          x24 = XVECEXP (x12, 0, 1);
          if (GET_CODE (x24) != CONST_INT
              || XVECLEN (x13, 0) != 2)
            return -1;
          x27 = XVECEXP (x13, 0, 0);
          if (GET_CODE (x27) != CONST_INT)
            return -1;
          x28 = XVECEXP (x13, 0, 1);
          if (GET_CODE (x28) != CONST_INT
              || XWINT (x9, 0) != 1L
              || pattern618 (x4, 
E_V2SImode) != 0)
            return -1;
          switch (XWINT (x23, 0))
            {
            case 1L:
              if (XWINT (x24, 0) != 0L
                  || XWINT (x27, 0) != 0L
                  || XWINT (x28, 0) != 1L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1065 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6761; /* *p iwmmxt_wunpckihw */

            case 0L:
              if (XWINT (x24, 0) != 1L
                  || XWINT (x27, 0) != 1L
                  || XWINT (x28, 0) != 0L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1129 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6764; /* *p iwmmxt_wunpckilw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MINUS:
      if (pattern380 (x1, 
SS_PLUS) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 81 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6831; /* *p iwmmxt_waddsubhx */

    case SS_PLUS:
      if (pattern380 (x1, 
SS_MINUS) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 99 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6832; /* *p iwmmxt_wsubaddhx */

    default:
      return -1;
    }
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_SImode
          || REGNO (x3) != 100)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[1] = x9;
      if (!arm_add_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
          if (XWINT (x10, 0) == 0L
              && GET_MODE (x3) == E_CC_NZmode
              && GET_MODE (x4) == E_CC_NZmode
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1142 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM)))
            return 6399; /* *p *addsi3_compare0_scratch */
          break;

        case REG:
        case SUBREG:
          if (rtx_equal_p (x10, operands[0])
              && GET_MODE (x3) == E_CC_Cmode
              && GET_MODE (x4) == E_CC_Cmode
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1293 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return 6401; /* *p *compare_addsi2_op0 */
          break;

        default:
          break;
        }
      if (GET_MODE (x3) != E_CC_Cmode
          || GET_MODE (x4) != E_CC_Cmode
          || !rtx_equal_p (x10, operands[1])
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1316 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6402; /* *p *compare_addsi2_op1 */

    case NEG:
      if (GET_MODE (x5) != E_SImode
          || REGNO (x3) != 100
          || GET_MODE (x3) != E_CC_Zmode
          || GET_MODE (x4) != E_CC_Zmode)
        return -1;
      x10 = XEXP (x4, 1);
      if (!s_register_operand (x10, E_SImode))
        return -1;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[0] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          operands[1] = x10;
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1157 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6400; /* *p *compare_negsi_si */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[1] = x8;
          if (!shift_operator (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[4] = x6;
          x7 = XEXP (x6, 0);
          operands[5] = x7;
          x11 = XEXP (x8, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x8, 1);
          operands[3] = x12;
          if (!shift_amount_operand (operands[3], E_SImode))
            return -1;
          operands[0] = x10;
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7925 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6576; /* *p *arm_cmpsi_negshiftsi_si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x3) != 100
          || GET_MODE (x3) != E_CC_NZmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (GET_MODE (x4) != E_CC_NZmode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[1] = x9;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x13 = XEXP (x5, 2);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3092 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
  && (INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) < 32
      && INTVAL (operands[1]) > 0 
      && INTVAL (operands[1]) + (INTVAL (operands[2]) & 1) <= 8
      && INTVAL (operands[1]) + INTVAL (operands[2]) <= 32))))
        return -1;
      return 6443; /* *p *zeroextractsi_compare0_scratch */

    case REG:
    case SUBREG:
      operands[0] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
          if (XWINT (x10, 0) == 0L
              && REGNO (x3) == 100
              && GET_MODE (x3) == E_CC_Zmode)
            {
              x6 = XEXP (x1, 0);
              operands[1] = x6;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (GET_MODE (x4) == E_CC_Zmode
                  && s_register_operand (operands[0], E_QImode)
                  && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5832 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return 6493; /* *p *compareqi_eq0 */
            }
          break;

        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          res = recog_333 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!s_register_operand (operands[0], E_SImode)
          || REGNO (x3) != 100
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (GET_MODE (x4) != E_CCmode)
        return -1;
      operands[1] = x10;
      if (!arm_add_operand (operands[1], E_SImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7877 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6575; /* *p *arm_cmpsi_insn */

    default:
      return -1;
    }
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5179 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6483; /* *p *arm_negsi2 */

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 890 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6913; /* *p *negsf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x4) != E_DFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 901 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6914; /* *p *negdf2_vfp */

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern524 (x4, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1163 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6924; /* *p *negmulsf3_vfp */

        case E_DFmode:
          if (pattern524 (x4, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1184 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6926; /* *p *negmuldf3_vfp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_359 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (pattern563 (x6, 
MULT, 
E_DImode, 
LSHIFTRT, 
TRUNCATE) != 0)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x7, 0);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XEXP (x12, 1);
  if (GET_MODE (x14) != E_DImode)
    return -1;
  switch (GET_CODE (x13))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x14) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[3])
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2444 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6419; /* *p smull */

    case ZERO_EXTEND:
      if (GET_CODE (x14) != ZERO_EXTEND)
        return -1;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[3])
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2444 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6420; /* *p umull */

    default:
      return -1;
    }
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          res = recog_360 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x4) != MULT
              || GET_MODE (x4) != E_SImode
              || pattern442 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!low_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!low_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1429 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size && reload_completed)))
            return -1;
          return 6993; /* *p *thumb2_mulsi_short */

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (s_register_operand (operands[0], E_SImode))
            {
              res = recog_362 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (!low_register_operand (operands[0], E_SImode)
              || pattern442 (x1) != 0
              || GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_CODE (x4))
            {
            case PLUS:
              if (!low_reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1301 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6991; /* *p *thumb2_addsi_short */

            case MINUS:
              if (!low_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1330 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6992; /* *p *thumb2_subsi_short */

            default:
              return -1;
            }

        case TRUNCATE:
          if (pattern381 (x4, 
E_DImode, 
MULT, 
LSHIFTRT, 
E_SImode) != 0)
            return -1;
          x7 = XEXP (x4, 0);
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x11 = XEXP (x5, 0);
          operands[5] = x11;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          x13 = XEXP (x12, 0);
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x12, 1);
          if (GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x10, 0);
          operands[3] = x15;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          switch (GET_CODE (x13))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x14) != SIGN_EXTEND)
                return -1;
              x16 = XEXP (x13, 0);
              operands[1] = x16;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[2] = x17;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2515 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6423; /* *p *smull_high */

            case ZERO_EXTEND:
              if (GET_CODE (x14) != ZERO_EXTEND)
                return -1;
              x16 = XEXP (x13, 0);
              operands[1] = x16;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[2] = x17;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2515 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6424; /* *p *umull_high */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern381 (x4, 
E_SImode, 
NOT, 
AND, 
E_CC_NZmode) != 0)
            return -1;
          x7 = XEXP (x4, 0);
          x12 = XEXP (x7, 0);
          x13 = XEXP (x12, 0);
          if (!shift_operator (x13, E_SImode))
            return -1;
          operands[0] = x13;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 100
              || GET_MODE (x6) != E_CC_NZmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[5] = x5;
          x11 = XEXP (x5, 0);
          operands[6] = x11;
          x16 = XEXP (x13, 0);
          operands[1] = x16;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x13, 1);
          operands[2] = x18;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[3] = x9;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x10))
            {
            case CLOBBER:
              x15 = XEXP (x10, 0);
              operands[4] = x15;
              if (!scratch_operand (operands[4], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3637 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6452; /* *p andsi_not_shiftsi_si_scc_no_reuse */

            case SET:
              x19 = XEXP (x10, 1);
              if (pattern382 (x19, 
NOT, 
AND, 
E_SImode) != 0)
                return -1;
              x20 = XEXP (x19, 0);
              x21 = XEXP (x20, 0);
              switch (GET_CODE (x21))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x21, operands[0]))
                    return -1;
                  x15 = XEXP (x10, 0);
                  operands[4] = x15;
                  if (!s_register_operand (operands[4], E_SImode))
                    return -1;
                  x22 = XEXP (x19, 1);
                  if (!rtx_equal_p (x22, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3661 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                    return -1;
                  return 6453; /* *p andsi_not_shiftsi_si_scc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ABS:
          if (GET_MODE (x4) != E_SImode
              || pattern363 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5255 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM)))
            return 6484; /* *p *arm_abssi2 */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 117 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
            return -1;
          return 6978; /* *p *thumb2_abssi2 */

        case NEG:
          if (GET_MODE (x4) != E_SImode
              || pattern414 (x1) != 0)
            return -1;
          x7 = XEXP (x4, 0);
          switch (GET_CODE (x7))
            {
            case ABS:
              if (GET_MODE (x7) != E_SImode
                  || !s_register_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x7, 0);
              operands[1] = x12;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5319 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM)))
                return 6485; /* *p *arm_neg_abssi2 */
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 170 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
                return -1;
              return 6979; /* *p *thumb2_neg_abssi2 */

            case REG:
              operands[1] = x7;
              if (!low_register_operand (operands[1], E_SImode)
                  || !low_register_operand (operands[0], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1523 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6995; /* *p *thumb2_negsi2_short */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 2)
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x19 = XEXP (x10, 1);
          if (GET_CODE (x19) != UNSPEC
              || XVECLEN (x19, 0) != 1
              || XINT (x19, 1) != 29
              || GET_MODE (x19) != E_CCmode)
            return -1;
          x23 = XVECEXP (x19, 0, 0);
          if (GET_CODE (x23) != REG
              || REGNO (x23) != 105
              || GET_MODE (x23) != E_CCmode)
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != REG
              || REGNO (x15) != 105
              || GET_MODE (x15) != E_CCmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x11 = XEXP (x5, 0);
          operands[4] = x11;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode)
            return -1;
          x24 = XVECEXP (x4, 0, 0);
          operands[1] = x24;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x25 = XVECEXP (x4, 0, 1);
          operands[2] = x25;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 82:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6536; /* *p arm_sadd8 */

            case 83:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6537; /* *p arm_ssub8 */

            case 84:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6538; /* *p arm_uadd8 */

            case 85:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6539; /* *p arm_usub8 */

            case 86:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6540; /* *p arm_sadd16 */

            case 87:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6541; /* *p arm_sasx */

            case 88:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6542; /* *p arm_ssax */

            case 89:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6543; /* *p arm_ssub16 */

            case 90:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6544; /* *p arm_uadd16 */

            case 91:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6545; /* *p arm_uasx */

            case 92:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6546; /* *p arm_usax */

            case 93:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6547; /* *p arm_usub16 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x4))
            {
            case MEM:
              res = recog_364 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case REG:
            case SUBREG:
              res = recog_367 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode))
            {
              res = recog_368 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x11 = XEXP (x5, 0);
          operands[5] = x11;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!memory_operand (operands[2], E_SImode))
            return -1;
          x15 = XEXP (x10, 0);
          operands[3] = x15;
          if (!memory_operand (operands[3], E_SImode))
            return -1;
          x19 = XEXP (x10, 1);
          operands[1] = x19;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 184 "../../gcc-15.1.0/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, false))))
            return -1;
          return 6621; /* *p *arm_strd */

        case CONST_INT:
          operands[1] = x4;
          if (pattern414 (x1) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!low_register_operand (operands[0], E_QImode)
                  || !const_int_operand (operands[1], E_QImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1289 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6988; /* *p *thumb2_movqi_shortim */

            case E_HImode:
              if (!low_register_operand (operands[0], E_HImode)
                  || !const_int_operand (operands[1], E_HImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1289 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6989; /* *p *thumb2_movhi_shortim */

            case E_SImode:
              if (!low_register_operand (operands[0], E_SImode)
                  || !const_int_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1289 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6990; /* *p *thumb2_movsi_shortim */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x4) != E_SImode
              || pattern363 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!low_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!low_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1512 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
            return -1;
          return 6994; /* *p *thumb2_one_cmplsi2_short */

        default:
          return -1;
        }

    case RETURN:
      x10 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x19 = XEXP (x10, 1);
      if (pattern382 (x19, 
POST_INC, 
MEM, 
E_SImode) != 0)
        return -1;
      x15 = XEXP (x10, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 15
          || GET_MODE (x15) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x11 = XEXP (x5, 0);
      operands[2] = x11;
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 0);
      operands[0] = x21;
      if (!s_register_operand (operands[0], E_SImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12016 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
        return -1;
      return 6598; /* *p *ldr_with_return */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 54
          || GET_MODE (x3) != E_SImode)
        return -1;
      x26 = XVECEXP (x3, 0, 0);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x2, 0, 1);
      if (pattern474 (x10) != 0)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1699 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse)))
        return -1;
      return 6998; /* *p *clear_apsr */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (arm_general_register_operand (operands[0], E_SImode))
    {
      res = peephole2_4 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x2 = XEXP (x1, 1);
  if (!memory_operand (x2, E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != PARALLEL)
    return NULL;
  if (XVECLEN (x3, 0) == 3)
    {
      res = peephole2_5 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (XVECLEN (x3, 0) != 2)
    return NULL;
  operands[3] = x2;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x7 = XEXP (x4, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_SImode))
    return NULL;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x9 = XEXP (x5, 1);
  operands[5] = x9;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_25 (insn, operands);
}

 rtx_insn *
peephole2_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  res = peephole2_8 (x1, insn, pmatch_len_);
  if (res != NULL_RTX)
    return res;
  if (peep2_current_count >= 4)
    {
      res = peephole2_9 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x3 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x3) != SET)
    return NULL;
  operands[0] = x2;
  if (s_register_operand (operands[0], E_SImode))
    {
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      if (memory_operand (operands[3], E_SImode))
        {
          x5 = PATTERN (peep2_next_insn (1));
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (s_register_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              if (memory_operand (operands[4], E_SImode))
                {
                  x8 = XEXP (x3, 0);
                  operands[2] = x8;
                  if (s_register_operand (operands[2], E_SImode))
                    {
                      x9 = XEXP (x3, 1);
                      operands[5] = x9;
                      if (memory_operand (operands[5], E_SImode))
                        {
                          *pmatch_len_ = 2;
                          res = gen_peephole2_24 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
        }
    }
  operands[3] = x2;
  if (!memory_operand (operands[3], E_SImode))
    return NULL;
  x4 = XEXP (x1, 1);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  if (!memory_operand (operands[4], E_SImode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x8 = XEXP (x3, 0);
  operands[5] = x8;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_28 (insn, operands);
}

 rtx_insn *
peephole2_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4)
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x4) != SET)
    return NULL;
  if (arm_general_register_operand (operands[0], E_SImode))
    {
      res = peephole2_11 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  if (peep2_current_count >= 5)
    {
      res = peephole2_13 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x5 = XEXP (x1, 1);
  operands[4] = x5;
  switch (pattern494 (x2))
    {
    case 0:
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x3, 1);
      operands[5] = x6;
      if (!const_int_operand (operands[5], E_SImode))
        return NULL;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[1]))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_30 (insn, operands);

    case 1:
      x8 = XEXP (x2, 0);
      operands[1] = x8;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      x9 = XEXP (x3, 0);
      operands[2] = x9;
      if (!memory_operand (operands[2], E_SImode))
        return NULL;
      x6 = XEXP (x3, 1);
      if (!rtx_equal_p (x6, operands[0]))
        return NULL;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[1]))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_31 (insn, operands);

    default:
      return NULL;
    }
}
