/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_CODE (x1))
    {
    case MEM:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      return 0;

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 39)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 28
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 104
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 104
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern34 (x3, 
E_V4HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern34 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x8 = XVECEXP (x4, 0, 0);
  operands[4] = x8;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  x9 = XVECEXP (x2, 0, 2);
  operands[3] = x9;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[2], E_V16QImode)
          || !vpr_register_operand (operands[3], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !vpr_register_operand (operands[3], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], i3))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i3))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern94 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern100 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 3;

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 5;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      return pattern41 (x3, 
E_V2SFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern38 (x3, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern38 (x3, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern38 (x3, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern148 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return pattern106 (x3); /* [-1, 2] */
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_EImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], E_EImode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_CImode))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V8QImode:
      return 0;

    case E_V16QImode:
      return 1;

    case E_V4HImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V4HFmode:
      return 6;

    case E_V8HFmode:
      return 7;

    case E_V4BFmode:
      return 8;

    case E_V8BFmode:
      return 9;

    case E_V2SFmode:
      return 10;

    case E_V4SFmode:
      return 11;

    case E_DImode:
      return 12;

    case E_V2DImode:
      return 13;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern166 (x3, 
E_V8HImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern167 (x3, 
E_V4SImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern40 (x3, 
E_V16QImode, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern40 (x3, 
E_V8HImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern40 (x3, 
E_V4SImode, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern187 (x3, 
E_HImode, 
E_V8HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern187 (x3, 
E_SImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern32 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern32 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern68 (x3, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V4SImode:
      if (pattern68 (x3, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern68 (x3, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern213 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return pattern214 (x3); /* [-1, 2] */
}

int
pattern226 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i4)
      || GET_MODE (x1) != i4
      || !s_register_operand (operands[1], i4)
      || !s_register_operand (operands[2], i3)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 2);
  operands[3] = x8;
  return 0;
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !mem_noofs_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !mem_noofs_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern249 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != i1
      || GET_MODE (x9) != E_V4HImode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_V4HImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 4)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x14 = XVECEXP (x11, 0, 2);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x15 = XVECEXP (x11, 0, 3);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x16 = XEXP (x1, 2);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10]
      || !register_operand (operands[0], E_V4HImode)
      || GET_MODE (x1) != E_V4HImode)
    return -1;
  x17 = XEXP (x2, 0);
  operands[1] = x17;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x18 = XEXP (x3, 0);
  operands[2] = x18;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x19 = XEXP (x9, 0);
  if (!rtx_equal_p (x19, operands[1]))
    return -1;
  x20 = XEXP (x10, 0);
  if (!rtx_equal_p (x20, operands[2]))
    return -1;
  return 0;
}

int
pattern268 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_double_vcvt_power_of_two_reciprocal (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x2) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x2) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern276 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 2);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (XVECLEN (x4, 0))
    {
    case 4:
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (GET_CODE (x8) != CONST_INT
          || !register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 4L:
          if (XWINT (x6, 0) != 5L
              || XWINT (x7, 0) != 6L
              || XWINT (x8, 0) != 7L)
            return -1;
          return 0;

        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 2L:
          if (XWINT (x6, 0) != 3L)
            return -1;
          return 2;

        case 0L:
          if (XWINT (x6, 0) != 1L)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 1:
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 1L:
          return 4;

        case 0L:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern310 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern317 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1
      || GET_MODE (x1) != E_SImode)
    return -1;
  return 0;
}

int
pattern320 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!reg_or_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern328 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[3] = x7;
  x8 = XEXP (x2, 0);
  operands[2] = x8;
  x9 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern327 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern327 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern327 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern327 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern327 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern327 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2SFmode:
      if (pattern327 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern327 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V8HFmode:
      if (pattern327 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 8;

    case E_V4HFmode:
      if (pattern327 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern357 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  return 0;
}

int
pattern371 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode)
      || !reg_or_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern377 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern376 (x1); /* [-1, 0] */

    case E_DImode:
      if (pattern311 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern311 (x1, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern311 (x1, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V8QImode:
      if (pattern311 (x1, 
E_V8QImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern385 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode
      || !s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern394 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern405 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case VEC_SELECT:
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      x3 = XEXP (x1, 1);
      operands[5] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          return 0;

        case E_V4SFmode:
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != VEC_SELECT
          || GET_MODE (x2) != E_HFmode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XVECEXP (x4, 0, 0);
      operands[5] = x6;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          return 2;

        case E_V4SFmode:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern417 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern427 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !const_int_vcde1_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern434 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern444 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  return 0;
}

int
pattern453 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern458 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !neon_struct_operand (operands[1], E_V2BFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_V8BFmode)
    return -1;
  return 0;
}

int
pattern465 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1)
      || !zero_operand (operands[3], i1)
      || !minus_one_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern476 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != SIGN_EXTEND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_Vmode
      || GET_MODE (x3) != E_CC_Vmode)
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern491 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern498 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern506 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  return pattern504 (x2, 
i1, 
i2); /* [-1, 1] */
}

int
pattern513 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern530 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern529 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern529 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern529 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_MODE (x9) != E_DImode
          || !mem_noofs_operand (operands[1], E_DImode)
          || !s_register_operand (operands[2], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern551 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  return 0;
}

int
pattern558 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x1, 0);
  operands[4] = x7;
  x8 = XEXP (x7, 0);
  operands[5] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern571 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern585 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern592 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern597 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case MEM:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case REG:
      operands[1] = x2;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!load_multiple_operation (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arm_hard_general_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!arm_hard_general_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!arm_hard_general_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern616 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[3], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern627 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_V2SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XVECEXP (x8, 0, 0);
  switch (XWINT (x9, 0))
    {
    case 0L:
      x10 = XEXP (x6, 1);
      x11 = XVECEXP (x10, 0, 0);
      switch (XWINT (x11, 0))
        {
        case 0L:
          return 0;

        case 1L:
          return 1;

        default:
          return -1;
        }

    case 1L:
      x10 = XEXP (x6, 1);
      x11 = XVECEXP (x10, 0, 0);
      switch (XWINT (x11, 0))
        {
        case 0L:
          return 2;

        case 1L:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern639 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 2);
  switch (XWINT (x3, 0))
    {
    case 0L:
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 2);
      if (XWINT (x5, 0) != 32L)
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      x7 = XEXP (x6, 2);
      switch (XWINT (x7, 0))
        {
        case 0L:
          x8 = XVECEXP (x1, 0, 4);
          x9 = XEXP (x8, 2);
          if (XWINT (x9, 0) != 32L)
            return -1;
          return 0;

        case 16L:
          x8 = XVECEXP (x1, 0, 4);
          x9 = XEXP (x8, 2);
          if (XWINT (x9, 0) != 48L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 16L:
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 2);
      if (XWINT (x5, 0) != 48L)
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      x7 = XEXP (x6, 2);
      switch (XWINT (x7, 0))
        {
        case 0L:
          x8 = XVECEXP (x1, 0, 4);
          x9 = XEXP (x8, 2);
          if (XWINT (x9, 0) != 32L)
            return -1;
          return 2;

        case 16L:
          x8 = XVECEXP (x1, 0, 4);
          x9 = XEXP (x8, 2);
          if (XWINT (x9, 0) != 48L)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (arm_addimm_operand (operands[2], E_SImode))
    {
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) == SET)
        {
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) == PLUS
              && GET_MODE (x6) == E_SImode
              && pattern416 (x1) == 0)
            {
              x7 = XEXP (x6, 1);
              operands[3] = x7;
              if (arm_addimm_operand (operands[3], E_SImode))
                {
                  x8 = XEXP (x6, 0);
                  if (rtx_equal_p (x8, operands[1])
                      && 
#line 1177 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (INTVAL (operands[2])
       == trunc_int_for_mode (-INTVAL (operands[3]), SImode))))
                    return 16; /* cmpsi2_addneg */
                }
            }
        }
    }
  if (XWINT (x4, 0) != 0L)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case SET:
      if (pattern416 (x1) != 0)
        return -1;
      x6 = XEXP (x5, 1);
      if (!rtx_equal_p (x6, operands[1])
          || !
#line 6834 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 264; /* *movsi_compare0 */

    case CLOBBER:
      x9 = XEXP (x2, 0);
      if (GET_MODE (x9) != E_CC_Zmode
          || GET_MODE (x3) != E_CC_Zmode)
        return -1;
      x10 = XEXP (x3, 0);
      operands[0] = x10;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      if (!scratch_operand (operands[1], E_SImode)
          || !
#line 1724 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 984; /* *thumb_cmpdi_zero */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XINT (x4, 1))
    {
    case 82:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 226; /* arm_sadd8 */

    case 83:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 227; /* arm_ssub8 */

    case 84:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 228; /* arm_uadd8 */

    case 85:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 229; /* arm_usub8 */

    case 86:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 230; /* arm_sadd16 */

    case 87:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 231; /* arm_sasx */

    case 88:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 232; /* arm_ssax */

    case 89:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 233; /* arm_ssub16 */

    case 90:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 234; /* arm_uadd16 */

    case 91:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 235; /* arm_uasx */

    case 92:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 236; /* arm_usax */

    case 93:
      if (pattern324 (x1, 
29, 
E_SImode, 
E_CCmode, 
105) != 0
          || !
#line 6100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 237; /* arm_usub16 */

    case 98:
      if (pattern324 (x1, 
28, 
E_SImode, 
E_CCmode, 
104) != 0
          || !
#line 6139 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
        return -1;
      return 247; /* arm_smuad_setq_insn */

    case 99:
      if (pattern324 (x1, 
28, 
E_SImode, 
E_CCmode, 
104) != 0
          || !
#line 6139 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
        return -1;
      return 249; /* arm_smuadx_setq_insn */

    case 100:
      if (pattern325 (x1) != 0
          || !ssat16_imm (operands[2], E_SImode)
          || !
#line 6166 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
        return -1;
      return 251; /* arm_ssat16_setq_insn */

    case 101:
      if (pattern325 (x1) != 0
          || !usat16_imm (operands[2], E_SImode)
          || !
#line 6166 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
        return -1;
      return 253; /* arm_usat16_setq_insn */

    case 177:
      if (pattern326 (x1) != 0
          || !
#line 1941 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 878; /* neon_vcvths_nhf_unspec */

    case 178:
      if (pattern326 (x1) != 0
          || !
#line 1941 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 879; /* neon_vcvthu_nhf_unspec */

    case 41:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER
          || !register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      if (!rtx_equal_p (x9, operands[2])
          || !
#line 2116 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 1006; /* thumb1_stack_protect_test_insn */

    case 345:
      switch (pattern328 (x1, 
346))
        {
        case 0:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2492; /* *neon_vtrnv8qi_insn */

        case 1:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2493; /* *neon_vtrnv16qi_insn */

        case 2:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2494; /* *neon_vtrnv4hi_insn */

        case 3:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2495; /* *neon_vtrnv8hi_insn */

        case 4:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2496; /* *neon_vtrnv2si_insn */

        case 5:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2497; /* *neon_vtrnv4si_insn */

        case 6:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2498; /* *neon_vtrnv2sf_insn */

        case 7:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2499; /* *neon_vtrnv4sf_insn */

        case 8:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2500; /* *neon_vtrnv8hf_insn */

        case 9:
          if (!
#line 4926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2501; /* *neon_vtrnv4hf_insn */

        default:
          return -1;
        }

    case 350:
      switch (pattern328 (x1, 
351))
        {
        case 0:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2502; /* *neon_vzipv8qi_insn */

        case 1:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2503; /* *neon_vzipv16qi_insn */

        case 2:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2504; /* *neon_vzipv4hi_insn */

        case 3:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2505; /* *neon_vzipv8hi_insn */

        case 4:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2506; /* *neon_vzipv2si_insn */

        case 5:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2507; /* *neon_vzipv4si_insn */

        case 6:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2508; /* *neon_vzipv2sf_insn */

        case 7:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2509; /* *neon_vzipv4sf_insn */

        case 8:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2510; /* *neon_vzipv8hf_insn */

        case 9:
          if (!
#line 4952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2511; /* *neon_vzipv4hf_insn */

        default:
          return -1;
        }

    case 348:
      switch (pattern328 (x1, 
349))
        {
        case 0:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2512; /* *neon_vuzpv8qi_insn */

        case 1:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2513; /* *neon_vuzpv16qi_insn */

        case 2:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2514; /* *neon_vuzpv4hi_insn */

        case 3:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2515; /* *neon_vuzpv8hi_insn */

        case 4:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2516; /* *neon_vuzpv2si_insn */

        case 5:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2517; /* *neon_vuzpv4si_insn */

        case 6:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2518; /* *neon_vuzpv2sf_insn */

        case 7:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2519; /* *neon_vuzpv4sf_insn */

        case 8:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2520; /* *neon_vuzpv8hf_insn */

        case 9:
          if (!
#line 4978 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2521; /* *neon_vuzpv4hf_insn */

        default:
          return -1;
        }

    case 1033:
      switch (pattern330 (x1, 
PLUS))
        {
        case 0:
          if (!
#line 3734 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4938; /* mve_vidupq_uv16qi_insn */

        case 1:
          if (!
#line 3734 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4940; /* mve_vidupq_uv8hi_insn */

        case 2:
          if (!
#line 3734 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4942; /* mve_vidupq_uv4si_insn */

        default:
          return -1;
        }

    case 1029:
      switch (pattern330 (x1, 
MINUS))
        {
        case 0:
          if (!
#line 3734 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4939; /* mve_vddupq_uv16qi_insn */

        case 1:
          if (!
#line 3734 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4941; /* mve_vddupq_uv8hi_insn */

        case 2:
          if (!
#line 3734 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4943; /* mve_vddupq_uv4si_insn */

        default:
          return -1;
        }

    case 1053:
      if (pattern331 (x1, 
1053) != 0
          || !
#line 3994 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4976; /* mve_vadciq_uv4si */

    case 1055:
      if (pattern331 (x1, 
1055) != 0
          || !
#line 3994 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4977; /* mve_vadciq_sv4si */

    case 1045:
      if (pattern331 (x1, 
1045) != 0
          || !
#line 3994 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4978; /* mve_vsbciq_uv4si */

    case 1046:
      if (pattern331 (x1, 
1046) != 0
          || !
#line 3994 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4979; /* mve_vsbciq_sv4si */

    case 1041:
      if (pattern324 (x1, 
1041, 
E_V4SImode, 
E_SImode, 
101) != 0
          || !
#line 4034 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4984; /* mve_vadcq_uv4si */

    case 1043:
      if (pattern324 (x1, 
1043, 
E_V4SImode, 
E_SImode, 
101) != 0
          || !
#line 4034 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4985; /* mve_vadcq_sv4si */

    case 1049:
      if (pattern324 (x1, 
1049, 
E_V4SImode, 
E_SImode, 
101) != 0
          || !
#line 4034 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4986; /* mve_vsbcq_uv4si */

    case 1050:
      if (pattern324 (x1, 
1050, 
E_V4SImode, 
E_SImode, 
101) != 0
          || !
#line 4034 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4987; /* mve_vsbcq_sv4si */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      switch (pattern6 (x3))
        {
        case 0:
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          x5 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x5))
            {
            case USE:
              x6 = XVECEXP (x1, 0, 2);
              if (pattern318 (x6, 
E_SImode, 
14) != 0)
                return -1;
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (s_register_operand (operands[0], E_SImode))
                {
                  if (
#line 8714 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch5t && !SIBLING_CALL_P (insn)))
                    return 290; /* *call_reg_armv5 */
                  if (
#line 8724 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch5t && !SIBLING_CALL_P (insn)))
                    return 291; /* *call_reg_arm */
                }
              if (
#line 8853 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !SIBLING_CALL_P (insn)
   && (GET_CODE (operands[0]) == SYMBOL_REF)
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[0]))))
                return 294; /* *call_symbol */
              if (register_operand (operands[0], E_SImode))
                {
                  if (
#line 1870 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch5t && !SIBLING_CALL_P (insn)))
                    return 991; /* *call_reg_thumb1_v5 */
                  if (
#line 1893 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch5t && !SIBLING_CALL_P (insn)))
                    return 993; /* *call_reg_thumb1 */
                }
              if (
#line 1960 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[0]))))
                return 997; /* *call_insn */
              if (!s_register_operand (operands[0], E_SImode)
                  || !
#line 534 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return -1;
              return 1025; /* *call_reg_thumb2 */

            case RETURN:
              x6 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x6) != USE
                  || !call_insn_operand (operands[0], E_SImode))
                return -1;
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              if (!
#line 8966 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && SIBLING_CALL_P (insn)))
                return -1;
              return 296; /* *sibcall_insn */

            default:
              return -1;
            }

        case 1:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (pattern318 (x6, 
E_SImode, 
14) != 0)
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) == REG
              && REGNO (x10) == 4
              && GET_MODE (x10) == E_SImode)
            {
              x4 = XEXP (x2, 1);
              operands[0] = x4;
              x7 = XEXP (x5, 0);
              operands[1] = x7;
              if (
#line 1882 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && use_cmse && !SIBLING_CALL_P (insn)))
                return 992; /* *nonsecure_call_reg_thumb1_v5 */
            }
          operands[0] = x10;
          if (s_register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (
#line 545 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && TARGET_HAVE_FPCXT_CMSE))
                return 1026; /* *nonsecure_call_reg_thumb2_fpcxt */
            }
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 4
              || GET_MODE (x10) != E_SImode)
            return -1;
          x4 = XEXP (x2, 1);
          operands[0] = x4;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!
#line 557 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && !TARGET_HAVE_FPCXT_CMSE))
            return -1;
          return 1027; /* *nonsecure_call_reg_thumb2 */

        default:
          return -1;
        }

    case SET:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CALL:
          switch (pattern18 (x2))
            {
            case 0:
              x11 = XEXP (x4, 1);
              operands[2] = x11;
              x5 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x5))
                {
                case USE:
                  x6 = XVECEXP (x1, 0, 2);
                  if (pattern318 (x6, 
E_SImode, 
14) != 0)
                    return -1;
                  x7 = XEXP (x5, 0);
                  operands[3] = x7;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      if (
#line 8826 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch5t && !SIBLING_CALL_P (insn)))
                        return 292; /* *call_value_reg_armv5 */
                      if (
#line 8837 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch5t && !SIBLING_CALL_P (insn)))
                        return 293; /* *call_value_reg_arm */
                    }
                  if (
#line 8877 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !SIBLING_CALL_P (insn)
   && (GET_CODE (operands[1]) == SYMBOL_REF)
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
                    return 295; /* *call_value_symbol */
                  if (register_operand (operands[1], E_SImode))
                    {
                      if (
#line 1914 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch5t))
                        return 994; /* *call_value_reg_thumb1_v5 */
                      if (
#line 1940 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch5t))
                        return 996; /* *call_value_reg_thumb1 */
                    }
                  if (
#line 1974 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
                    return 998; /* *call_value_insn */
                  if (!register_operand (operands[1], E_SImode)
                      || !
#line 569 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                    return -1;
                  return 1028; /* *call_value_reg_thumb2 */

                case RETURN:
                  x6 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x6) != USE
                      || !call_insn_operand (operands[1], E_SImode))
                    return -1;
                  x8 = XEXP (x6, 0);
                  operands[3] = x8;
                  if (!
#line 8987 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && SIBLING_CALL_P (insn)))
                    return -1;
                  return 297; /* *sibcall_value_insn */

                default:
                  return -1;
                }

            case 1:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              if (pattern318 (x6, 
E_SImode, 
14) != 0)
                return -1;
              x12 = XEXP (x4, 0);
              x13 = XVECEXP (x12, 0, 0);
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) == REG
                  && REGNO (x14) == 4
                  && GET_MODE (x14) == E_SImode)
                {
                  x11 = XEXP (x4, 1);
                  operands[1] = x11;
                  x7 = XEXP (x5, 0);
                  operands[2] = x7;
                  if (
#line 1928 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && use_cmse))
                    return 995; /* *nonsecure_call_value_reg_thumb1_v5 */
                }
              operands[1] = x14;
              if (register_operand (operands[1], E_SImode))
                {
                  x11 = XEXP (x4, 1);
                  operands[2] = x11;
                  x7 = XEXP (x5, 0);
                  operands[3] = x7;
                  if (
#line 582 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && TARGET_HAVE_FPCXT_CMSE))
                    return 1029; /* *nonsecure_call_value_reg_thumb2_fpcxt */
                }
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 4
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x11 = XEXP (x4, 1);
              operands[1] = x11;
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (!
#line 595 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && !TARGET_HAVE_FPCXT_CMSE))
                return -1;
              return 1030; /* *nonsecure_call_value_reg_thumb2 */

            default:
              return -1;
            }

        case UNSPEC:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (XVECLEN (x4, 0))
            {
            case 1:
              if (pattern285 (x4) != 0
                  || pattern451 (x1) != 0)
                return -1;
              return 308; /* *stack_protect_combined_set_insn */

            case 2:
              if (XINT (x4, 1) != 21)
                return -1;
              x15 = XVECEXP (x4, 0, 0);
              if (GET_CODE (x15) != REG
                  || REGNO (x15) != 0
                  || GET_MODE (x15) != E_SImode)
                return -1;
              x16 = XVECEXP (x4, 0, 1);
              if (GET_CODE (x16) != LABEL_REF)
                return -1;
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != PC)
                return -1;
              x7 = XEXP (x5, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 12
                  || GET_MODE (x7) != E_SImode)
                return -1;
              x8 = XEXP (x6, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 14
                  || GET_MODE (x8) != E_SImode)
                return -1;
              x17 = XEXP (x16, 0);
              operands[0] = x17;
              if (!
#line 2008 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return -1;
              return 999; /* thumb1_casesi_dispatch */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x4) != E_CC_Zmode)
            return -1;
          x12 = XEXP (x4, 0);
          if (GET_CODE (x12) != UNSPEC
              || XVECLEN (x12, 0) != 2
              || XINT (x12, 1) != 41
              || pattern289 (x2, 
E_CC_Zmode) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x13 = XVECEXP (x12, 0, 0);
          if (!memory_operand (x13, E_SImode))
            return -1;
          operands[1] = x13;
          x18 = XVECEXP (x12, 0, 1);
          if (GET_CODE (x18) == MEM
              && GET_MODE (x18) == E_SImode)
            {
              x19 = XEXP (x18, 0);
              operands[2] = x19;
              if (register_operand (operands[2], E_SImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[0] = x7;
                  if (register_operand (operands[0], E_SImode))
                    {
                      x8 = XEXP (x6, 0);
                      if (rtx_equal_p (x8, operands[2])
                          && 
#line 9459 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                        return 311; /* arm_stack_protect_test_insn */
                    }
                }
            }
          operands[0] = x13;
          operands[1] = x18;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!scratch_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          return 313; /* stack_protect_test_tls */

        case IF_THEN_ELSE:
          x12 = XEXP (x4, 0);
          switch (GET_CODE (x12))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              x20 = XEXP (x12, 1);
              if (GET_CODE (x20) != CONST_INT)
                return -1;
              x21 = XEXP (x4, 2);
              if (GET_CODE (x21) != PC)
                return -1;
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != PC)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != SET)
                return -1;
              x22 = XEXP (x5, 1);
              if (GET_CODE (x22) != PLUS
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XEXP (x22, 1);
              if (GET_CODE (x23) == CONST_INT)
                {
                  res = recog_36 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              x24 = XEXP (x12, 0);
              if (GET_CODE (x24) != PLUS
                  || GET_MODE (x24) != E_SImode
                  || XWINT (x20, 0) != 0L)
                return -1;
              x11 = XEXP (x4, 1);
              if (GET_CODE (x11) != LABEL_REF)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              operands[4] = x12;
              if (!arm_comparison_operator (operands[4], E_VOIDmode))
                return -1;
              x25 = XEXP (x24, 0);
              operands[2] = x25;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x26 = XEXP (x24, 1);
              operands[3] = x26;
              if (!reg_or_int_operand (operands[3], E_SImode))
                return -1;
              x27 = XEXP (x11, 0);
              operands[5] = x27;
              x7 = XEXP (x5, 0);
              operands[0] = x7;
              if (!thumb_cbrch_target_operand (operands[0], E_SImode))
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              if (!scratch_operand (operands[1], E_SImode))
                return -1;
              x28 = XEXP (x22, 0);
              if (!rtx_equal_p (x28, operands[2])
                  || !rtx_equal_p (x23, operands[3])
                  || !
#line 1582 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[4]) == EQ
       || GET_CODE (operands[4]) == NE
       || GET_CODE (operands[4]) == GE
       || GET_CODE (operands[4]) == LT)))
                return -1;
              return 982; /* *addsi3_cbranch */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (pnum_clobbers == NULL
              || XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 17)
            return -1;
          x15 = XVECEXP (x4, 0, 0);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != SET)
            return -1;
          x29 = XEXP (x6, 1);
          if (GET_CODE (x29) != UNSPEC_VOLATILE
              || XVECLEN (x29, 0) != 5
              || XINT (x29, 1) != 17)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x30 = XVECEXP (x29, 0, 0);
          operands[3] = x30;
          x31 = XVECEXP (x29, 0, 1);
          operands[4] = x31;
          x32 = XVECEXP (x29, 0, 2);
          operands[5] = x32;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x33 = XVECEXP (x29, 0, 3);
          operands[6] = x33;
          if (!const_int_operand (operands[6], E_SImode))
            return -1;
          x34 = XVECEXP (x29, 0, 4);
          operands[7] = x34;
          if (!const_int_operand (operands[7], E_SImode))
            return -1;
          switch (pattern261 (x1))
            {
            case 0:
              if (!(
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 3081; /* atomic_compare_and_swap32qi_1 */

            case 1:
              if (!(
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 3083; /* atomic_compare_and_swap32hi_1 */

            case 2:
              if (!(
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)))
                return -1;
              *pnum_clobbers = 1;
              return 3082; /* atomic_compare_and_swapt1qi_1 */

            case 3:
              if (!(
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)))
                return -1;
              *pnum_clobbers = 1;
              return 3084; /* atomic_compare_and_swapt1hi_1 */

            case 4:
              if (!(
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 3085; /* atomic_compare_and_swap32si_1 */

            case 5:
              if (!(
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 3087; /* atomic_compare_and_swap32di_1 */

            case 6:
              if (!(
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)))
                return -1;
              *pnum_clobbers = 1;
              return 3086; /* atomic_compare_and_swapt1si_1 */

            case 7:
              if (!(
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)))
                return -1;
              *pnum_clobbers = 1;
              return 3088; /* atomic_compare_and_swapt1di_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern32 (x3, 
E_V8QImode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2261; /* neon_vbslv8qi_internal */

    case E_V16QImode:
      if (pattern32 (x3, 
E_V16QImode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2262; /* neon_vbslv16qi_internal */

    case E_V4HImode:
      if (pattern32 (x3, 
E_V4HImode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2263; /* neon_vbslv4hi_internal */

    case E_V8HImode:
      if (pattern32 (x3, 
E_V8HImode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2264; /* neon_vbslv8hi_internal */

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2265; /* neon_vbslv2si_internal */

    case E_V4SImode:
      if (pattern32 (x3, 
E_V4SImode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2266; /* neon_vbslv4si_internal */

    case E_V4HFmode:
      if (pattern32 (x3, 
E_V4HFmode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2267; /* neon_vbslv4hf_internal */

    case E_V8HFmode:
      if (pattern32 (x3, 
E_V8HFmode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2268; /* neon_vbslv8hf_internal */

    case E_V4BFmode:
      if (pattern32 (x3, 
E_V4BFmode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2269; /* neon_vbslv4bf_internal */

    case E_V8BFmode:
      if (pattern32 (x3, 
E_V8BFmode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2270; /* neon_vbslv8bf_internal */

    case E_V2SFmode:
      if (pattern32 (x3, 
E_V2SFmode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2271; /* neon_vbslv2sf_internal */

    case E_V4SFmode:
      if (pattern32 (x3, 
E_V4SFmode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2272; /* neon_vbslv4sf_internal */

    case E_DImode:
      if (pattern32 (x3, 
E_DImode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2273; /* neon_vbsldi_internal */

    case E_V2DImode:
      if (pattern32 (x3, 
E_V2DImode) != 0
          || !
#line 4472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2274; /* neon_vbslv2di_internal */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_V8QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_V8QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_V8QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[2], E_V8QImode)
          || !
#line 4831 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2488; /* neon_vtbx1v8qi */

    case E_TImode:
      if (!s_register_operand (operands[2], E_TImode)
          || !
#line 4842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2489; /* neon_vtbx2v8qi */

    case E_EImode:
      if (!s_register_operand (operands[2], E_EImode)
          || !
#line 4864 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2490; /* neon_vtbx3v8qi */

    case E_OImode:
      if (!s_register_operand (operands[2], E_OImode)
          || !
#line 4887 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2491; /* neon_vtbx4v8qi */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern91 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SImode:
          if (!s_register_operand (operands[2], E_V4SImode)
              || !
#line 3414 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4876; /* mve_vstrq_scatter_base_v4si */

        case E_V4SFmode:
          if (!s_register_operand (operands[2], E_V4SFmode)
              || !
#line 3414 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4877; /* mve_vstrq_scatter_base_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !
#line 3414 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4878; /* mve_vstrq_scatter_base_v2di */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2434; /* neon_vsrau_nv8qi */

    case 1:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2438; /* neon_vsrau_nv16qi */

    case 2:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2442; /* neon_vsrau_nv4hi */

    case 3:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2446; /* neon_vsrau_nv8hi */

    case 4:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2450; /* neon_vsrau_nv2si */

    case 5:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2454; /* neon_vsrau_nv4si */

    case 6:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2458; /* neon_vsrau_ndi */

    case 7:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2462; /* neon_vsrau_nv2di */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[2] = x6;
  switch (XWINT (x3, 0))
    {
    case 4L:
      if (!
#line 6739 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_THUMB))
        return -1;
      return 261; /* pic_add_dot_plus_four */

    case 8L:
      if (!
#line 6755 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      return 262; /* pic_add_dot_plus_eight */

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_ccde1_operand (operands[3], E_SImode))
    return -1;
  switch (pattern426 (x3))
    {
    case 0:
      if (!
#line 4539 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 141; /* arm_cx1asi */

    case 1:
      if (!
#line 4539 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 142; /* arm_cx1adi */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_V8QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFTRT
      || GET_MODE (x4) != E_TImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_CONCAT
      || GET_MODE (x6) != E_V16QImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != MULT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x9 = XEXP (x1, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x11 = XEXP (x6, 1);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x12 = XEXP (x7, 0);
  operands[3] = x12;
  if (!immediate_operand (operands[3], E_SImode)
      || !
#line 1641 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
    return -1;
  return 677; /* iwmmxt_waligni */
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 4444 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2255; /* neon_vrev32v8qi */

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode)
          || !
#line 4444 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2256; /* neon_vrev32v4hi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 4444 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2257; /* neon_vrev32v16qi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 4444 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2258; /* neon_vrev32v8hi */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 4453 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2259; /* neon_vrev16v8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 4453 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2260; /* neon_vrev16v16qi */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern104 (x1))
    {
    case 0:
      if (!
#line 3141 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2006; /* neon_vqnegv8qi */

    case 1:
      if (!
#line 3141 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2007; /* neon_vqnegv16qi */

    case 2:
      if (!
#line 3141 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2008; /* neon_vqnegv4hi */

    case 3:
      if (!
#line 3141 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2009; /* neon_vqnegv8hi */

    case 4:
      if (!
#line 3141 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2010; /* neon_vqnegv2si */

    case 5:
      if (!
#line 3141 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2011; /* neon_vqnegv4si */

    default:
      return -1;
    }
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern155 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      switch (pattern456 (x2, 
E_TImode))
        {
        case 0:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2536; /* neon_vld1_x2v8qi */

        case 1:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2538; /* neon_vld1_x2v16qi */

        case 2:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2540; /* neon_vld1_x2v4hi */

        case 3:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2542; /* neon_vld1_x2v8hi */

        case 4:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2544; /* neon_vld1_x2v2si */

        case 5:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2546; /* neon_vld1_x2v4si */

        case 6:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2548; /* neon_vld1_x2v4hf */

        case 7:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2550; /* neon_vld1_x2v8hf */

        case 8:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2552; /* neon_vld1_x2v4bf */

        case 9:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2554; /* neon_vld1_x2v8bf */

        case 10:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2556; /* neon_vld1_x2v2sf */

        case 11:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2558; /* neon_vld1_x2v4sf */

        case 12:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2560; /* neon_vld1_x2di */

        case 13:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2562; /* neon_vld1_x2v2di */

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      switch (pattern456 (x2, 
E_OImode))
        {
        case 0:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2537; /* neon_vld1q_x2v8qi */

        case 1:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2539; /* neon_vld1q_x2v16qi */

        case 2:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2541; /* neon_vld1q_x2v4hi */

        case 3:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2543; /* neon_vld1q_x2v8hi */

        case 4:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2545; /* neon_vld1q_x2v2si */

        case 5:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2547; /* neon_vld1q_x2v4si */

        case 6:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2549; /* neon_vld1q_x2v4hf */

        case 7:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2551; /* neon_vld1q_x2v8hf */

        case 8:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2553; /* neon_vld1q_x2v4bf */

        case 9:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2555; /* neon_vld1q_x2v8bf */

        case 10:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2557; /* neon_vld1q_x2v2sf */

        case 11:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2559; /* neon_vld1q_x2v4sf */

        case 12:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2561; /* neon_vld1q_x2di */

        case 13:
          if (!
#line 5003 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2563; /* neon_vld1q_x2v2di */

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 1);
      switch (pattern456 (x2, 
E_EImode))
        {
        case 0:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2564; /* neon_vld1_x3v8qi */

        case 1:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2565; /* neon_vld1_x3v16qi */

        case 2:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2566; /* neon_vld1_x3v4hi */

        case 3:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2567; /* neon_vld1_x3v8hi */

        case 4:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2568; /* neon_vld1_x3v2si */

        case 5:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2569; /* neon_vld1_x3v4si */

        case 6:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2570; /* neon_vld1_x3v4hf */

        case 7:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2571; /* neon_vld1_x3v8hf */

        case 8:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2572; /* neon_vld1_x3v4bf */

        case 9:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2573; /* neon_vld1_x3v8bf */

        case 10:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2574; /* neon_vld1_x3v2sf */

        case 11:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2575; /* neon_vld1_x3v4sf */

        case 12:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2576; /* neon_vld1_x3di */

        case 13:
          if (!
#line 5013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2577; /* neon_vld1_x3v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2403; /* neon_vqshl_s_nv8qi */

    case 1:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2405; /* neon_vqshl_s_nv16qi */

    case 2:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2407; /* neon_vqshl_s_nv4hi */

    case 3:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2409; /* neon_vqshl_s_nv8hi */

    case 4:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2411; /* neon_vqshl_s_nv2si */

    case 5:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2413; /* neon_vqshl_s_nv4si */

    case 6:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2415; /* neon_vqshl_s_ndi */

    case 7:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2417; /* neon_vqshl_s_nv2di */

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2307; /* neon_vqshlsv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2311; /* neon_vqshlsv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2315; /* neon_vqshlsv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2319; /* neon_vqshlsv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2323; /* neon_vqshlsv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2327; /* neon_vqshlsv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2331; /* neon_vqshlsdi */

    case 7:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2335; /* neon_vqshlsv2di */

    default:
      return -1;
    }
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1633; /* neon_vqsubsv8qi */

    case 1:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1635; /* neon_vqsubsv16qi */

    case 2:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1637; /* neon_vqsubsv4hi */

    case 3:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1639; /* neon_vqsubsv8hi */

    case 4:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1641; /* neon_vqsubsv2si */

    case 5:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1643; /* neon_vqsubsv4si */

    case 6:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1645; /* neon_vqsubsdi */

    case 7:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1647; /* neon_vqsubsv2di */

    default:
      return -1;
    }
}

 int
recog_193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1, 
E_OImode, 
E_XImode))
    {
    case 0:
      if (!
#line 5093 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2606; /* neon_vld1x4qav16qi */

    case 1:
      if (!
#line 5093 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2607; /* neon_vld1x4qav8hi */

    case 2:
      if (!
#line 5093 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2608; /* neon_vld1x4qav8hf */

    case 3:
      if (!(
#line 5093 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2609; /* neon_vld1x4qav8bf */

    case 4:
      if (!
#line 5093 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2610; /* neon_vld1x4qav4si */

    case 5:
      if (!
#line 5093 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2611; /* neon_vld1x4qav4sf */

    case 6:
      if (!
#line 5093 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2612; /* neon_vld1x4qav2di */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5887 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2879; /* neon_vst3qbv16qi */

    case 1:
      if (!
#line 5887 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2880; /* neon_vst3qbv8hi */

    case 2:
      if (!
#line 5887 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2881; /* neon_vst3qbv8hf */

    case 3:
      if (!(
#line 5887 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2882; /* neon_vst3qbv8bf */

    case 4:
      if (!
#line 5887 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2883; /* neon_vst3qbv4si */

    case 5:
      if (!
#line 5887 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2884; /* neon_vst3qbv4sf */

    default:
      return -1;
    }
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1787; /* neon_vabdsv8qi */

    case 1:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1789; /* neon_vabdsv16qi */

    case 2:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1791; /* neon_vabdsv4hi */

    case 3:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1793; /* neon_vabdsv8hi */

    case 4:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1795; /* neon_vabdsv2si */

    case 5:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1797; /* neon_vabdsv4si */

    default:
      return -1;
    }
}

 int
recog_223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 385; /* stack_tie */
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 2516 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1758; /* neon_vcagtv2sf_insn_unspec */

    case 1:
      if (!
#line 2516 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1762; /* neon_vcagtv4sf_insn_unspec */

    case 2:
      if (!
#line 2557 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1774; /* neon_vcagtv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2557 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1778; /* neon_vcagtv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern132 (x1))
    {
    case 0:
      if (!
#line 1376 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1440; /* neon_vpsminv8qi */

    case 1:
      if (!
#line 1376 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1441; /* neon_vpsminv4hi */

    case 2:
      if (!
#line 1376 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1442; /* neon_vpsminv2si */

    case 3:
      if (!
#line 1376 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1443; /* neon_vpsminv2sf */

    default:
      return -1;
    }
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern91 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 3);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode))
        return -1;
      switch (pattern552 ())
        {
        case 0:
          if (!
#line 3521 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4903; /* mve_vstrq_scatter_base_p_v4si */

        case 1:
          if (!
#line 3521 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4904; /* mve_vstrq_scatter_base_p_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !vpr_register_operand (operands[3], E_V2QImode)
          || !
#line 3521 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4905; /* mve_vstrq_scatter_base_p_v2di */

    default:
      return -1;
    }
}

 int
recog_254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern196 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern481 (x2, 
E_SImode) != 0
          || !
#line 2226 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 935; /* arm_vcx2asi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern481 (x2, 
E_DImode) != 0
          || !
#line 2226 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 936; /* arm_vcx2adi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern482 (x2) != 0
          || !const_int_mve_cde2_operand (operands[4], E_SImode)
          || !
#line 4473 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5048; /* arm_vcx2qav16qi */

    case 3:
      if (!
#line 4513 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5052; /* arm_vcx1qa_p_v16qi */

    default:
      return -1;
    }
}

 int
recog_262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 102:
      return recog_243 (x1, insn, pnum_clobbers);

    case 47:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 192; /* arm_qadd8 */

    case 48:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 193; /* arm_qsub8 */

    case 49:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 194; /* arm_shadd8 */

    case 50:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 195; /* arm_shsub8 */

    case 51:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 196; /* arm_uhadd8 */

    case 52:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 197; /* arm_uhsub8 */

    case 53:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 198; /* arm_uqadd8 */

    case 54:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 199; /* arm_uqsub8 */

    case 55:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 200; /* arm_qadd16 */

    case 56:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 201; /* arm_qasx */

    case 57:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 202; /* arm_qsax */

    case 58:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 203; /* arm_qsub16 */

    case 59:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 204; /* arm_shadd16 */

    case 60:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 205; /* arm_shasx */

    case 61:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 206; /* arm_shsax */

    case 62:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 207; /* arm_shsub16 */

    case 63:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 208; /* arm_uhadd16 */

    case 64:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 209; /* arm_uhasx */

    case 65:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 210; /* arm_uhsax */

    case 66:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 211; /* arm_uhsub16 */

    case 67:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 212; /* arm_uqadd16 */

    case 68:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 213; /* arm_uqasx */

    case 69:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 214; /* arm_uqsax */

    case 70:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 215; /* arm_uqsub16 */

    case 71:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 216; /* arm_smusd */

    case 72:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 217; /* arm_smusdx */

    case 43:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 218; /* arm_sxtab16 */

    case 44:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 219; /* arm_uxtab16 */

    case 73:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 220; /* arm_usad8 */

    case 98:
      if (pattern122 (x1) != 0
          || !
#line 6139 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 246; /* arm_smuad_insn */

    case 99:
      if (pattern122 (x1) != 0
          || !
#line 6139 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 248; /* arm_smuadx_insn */

    case 100:
      return recog_242 (x1, insn, pnum_clobbers);

    case 101:
      return recog_241 (x1, insn, pnum_clobbers);

    case 27:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!
#line 6690 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(flag_pic))
        return -1;
      return 258; /* pic_load_addr_unified */

    case 42:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 289; /* restore_pic_register_after_call */

    case 3:
      return recog_223 (x1, insn, pnum_clobbers);

    case 123:
      if (pattern123 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 429; /* arm_crc32b */

    case 124:
      if (pattern123 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 430; /* arm_crc32h */

    case 125:
      if (pattern122 (x1) != 0
          || !
#line 12806 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 431; /* arm_crc32w */

    case 126:
      if (pattern123 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 432; /* arm_crc32cb */

    case 127:
      if (pattern123 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 433; /* arm_crc32ch */

    case 128:
      if (pattern122 (x1) != 0
          || !
#line 12806 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 434; /* arm_crc32cw */

    case 107:
      if (pattern124 (x1) != 0
          || !
#line 13100 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_arch8m_main))
        return -1;
      return 514; /* pac_nop */

    case 462:
      return recog_222 (x1, insn, pnum_clobbers);

    case 463:
      return recog_221 (x1, insn, pnum_clobbers);

    case 13:
      if (pattern127 (x1, 
E_V4HImode, 
E_DImode) != 0
          || !
#line 528 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 574; /* iwmmxt_wmacsz */

    case 14:
      if (pattern127 (x1, 
E_V4HImode, 
E_DImode) != 0
          || !
#line 549 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 576; /* iwmmxt_wmacuz */

    case 6:
      return recog_240 (x1, insn, pnum_clobbers);

    case 10:
      return recog_186 (x1, insn, pnum_clobbers);

    case 113:
      if (pattern128 (x1, 
E_V4HImode) != 0
          || !
#line 371 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 710; /* iwmmxt_wqmulm */

    case 112:
      if (pattern128 (x1, 
E_V2SImode) != 0
          || !
#line 381 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 711; /* iwmmxt_wqmulwm */

    case 111:
      if (pattern128 (x1, 
E_V4HImode) != 0
          || !
#line 391 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 712; /* iwmmxt_wqmulmr */

    case 110:
      if (pattern128 (x1, 
E_V2SImode) != 0
          || !
#line 401 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 713; /* iwmmxt_wqmulwmr */

    case 299:
      return recog_158 (x1, insn, pnum_clobbers);

    case 179:
      if (pattern129 (x1) != 0
          || !
#line 1982 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 880; /* neon_vcvths_nsi_unspec */

    case 180:
      if (pattern129 (x1) != 0
          || !
#line 1982 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 881; /* neon_vcvthu_nsi_unspec */

    case 219:
      return recog_197 (x1, insn, pnum_clobbers);

    case 222:
      return recog_198 (x1, insn, pnum_clobbers);

    case 104:
      return recog_148 (x1, insn, pnum_clobbers);

    case 21:
      return recog_220 (x1, insn, pnum_clobbers);

    case 121:
      return recog_196 (x1, insn, pnum_clobbers);

    case 122:
      return recog_195 (x1, insn, pnum_clobbers);

    case 250:
      return recog_157 (x1, insn, pnum_clobbers);

    case 258:
      return recog_239 (x1, insn, pnum_clobbers);

    case 257:
      return recog_238 (x1, insn, pnum_clobbers);

    case 260:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 1402 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1448; /* neon_vpuminv8qi */

        case 1:
          if (!
#line 1402 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1449; /* neon_vpuminv4hi */

        case 2:
          if (!
#line 1402 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1450; /* neon_vpuminv2si */

        default:
          return -1;
        }

    case 259:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 1412 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1451; /* neon_vpumaxv8qi */

        case 1:
          if (!
#line 1412 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1452; /* neon_vpumaxv4hi */

        case 2:
          if (!
#line 1412 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1453; /* neon_vpumaxv2si */

        default:
          return -1;
        }

    case 153:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 1555 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1470; /* neon_vaddv2sf_unspec */

        case 1:
          if (!
#line 1555 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1471; /* neon_vaddv4sf_unspec */

        default:
          return -1;
        }

    case 156:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 1568 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1472; /* neon_vaddlsv8qi */

        case 1:
          if (!
#line 1568 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1474; /* neon_vaddlsv4hi */

        case 2:
          if (!
#line 1568 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1476; /* neon_vaddlsv2si */

        default:
          return -1;
        }

    case 157:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 1568 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1473; /* neon_vaddluv8qi */

        case 1:
          if (!
#line 1568 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1475; /* neon_vaddluv4hi */

        case 2:
          if (!
#line 1568 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1477; /* neon_vaddluv2si */

        default:
          return -1;
        }

    case 158:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 1578 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1478; /* neon_vaddwsv8qi */

        case 1:
          if (!
#line 1578 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1480; /* neon_vaddwsv4hi */

        case 2:
          if (!
#line 1578 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1482; /* neon_vaddwsv2si */

        default:
          return -1;
        }

    case 159:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 1578 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1479; /* neon_vaddwuv8qi */

        case 1:
          if (!
#line 1578 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1481; /* neon_vaddwuv4hi */

        case 2:
          if (!
#line 1578 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1483; /* neon_vaddwuv2si */

        default:
          return -1;
        }

    case 194:
      return recog_219 (x1, insn, pnum_clobbers);

    case 195:
      return recog_218 (x1, insn, pnum_clobbers);

    case 192:
      return recog_217 (x1, insn, pnum_clobbers);

    case 193:
      return recog_216 (x1, insn, pnum_clobbers);

    case 262:
      return recog_185 (x1, insn, pnum_clobbers);

    case 263:
      return recog_184 (x1, insn, pnum_clobbers);

    case 154:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 1610 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1524; /* neon_vaddhnv8hi */

        case 1:
          if (!
#line 1610 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1526; /* neon_vaddhnv4si */

        case 2:
          if (!
#line 1610 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1528; /* neon_vaddhnv2di */

        default:
          return -1;
        }

    case 155:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 1610 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1525; /* neon_vraddhnv8hi */

        case 1:
          if (!
#line 1610 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1527; /* neon_vraddhnv4si */

        case 2:
          if (!
#line 1610 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1529; /* neon_vraddhnv2di */

        default:
          return -1;
        }

    case 241:
      return recog_183 (x1, insn, pnum_clobbers);

    case 268:
      return recog_237 (x1, insn, pnum_clobbers);

    case 270:
      return recog_236 (x1, insn, pnum_clobbers);

    case 243:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2224 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1608; /* neon_vmullsv8qi */

        case 1:
          if (!
#line 2224 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1611; /* neon_vmullsv4hi */

        case 2:
          if (!
#line 2224 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1614; /* neon_vmullsv2si */

        default:
          return -1;
        }

    case 244:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2224 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1609; /* neon_vmulluv8qi */

        case 1:
          if (!
#line 2224 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1612; /* neon_vmulluv4hi */

        case 2:
          if (!
#line 2224 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1615; /* neon_vmulluv2si */

        default:
          return -1;
        }

    case 242:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2224 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1610; /* neon_vmullpv8qi */

        case 1:
          if (!
#line 2224 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1613; /* neon_vmullpv4hi */

        case 2:
          if (!
#line 2224 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1616; /* neon_vmullpv2si */

        default:
          return -1;
        }

    case 272:
      switch (pattern141 (x1, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2234 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1617; /* neon_vqdmullv4hi */

        case 1:
          if (!
#line 2234 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1618; /* neon_vqdmullv2si */

        default:
          return -1;
        }

    case 336:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2260 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1619; /* neon_vsubv2sf_unspec */

        case 1:
          if (!
#line 2260 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1620; /* neon_vsubv4sf_unspec */

        default:
          return -1;
        }

    case 339:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2273 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1621; /* neon_vsublsv8qi */

        case 1:
          if (!
#line 2273 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1623; /* neon_vsublsv4hi */

        case 2:
          if (!
#line 2273 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1625; /* neon_vsublsv2si */

        default:
          return -1;
        }

    case 340:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2273 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1622; /* neon_vsubluv8qi */

        case 1:
          if (!
#line 2273 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1624; /* neon_vsubluv4hi */

        case 2:
          if (!
#line 2273 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1626; /* neon_vsubluv2si */

        default:
          return -1;
        }

    case 341:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 2283 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1627; /* neon_vsubwsv8qi */

        case 1:
          if (!
#line 2283 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1629; /* neon_vsubwsv4hi */

        case 2:
          if (!
#line 2283 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1631; /* neon_vsubwsv2si */

        default:
          return -1;
        }

    case 342:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 2283 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1628; /* neon_vsubwuv8qi */

        case 1:
          if (!
#line 2283 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1630; /* neon_vsubwuv4hi */

        case 2:
          if (!
#line 2283 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1632; /* neon_vsubwuv2si */

        default:
          return -1;
        }

    case 291:
      return recog_182 (x1, insn, pnum_clobbers);

    case 292:
      return recog_181 (x1, insn, pnum_clobbers);

    case 196:
      return recog_215 (x1, insn, pnum_clobbers);

    case 197:
      return recog_214 (x1, insn, pnum_clobbers);

    case 337:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 2313 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1661; /* neon_vsubhnv8hi */

        case 1:
          if (!
#line 2313 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1663; /* neon_vsubhnv4si */

        case 2:
          if (!
#line 2313 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1665; /* neon_vsubhnv2di */

        default:
          return -1;
        }

    case 338:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 2313 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1662; /* neon_vrsubhnv8hi */

        case 1:
          if (!
#line 2313 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1664; /* neon_vrsubhnv4si */

        case 2:
          if (!
#line 2313 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1666; /* neon_vrsubhnv2di */

        default:
          return -1;
        }

    case 165:
      return recog_235 (x1, insn, pnum_clobbers);

    case 168:
      return recog_233 (x1, insn, pnum_clobbers);

    case 166:
      return recog_234 (x1, insn, pnum_clobbers);

    case 354:
      return recog_232 (x1, insn, pnum_clobbers);

    case 353:
      return recog_231 (x1, insn, pnum_clobbers);

    case 161:
      return recog_230 (x1, insn, pnum_clobbers);

    case 162:
      return recog_229 (x1, insn, pnum_clobbers);

    case 163:
      return recog_228 (x1, insn, pnum_clobbers);

    case 164:
      return recog_227 (x1, insn, pnum_clobbers);

    case 149:
      return recog_213 (x1, insn, pnum_clobbers);

    case 150:
      return recog_212 (x1, insn, pnum_clobbers);

    case 148:
      return recog_180 (x1, insn, pnum_clobbers);

    case 151:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2623 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1803; /* neon_vabdlsv8qi */

        case 1:
          if (!
#line 2623 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1805; /* neon_vabdlsv4hi */

        case 2:
          if (!
#line 2623 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1807; /* neon_vabdlsv2si */

        default:
          return -1;
        }

    case 152:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2623 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1804; /* neon_vabdluv8qi */

        case 1:
          if (!
#line 2623 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1806; /* neon_vabdluv4hi */

        case 2:
          if (!
#line 2623 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1808; /* neon_vabdluv2si */

        default:
          return -1;
        }

    case 217:
      return recog_156 (x1, insn, pnum_clobbers);

    case 218:
      return recog_211 (x1, insn, pnum_clobbers);

    case 220:
      return recog_155 (x1, insn, pnum_clobbers);

    case 221:
      return recog_209 (x1, insn, pnum_clobbers);

    case 253:
      return recog_210 (x1, insn, pnum_clobbers);

    case 255:
      return recog_208 (x1, insn, pnum_clobbers);

    case 248:
      return recog_207 (x1, insn, pnum_clobbers);

    case 249:
      return recog_206 (x1, insn, pnum_clobbers);

    case 254:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2776 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1894; /* neon_vpmaxuv8qi */

        case 1:
          if (!
#line 2776 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1898; /* neon_vpmaxuv4hi */

        case 2:
          if (!
#line 2776 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1902; /* neon_vpmaxuv2si */

        default:
          return -1;
        }

    case 256:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2776 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1896; /* neon_vpminuv8qi */

        case 1:
          if (!
#line 2776 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1900; /* neon_vpminuv4hi */

        case 2:
          if (!
#line 2776 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1904; /* neon_vpminuv2si */

        default:
          return -1;
        }

    case 294:
      return recog_179 (x1, insn, pnum_clobbers);

    case 376:
      return recog_142 (x1, insn, pnum_clobbers);

    case 377:
      return recog_141 (x1, insn, pnum_clobbers);

    case 175:
      return recog_178 (x1, insn, pnum_clobbers);

    case 176:
      return recog_177 (x1, insn, pnum_clobbers);

    case 300:
      return recog_176 (x1, insn, pnum_clobbers);

    case 301:
      return recog_175 (x1, insn, pnum_clobbers);

    case 302:
      return recog_174 (x1, insn, pnum_clobbers);

    case 303:
      return recog_173 (x1, insn, pnum_clobbers);

    case 278:
      return recog_172 (x1, insn, pnum_clobbers);

    case 279:
      return recog_171 (x1, insn, pnum_clobbers);

    case 280:
      return recog_170 (x1, insn, pnum_clobbers);

    case 281:
      return recog_169 (x1, insn, pnum_clobbers);

    case 307:
      return recog_168 (x1, insn, pnum_clobbers);

    case 308:
      return recog_167 (x1, insn, pnum_clobbers);

    case 309:
      return recog_166 (x1, insn, pnum_clobbers);

    case 310:
      return recog_165 (x1, insn, pnum_clobbers);

    case 311:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4534 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2371; /* neon_vshrn_nv8hi */

        case 1:
          if (!
#line 4534 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2373; /* neon_vshrn_nv4si */

        case 2:
          if (!
#line 4534 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2375; /* neon_vshrn_nv2di */

        default:
          return -1;
        }

    case 312:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4534 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2372; /* neon_vrshrn_nv8hi */

        case 1:
          if (!
#line 4534 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2374; /* neon_vrshrn_nv4si */

        case 2:
          if (!
#line 4534 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2376; /* neon_vrshrn_nv2di */

        default:
          return -1;
        }

    case 285:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2377; /* neon_vqshrns_nv8hi */

        case 1:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2381; /* neon_vqshrns_nv4si */

        case 2:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2385; /* neon_vqshrns_nv2di */

        default:
          return -1;
        }

    case 286:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2378; /* neon_vqshrnu_nv8hi */

        case 1:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2382; /* neon_vqshrnu_nv4si */

        case 2:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2386; /* neon_vqshrnu_nv2di */

        default:
          return -1;
        }

    case 287:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2379; /* neon_vqrshrns_nv8hi */

        case 1:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2383; /* neon_vqrshrns_nv4si */

        case 2:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2387; /* neon_vqrshrns_nv2di */

        default:
          return -1;
        }

    case 288:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2380; /* neon_vqrshrnu_nv8hi */

        case 1:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2384; /* neon_vqrshrnu_nv4si */

        case 2:
          if (!
#line 4548 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2388; /* neon_vqrshrnu_nv2di */

        default:
          return -1;
        }

    case 289:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2389; /* neon_vqshrun_nv8hi */

        case 1:
          if (!
#line 4562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2391; /* neon_vqshrun_nv4si */

        case 2:
          if (!
#line 4562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2393; /* neon_vqshrun_nv2di */

        default:
          return -1;
        }

    case 290:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2390; /* neon_vqrshrun_nv8hi */

        case 1:
          if (!
#line 4562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2392; /* neon_vqrshrun_nv4si */

        case 2:
          if (!
#line 4562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2394; /* neon_vqrshrun_nv2di */

        default:
          return -1;
        }

    case 306:
      return recog_164 (x1, insn, pnum_clobbers);

    case 282:
      return recog_163 (x1, insn, pnum_clobbers);

    case 283:
      return recog_162 (x1, insn, pnum_clobbers);

    case 284:
      return recog_161 (x1, insn, pnum_clobbers);

    case 304:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 4614 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2427; /* neon_vshlls_nv8qi */

        case 1:
          if (!
#line 4614 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2429; /* neon_vshlls_nv4hi */

        case 2:
          if (!
#line 4614 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2431; /* neon_vshlls_nv2si */

        default:
          return -1;
        }

    case 305:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 4614 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2428; /* neon_vshllu_nv8qi */

        case 1:
          if (!
#line 4614 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2430; /* neon_vshllu_nv4hi */

        case 2:
          if (!
#line 4614 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2432; /* neon_vshllu_nv2si */

        default:
          return -1;
        }

    case 343:
      return recog_144 (x1, insn, pnum_clobbers);

    case 171:
      if (pattern154 (x1, 
E_V16QImode, 
E_OImode) != 0
          || !
#line 4814 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2487; /* neon_vcombinev16qi */

    case 198:
      return recog_136 (x1, insn, pnum_clobbers);

    case 199:
      return recog_194 (x1, insn, pnum_clobbers);

    case 201:
      return recog_193 (x1, insn, pnum_clobbers);

    case 319:
      return recog_135 (x1, insn, pnum_clobbers);

    case 320:
      return recog_146 (x1, insn, pnum_clobbers);

    case 321:
      return recog_145 (x1, insn, pnum_clobbers);

    case 322:
      return recog_192 (x1, insn, pnum_clobbers);

    case 323:
      return recog_191 (x1, insn, pnum_clobbers);

    case 324:
      return recog_134 (x1, insn, pnum_clobbers);

    case 204:
      return recog_140 (x1, insn, pnum_clobbers);

    case 205:
      return recog_137 (x1, insn, pnum_clobbers);

    case 325:
      return recog_139 (x1, insn, pnum_clobbers);

    case 207:
      return recog_190 (x1, insn, pnum_clobbers);

    case 208:
      return recog_205 (x1, insn, pnum_clobbers);

    case 210:
      return recog_149 (x1, insn, pnum_clobbers);

    case 327:
      return recog_189 (x1, insn, pnum_clobbers);

    case 328:
      return recog_204 (x1, insn, pnum_clobbers);

    case 329:
      return recog_203 (x1, insn, pnum_clobbers);

    case 212:
      return recog_188 (x1, insn, pnum_clobbers);

    case 213:
      return recog_202 (x1, insn, pnum_clobbers);

    case 215:
      return recog_138 (x1, insn, pnum_clobbers);

    case 331:
      return recog_187 (x1, insn, pnum_clobbers);

    case 332:
      return recog_201 (x1, insn, pnum_clobbers);

    case 333:
      return recog_200 (x1, insn, pnum_clobbers);

    case 393:
      return recog_226 (x1, insn, pnum_clobbers);

    case 139:
      if (pattern128 (x1, 
E_V4SImode) != 0
          || !
#line 213 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3056; /* crypto_sha1su1 */

    case 142:
      if (pattern128 (x1, 
E_V4SImode) != 0
          || !
#line 213 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3057; /* crypto_sha256su0 */

    case 144:
      if (pattern127 (x1, 
E_DImode, 
E_TImode) != 0
          || !
#line 262 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3063; /* crypto_vmullp64 */

    case 397:
      return recog_154 (x1, insn, pnum_clobbers);

    case 452:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      switch (pattern112 (x2))
        {
        case 0:
          if (!
#line 496 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3360; /* mve_vbrsrq_n_fv8hf */

        case 1:
          if (!
#line 496 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3361; /* mve_vbrsrq_n_fv4sf */

        default:
          return -1;
        }

    case 450:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3362; /* mve_vcvtq_n_to_f_sv8hf */

        case 1:
          if (!
#line 512 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3364; /* mve_vcvtq_n_to_f_sv4sf */

        default:
          return -1;
        }

    case 451:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3363; /* mve_vcvtq_n_to_f_uv8hf */

        case 1:
          if (!
#line 512 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3365; /* mve_vcvtq_n_to_f_uv4sf */

        default:
          return -1;
        }

    case 449:
      return recog_160 (x1, insn, pnum_clobbers);

    case 454:
      return recog_225 (x1, insn, pnum_clobbers);

    case 455:
      return recog_224 (x1, insn, pnum_clobbers);

    case 496:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3376; /* mve_vrshrq_n_sv16qi */

        case 1:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3380; /* mve_vrshrq_n_sv8hi */

        case 2:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3384; /* mve_vrshrq_n_sv4si */

        default:
          return -1;
        }

    case 533:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3377; /* mve_vrshrq_n_uv16qi */

        case 1:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3381; /* mve_vrshrq_n_uv8hi */

        case 2:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3385; /* mve_vrshrq_n_uv4si */

        default:
          return -1;
        }

    case 456:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3378; /* mve_vshrq_n_sv16qi */

        case 1:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3382; /* mve_vshrq_n_sv8hi */

        case 2:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3386; /* mve_vshrq_n_sv4si */

        default:
          return -1;
        }

    case 457:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3379; /* mve_vshrq_n_uv16qi */

        case 1:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3383; /* mve_vshrq_n_uv8hi */

        case 2:
          if (!
#line 559 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3387; /* mve_vshrq_n_uv4si */

        default:
          return -1;
        }

    case 458:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 610 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3394; /* mve_vcvtq_n_from_f_sv8hi */

        case 1:
          if (!
#line 610 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3396; /* mve_vcvtq_n_from_f_sv4si */

        default:
          return -1;
        }

    case 459:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 610 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3395; /* mve_vcvtq_n_from_f_uv8hi */

        case 1:
          if (!
#line 610 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3397; /* mve_vcvtq_n_from_f_uv4si */

        default:
          return -1;
        }

    case 460:
      if (pattern172 (x1) != 0
          || !
#line 626 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3398; /* mve_vaddlvq_p_sv4si */

    case 461:
      if (pattern172 (x1) != 0
          || !
#line 626 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3399; /* mve_vaddlvq_p_uv4si */

    case 464:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3448; /* mve_vabdq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3472; /* mve_vabdq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3496; /* mve_vabdq_sv4si */

        default:
          return -1;
        }

    case 501:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3449; /* mve_vabdq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3473; /* mve_vabdq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3497; /* mve_vabdq_uv4si */

        default:
          return -1;
        }

    case 469:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3450; /* mve_vhaddq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3474; /* mve_vhaddq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3498; /* mve_vhaddq_sv4si */

        default:
          return -1;
        }

    case 506:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3451; /* mve_vhaddq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3475; /* mve_vhaddq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3499; /* mve_vhaddq_uv4si */

        default:
          return -1;
        }

    case 471:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3452; /* mve_vhsubq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3476; /* mve_vhsubq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3500; /* mve_vhsubq_sv4si */

        default:
          return -1;
        }

    case 508:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3453; /* mve_vhsubq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3477; /* mve_vhsubq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3501; /* mve_vhsubq_uv4si */

        default:
          return -1;
        }

    case 478:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3454; /* mve_vmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3478; /* mve_vmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3502; /* mve_vmulhq_sv4si */

        default:
          return -1;
        }

    case 515:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3455; /* mve_vmulhq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3479; /* mve_vmulhq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3503; /* mve_vmulhq_uv4si */

        default:
          return -1;
        }

    case 483:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3456; /* mve_vqaddq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3480; /* mve_vqaddq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3504; /* mve_vqaddq_sv4si */

        default:
          return -1;
        }

    case 520:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3457; /* mve_vqaddq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3481; /* mve_vqaddq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3505; /* mve_vqaddq_uv4si */

        default:
          return -1;
        }

    case 548:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3458; /* mve_vqdmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3482; /* mve_vqdmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3506; /* mve_vqdmulhq_sv4si */

        default:
          return -1;
        }

    case 550:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3459; /* mve_vqrdmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3483; /* mve_vqrdmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3507; /* mve_vqrdmulhq_sv4si */

        default:
          return -1;
        }

    case 485:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3460; /* mve_vqrshlq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3484; /* mve_vqrshlq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3508; /* mve_vqrshlq_sv4si */

        default:
          return -1;
        }

    case 522:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3461; /* mve_vqrshlq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3485; /* mve_vqrshlq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3509; /* mve_vqrshlq_uv4si */

        default:
          return -1;
        }

    case 487:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3462; /* mve_vqshlq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3486; /* mve_vqshlq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3510; /* mve_vqshlq_sv4si */

        default:
          return -1;
        }

    case 524:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3463; /* mve_vqshlq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3487; /* mve_vqshlq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3511; /* mve_vqshlq_uv4si */

        default:
          return -1;
        }

    case 490:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3464; /* mve_vqsubq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3488; /* mve_vqsubq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3512; /* mve_vqsubq_sv4si */

        default:
          return -1;
        }

    case 527:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3465; /* mve_vqsubq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3489; /* mve_vqsubq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3513; /* mve_vqsubq_uv4si */

        default:
          return -1;
        }

    case 492:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3466; /* mve_vrhaddq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3490; /* mve_vrhaddq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3514; /* mve_vrhaddq_sv4si */

        default:
          return -1;
        }

    case 529:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3467; /* mve_vrhaddq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3491; /* mve_vrhaddq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3515; /* mve_vrhaddq_uv4si */

        default:
          return -1;
        }

    case 493:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3468; /* mve_vrmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3492; /* mve_vrmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3516; /* mve_vrmulhq_sv4si */

        default:
          return -1;
        }

    case 530:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3469; /* mve_vrmulhq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3493; /* mve_vrmulhq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3517; /* mve_vrmulhq_uv4si */

        default:
          return -1;
        }

    case 494:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3470; /* mve_vrshlq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3494; /* mve_vrshlq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3518; /* mve_vrshlq_sv4si */

        default:
          return -1;
        }

    case 531:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3471; /* mve_vrshlq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3495; /* mve_vrshlq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3519; /* mve_vrshlq_uv4si */

        default:
          return -1;
        }

    case 465:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3520; /* mve_vaddq_n_sv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3526; /* mve_vaddq_n_sv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3532; /* mve_vaddq_n_sv4si */

        default:
          return -1;
        }

    case 502:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3521; /* mve_vaddq_n_uv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3527; /* mve_vaddq_n_uv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3533; /* mve_vaddq_n_uv4si */

        default:
          return -1;
        }

    case 482:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3522; /* mve_vmulq_n_sv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3528; /* mve_vmulq_n_sv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3534; /* mve_vmulq_n_sv4si */

        default:
          return -1;
        }

    case 519:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3523; /* mve_vmulq_n_uv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3529; /* mve_vmulq_n_uv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3535; /* mve_vmulq_n_uv4si */

        default:
          return -1;
        }

    case 500:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3524; /* mve_vsubq_n_sv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3530; /* mve_vsubq_n_sv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3536; /* mve_vsubq_n_sv4si */

        default:
          return -1;
        }

    case 537:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3525; /* mve_vsubq_n_uv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3531; /* mve_vsubq_n_uv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3537; /* mve_vsubq_n_uv4si */

        default:
          return -1;
        }

    case 466:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 723 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3538; /* mve_vaddvaq_sv16qi */

        case 1:
          if (!
#line 723 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3540; /* mve_vaddvaq_sv8hi */

        case 2:
          if (!
#line 723 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3542; /* mve_vaddvaq_sv4si */

        default:
          return -1;
        }

    case 503:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 723 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3539; /* mve_vaddvaq_uv16qi */

        case 1:
          if (!
#line 723 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3541; /* mve_vaddvaq_uv8hi */

        case 2:
          if (!
#line 723 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3543; /* mve_vaddvaq_uv4si */

        default:
          return -1;
        }

    case 504:
      switch (pattern176 (x1))
        {
        case 0:
          if (!
#line 740 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3544; /* mve_vaddvq_p_uv16qi */

        case 1:
          if (!
#line 740 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3546; /* mve_vaddvq_p_uv8hi */

        case 2:
          if (!
#line 740 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3548; /* mve_vaddvq_p_uv4si */

        default:
          return -1;
        }

    case 467:
      switch (pattern176 (x1))
        {
        case 0:
          if (!
#line 740 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3545; /* mve_vaddvq_p_sv16qi */

        case 1:
          if (!
#line 740 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3547; /* mve_vaddvq_p_sv8hi */

        case 2:
          if (!
#line 740 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3549; /* mve_vaddvq_p_sv4si */

        default:
          return -1;
        }

    case 505:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 811 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3556; /* mve_vbrsrq_n_uv16qi */

        case 1:
          if (!
#line 811 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3558; /* mve_vbrsrq_n_uv8hi */

        case 2:
          if (!
#line 811 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3560; /* mve_vbrsrq_n_uv4si */

        default:
          return -1;
        }

    case 468:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 811 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3557; /* mve_vbrsrq_n_sv16qi */

        case 1:
          if (!
#line 811 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3559; /* mve_vbrsrq_n_sv8hi */

        case 2:
          if (!
#line 811 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3561; /* mve_vbrsrq_n_sv4si */

        default:
          return -1;
        }

    case 539:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3564; /* mve_vhcaddq_rot90_sv16qi */

        case 1:
          if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3568; /* mve_vhcaddq_rot90_sv8hi */

        case 2:
          if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3572; /* mve_vhcaddq_rot90_sv4si */

        default:
          return -1;
        }

    case 538:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3565; /* mve_vhcaddq_rot270_sv16qi */

        case 1:
          if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3569; /* mve_vhcaddq_rot270_sv8hi */

        case 2:
          if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3573; /* mve_vhcaddq_rot270_sv4si */

        default:
          return -1;
        }

    case 470:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3577; /* mve_vhaddq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3587; /* mve_vhaddq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3597; /* mve_vhaddq_n_sv4si */

        default:
          return -1;
        }

    case 507:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3578; /* mve_vhaddq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3588; /* mve_vhaddq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3598; /* mve_vhaddq_n_uv4si */

        default:
          return -1;
        }

    case 472:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3579; /* mve_vhsubq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3589; /* mve_vhsubq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3599; /* mve_vhsubq_n_sv4si */

        default:
          return -1;
        }

    case 509:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3580; /* mve_vhsubq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3590; /* mve_vhsubq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3600; /* mve_vhsubq_n_uv4si */

        default:
          return -1;
        }

    case 484:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3581; /* mve_vqaddq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3591; /* mve_vqaddq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3601; /* mve_vqaddq_n_sv4si */

        default:
          return -1;
        }

    case 521:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3582; /* mve_vqaddq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3592; /* mve_vqaddq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3602; /* mve_vqaddq_n_uv4si */

        default:
          return -1;
        }

    case 547:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3583; /* mve_vqdmulhq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3593; /* mve_vqdmulhq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3603; /* mve_vqdmulhq_n_sv4si */

        default:
          return -1;
        }

    case 549:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3584; /* mve_vqrdmulhq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3594; /* mve_vqrdmulhq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3604; /* mve_vqrdmulhq_n_sv4si */

        default:
          return -1;
        }

    case 491:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3585; /* mve_vqsubq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3595; /* mve_vqsubq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3605; /* mve_vqsubq_n_sv4si */

        default:
          return -1;
        }

    case 528:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3586; /* mve_vqsubq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3596; /* mve_vqsubq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3606; /* mve_vqsubq_n_uv4si */

        default:
          return -1;
        }

    case 540:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 900 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3607; /* mve_vmaxaq_sv16qi */

        case 1:
          if (!
#line 900 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3609; /* mve_vmaxaq_sv8hi */

        case 2:
          if (!
#line 900 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3611; /* mve_vmaxaq_sv4si */

        default:
          return -1;
        }

    case 542:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 900 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3608; /* mve_vminaq_sv16qi */

        case 1:
          if (!
#line 900 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3610; /* mve_vminaq_sv8hi */

        case 2:
          if (!
#line 900 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3612; /* mve_vminaq_sv4si */

        default:
          return -1;
        }

    case 541:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3625; /* mve_vmaxavq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3631; /* mve_vmaxavq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3637; /* mve_vmaxavq_sv4si */

        default:
          return -1;
        }

    case 474:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3626; /* mve_vmaxvq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3632; /* mve_vmaxvq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3638; /* mve_vmaxvq_sv4si */

        default:
          return -1;
        }

    case 511:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3627; /* mve_vmaxvq_uv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3633; /* mve_vmaxvq_uv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3639; /* mve_vmaxvq_uv4si */

        default:
          return -1;
        }

    case 543:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3628; /* mve_vminavq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3634; /* mve_vminavq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3640; /* mve_vminavq_sv4si */

        default:
          return -1;
        }

    case 476:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3629; /* mve_vminvq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3635; /* mve_vminvq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3641; /* mve_vminvq_sv4si */

        default:
          return -1;
        }

    case 513:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3630; /* mve_vminvq_uv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3636; /* mve_vminvq_uv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3642; /* mve_vminvq_uv4si */

        default:
          return -1;
        }

    case 477:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3643; /* mve_vmladavq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3648; /* mve_vmladavq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3653; /* mve_vmladavq_sv4si */

        default:
          return -1;
        }

    case 514:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3644; /* mve_vmladavq_uv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3649; /* mve_vmladavq_uv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3654; /* mve_vmladavq_uv4si */

        default:
          return -1;
        }

    case 544:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3645; /* mve_vmladavxq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3650; /* mve_vmladavxq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3655; /* mve_vmladavxq_sv4si */

        default:
          return -1;
        }

    case 545:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3646; /* mve_vmlsdavq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3651; /* mve_vmlsdavq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3656; /* mve_vmlsdavq_sv4si */

        default:
          return -1;
        }

    case 546:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3647; /* mve_vmlsdavxq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3652; /* mve_vmlsdavxq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3657; /* mve_vmlsdavxq_sv4si */

        default:
          return -1;
        }

    case 516:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3658; /* mve_vmullbq_int_uv16qi */

        case 1:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3662; /* mve_vmullbq_int_uv8hi */

        case 2:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3666; /* mve_vmullbq_int_uv4si */

        default:
          return -1;
        }

    case 479:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3659; /* mve_vmullbq_int_sv16qi */

        case 1:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3663; /* mve_vmullbq_int_sv8hi */

        case 2:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3667; /* mve_vmullbq_int_sv4si */

        default:
          return -1;
        }

    case 517:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3660; /* mve_vmulltq_int_uv16qi */

        case 1:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3664; /* mve_vmulltq_int_uv8hi */

        case 2:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3668; /* mve_vmulltq_int_uv4si */

        default:
          return -1;
        }

    case 480:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3661; /* mve_vmulltq_int_sv16qi */

        case 1:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3665; /* mve_vmulltq_int_sv8hi */

        case 2:
          if (!
#line 974 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3669; /* mve_vmulltq_int_sv4si */

        default:
          return -1;
        }

    case 486:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3685; /* mve_vqrshlq_n_sv16qi */

        case 1:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3689; /* mve_vqrshlq_n_sv8hi */

        case 2:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3693; /* mve_vqrshlq_n_sv4si */

        default:
          return -1;
        }

    case 523:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3686; /* mve_vqrshlq_n_uv16qi */

        case 1:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3690; /* mve_vqrshlq_n_uv8hi */

        case 2:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3694; /* mve_vqrshlq_n_uv4si */

        default:
          return -1;
        }

    case 495:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3687; /* mve_vrshlq_n_sv16qi */

        case 1:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3691; /* mve_vrshlq_n_sv8hi */

        case 2:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3695; /* mve_vrshlq_n_sv4si */

        default:
          return -1;
        }

    case 532:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3688; /* mve_vrshlq_n_uv16qi */

        case 1:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3692; /* mve_vrshlq_n_uv8hi */

        case 2:
          if (!
#line 1061 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3696; /* mve_vrshlq_n_uv4si */

        default:
          return -1;
        }

    case 488:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3697; /* mve_vqshlq_n_sv16qi */

        case 1:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3701; /* mve_vqshlq_n_sv8hi */

        case 2:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3705; /* mve_vqshlq_n_sv4si */

        default:
          return -1;
        }

    case 525:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3698; /* mve_vqshlq_n_uv16qi */

        case 1:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3702; /* mve_vqshlq_n_uv8hi */

        case 2:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3706; /* mve_vqshlq_n_uv4si */

        default:
          return -1;
        }

    case 497:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3699; /* mve_vshlq_n_sv16qi */

        case 1:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3703; /* mve_vshlq_n_sv8hi */

        case 2:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3707; /* mve_vshlq_n_sv4si */

        default:
          return -1;
        }

    case 534:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3700; /* mve_vshlq_n_uv16qi */

        case 1:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3704; /* mve_vshlq_n_uv8hi */

        case 2:
          if (!
#line 1078 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3708; /* mve_vshlq_n_uv4si */

        default:
          return -1;
        }

    case 489:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3709; /* mve_vqshlq_r_sv16qi */

        case 1:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3713; /* mve_vqshlq_r_sv8hi */

        case 2:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3717; /* mve_vqshlq_r_sv4si */

        default:
          return -1;
        }

    case 526:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3710; /* mve_vqshlq_r_uv16qi */

        case 1:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3714; /* mve_vqshlq_r_uv8hi */

        case 2:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3718; /* mve_vqshlq_r_uv4si */

        default:
          return -1;
        }

    case 498:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3711; /* mve_vshlq_r_sv16qi */

        case 1:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3715; /* mve_vshlq_r_sv8hi */

        case 2:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3719; /* mve_vshlq_r_sv4si */

        default:
          return -1;
        }

    case 535:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3712; /* mve_vshlq_r_uv16qi */

        case 1:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3716; /* mve_vshlq_r_uv8hi */

        case 2:
          if (!
#line 1095 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3720; /* mve_vshlq_r_uv4si */

        default:
          return -1;
        }

    case 551:
      return recog_199 (x1, insn, pnum_clobbers);

    case 554:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1127 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3724; /* mve_vabdq_fv8hf */

        case 1:
          if (!
#line 1127 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3725; /* mve_vabdq_fv4sf */

        default:
          return -1;
        }

    case 568:
      if (pattern123 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1143 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3726; /* mve_vaddlvaq_sv4si */

    case 567:
      if (pattern123 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1143 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3727; /* mve_vaddlvaq_uv4si */

    case 555:
      switch (pattern182 (x1))
        {
        case 0:
          if (!
#line 1162 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3728; /* mve_vaddq_n_fv8hf */

        case 1:
          if (!
#line 1162 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3731; /* mve_vaddq_n_fv4sf */

        default:
          return -1;
        }

    case 565:
      switch (pattern182 (x1))
        {
        case 0:
          if (!
#line 1162 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3729; /* mve_vmulq_n_fv8hf */

        case 1:
          if (!
#line 1162 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3732; /* mve_vmulq_n_fv4sf */

        default:
          return -1;
        }

    case 453:
      switch (pattern182 (x1))
        {
        case 0:
          if (!
#line 1162 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3730; /* mve_vsubq_n_fv8hf */

        case 1:
          if (!
#line 1162 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3733; /* mve_vsubq_n_fv4sf */

        default:
          return -1;
        }

    case 384:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3740; /* mve_vcmulq_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3746; /* mve_vcmulq_fv4sf */

        default:
          return -1;
        }

    case 385:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3741; /* mve_vcmulq_rot90_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3747; /* mve_vcmulq_rot90_fv4sf */

        default:
          return -1;
        }

    case 386:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3742; /* mve_vcmulq_rot180_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3748; /* mve_vcmulq_rot180_fv4sf */

        default:
          return -1;
        }

    case 387:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3743; /* mve_vcmulq_rot270_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3749; /* mve_vcmulq_rot270_fv4sf */

        default:
          return -1;
        }

    case 443:
      return recog_143 (x1, insn, pnum_clobbers);

    case 571:
      if (pattern123 (x1, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 1274 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3778; /* mve_vcvtbq_f16_f32v8hf */

    case 572:
      if (pattern123 (x1, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 1274 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3779; /* mve_vcvttq_f16_f32v8hf */

    case 556:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1306 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3782; /* mve_vmaxnmaq_fv8hf */

        case 1:
          if (!
#line 1306 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3784; /* mve_vmaxnmaq_fv4sf */

        default:
          return -1;
        }

    case 560:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1306 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3783; /* mve_vminnmaq_fv8hf */

        case 1:
          if (!
#line 1306 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3785; /* mve_vminnmaq_fv4sf */

        default:
          return -1;
        }

    case 557:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3786; /* mve_vmaxnmavq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3790; /* mve_vmaxnmavq_fv4sf */

        default:
          return -1;
        }

    case 559:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3787; /* mve_vmaxnmvq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3791; /* mve_vmaxnmvq_fv4sf */

        default:
          return -1;
        }

    case 561:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3788; /* mve_vminnmavq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3792; /* mve_vminnmavq_fv4sf */

        default:
          return -1;
        }

    case 563:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3789; /* mve_vminnmvq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3793; /* mve_vminnmvq_fv4sf */

        default:
          return -1;
        }

    case 575:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3798; /* mve_vmlaldavq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3803; /* mve_vmlaldavq_sv4si */

        default:
          return -1;
        }

    case 573:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3799; /* mve_vmlaldavq_uv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3804; /* mve_vmlaldavq_uv4si */

        default:
          return -1;
        }

    case 574:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3800; /* mve_vmlaldavxq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3805; /* mve_vmlaldavxq_sv4si */

        default:
          return -1;
        }

    case 576:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3801; /* mve_vmlsldavq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3806; /* mve_vmlsldavq_sv4si */

        default:
          return -1;
        }

    case 577:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3802; /* mve_vmlsldavxq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3807; /* mve_vmlsldavxq_sv4si */

        default:
          return -1;
        }

    case 579:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3808; /* mve_vmovnbq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3818; /* mve_vmovnbq_sv4si */

        default:
          return -1;
        }

    case 578:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3809; /* mve_vmovnbq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3819; /* mve_vmovnbq_uv4si */

        default:
          return -1;
        }

    case 581:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3810; /* mve_vmovntq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3820; /* mve_vmovntq_sv4si */

        default:
          return -1;
        }

    case 580:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3811; /* mve_vmovntq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3821; /* mve_vmovntq_uv4si */

        default:
          return -1;
        }

    case 589:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3812; /* mve_vqmovnbq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3822; /* mve_vqmovnbq_sv4si */

        default:
          return -1;
        }

    case 588:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3813; /* mve_vqmovnbq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3823; /* mve_vqmovnbq_uv4si */

        default:
          return -1;
        }

    case 600:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3814; /* mve_vqmovntq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3824; /* mve_vqmovntq_sv4si */

        default:
          return -1;
        }

    case 599:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3815; /* mve_vqmovntq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3825; /* mve_vqmovntq_uv4si */

        default:
          return -1;
        }

    case 590:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3816; /* mve_vqmovunbq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3826; /* mve_vqmovunbq_sv4si */

        default:
          return -1;
        }

    case 591:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3817; /* mve_vqmovuntq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3827; /* mve_vqmovuntq_sv4si */

        default:
          return -1;
        }

    case 570:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3838; /* mve_vbicq_n_sv8hi */

        case 1:
          if (!
#line 1446 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3842; /* mve_vbicq_n_sv4si */

        default:
          return -1;
        }

    case 569:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3839; /* mve_vbicq_n_uv8hi */

        case 1:
          if (!
#line 1446 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3843; /* mve_vbicq_n_uv4si */

        default:
          return -1;
        }

    case 582:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3840; /* mve_vorrq_n_sv8hi */

        case 1:
          if (!
#line 1446 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3844; /* mve_vorrq_n_sv4si */

        default:
          return -1;
        }

    case 583:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3841; /* mve_vorrq_n_uv8hi */

        case 1:
          if (!
#line 1446 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3845; /* mve_vorrq_n_uv4si */

        default:
          return -1;
        }

    case 584:
      switch (pattern188 (x1))
        {
        case 0:
          if (!
#line 1463 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3846; /* mve_vqdmullbq_n_sv8hi */

        case 1:
          if (!
#line 1463 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3848; /* mve_vqdmullbq_n_sv4si */

        default:
          return -1;
        }

    case 586:
      switch (pattern188 (x1))
        {
        case 0:
          if (!
#line 1463 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3847; /* mve_vqdmulltq_n_sv8hi */

        case 1:
          if (!
#line 1463 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3849; /* mve_vqdmulltq_n_sv4si */

        default:
          return -1;
        }

    case 585:
      switch (pattern141 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3850; /* mve_vqdmullbq_sv8hi */

        case 1:
          if (!
#line 1480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3852; /* mve_vqdmullbq_sv4si */

        default:
          return -1;
        }

    case 587:
      switch (pattern141 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3851; /* mve_vqdmulltq_sv8hi */

        case 1:
          if (!
#line 1480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3853; /* mve_vqdmulltq_sv4si */

        default:
          return -1;
        }

    case 606:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3854; /* mve_vrmlaldavhq_sv4si */

    case 605:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3855; /* mve_vrmlaldavhq_uv4si */

    case 592:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3856; /* mve_vrmlaldavhxq_sv4si */

    case 593:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3857; /* mve_vrmlsldavhq_sv4si */

    case 594:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3858; /* mve_vrmlsldavhxq_sv4si */

    case 601:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3859; /* mve_vshllbq_n_sv16qi */

        case 1:
          if (!
#line 1517 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3863; /* mve_vshllbq_n_sv8hi */

        default:
          return -1;
        }

    case 602:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3860; /* mve_vshllbq_n_uv16qi */

        case 1:
          if (!
#line 1517 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3864; /* mve_vshllbq_n_uv8hi */

        default:
          return -1;
        }

    case 604:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3861; /* mve_vshlltq_n_sv16qi */

        case 1:
          if (!
#line 1517 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3865; /* mve_vshlltq_n_sv8hi */

        default:
          return -1;
        }

    case 603:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3862; /* mve_vshlltq_n_uv16qi */

        case 1:
          if (!
#line 1517 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3866; /* mve_vshlltq_n_uv8hi */

        default:
          return -1;
        }

    case 608:
      switch (pattern190 (x1))
        {
        case 0:
          if (!
#line 1534 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3867; /* mve_vmullbq_poly_pv16qi */

        case 1:
          if (!
#line 1534 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3869; /* mve_vmullbq_poly_pv8hi */

        default:
          return -1;
        }

    case 607:
      switch (pattern190 (x1))
        {
        case 0:
          if (!
#line 1534 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3868; /* mve_vmulltq_poly_pv16qi */

        case 1:
          if (!
#line 1534 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3870; /* mve_vmulltq_poly_pv8hi */

        default:
          return -1;
        }

    case 1006:
      return recog_153 (x1, insn, pnum_clobbers);

    case 1008:
      return recog_159 (x1, insn, pnum_clobbers);

    case 1013:
      return recog_147 (x1, insn, pnum_clobbers);

    case 1059:
      return recog_152 (x1, insn, pnum_clobbers);

    case 1057:
      return recog_150 (x1, insn, pnum_clobbers);

    case 1058:
      return recog_151 (x1, insn, pnum_clobbers);

    case 1069:
      if (pattern192 (x1) != 0
          || !
#line 4274 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5025; /* mve_uqrshll_sat64_di */

    case 1070:
      if (pattern192 (x1) != 0
          || !
#line 4274 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5026; /* mve_uqrshll_sat48_di */

    case 1071:
      if (pattern192 (x1) != 0
          || !
#line 4286 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5027; /* mve_sqrshrl_sat64_di */

    case 1072:
      if (pattern192 (x1) != 0
          || !
#line 4286 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5028; /* mve_sqrshrl_sat48_di */

    case 1068:
      if (pattern193 (x1) != 0
          || !
#line 4298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5029; /* mve_uqrshl_si */

    case 1067:
      if (pattern193 (x1) != 0
          || !
#line 4310 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5030; /* mve_sqrshr_si */

    case 1066:
      if (pattern194 (x1) != 0
          || !
#line 4333 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5032; /* mve_urshrl_di */

    case 1065:
      if (pattern195 (x1, 
E_SImode) != 0
          || !
#line 4356 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5034; /* mve_urshr_si */

    case 1064:
      if (pattern195 (x1, 
E_DImode) != 0
          || !
#line 4379 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5036; /* mve_srshr_si */

    case 1063:
      if (pattern194 (x1) != 0
          || !
#line 4391 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5037; /* mve_srshrl_di */

    default:
      return -1;
    }
}

 int
recog_351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      x9 = XEXP (x6, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern559 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1365 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6935; /* *p fmasf4 */

            case E_DFmode:
              if (pattern559 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1365 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6936; /* *p fmadf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern560 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1423 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6939; /* *p *fnmsubsf4 */

            case E_DFmode:
              if (pattern560 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1423 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6940; /* *p *fnmsubdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      x9 = XEXP (x6, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern561 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1401 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6937; /* *p *fmsubsf4 */

            case E_DFmode:
              if (pattern561 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1401 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6938; /* *p *fmsubdf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern562 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1446 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6941; /* *p *fnmaddsf4 */

            case E_DFmode:
              if (pattern562 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1446 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6942; /* *p *fnmadddf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (s_register_operand (operands[0], E_SImode))
    {
      res = recog_359 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!low_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x4, 0, 1);
  if (pattern474 (x7) != 0)
    return -1;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  if (!shift_operator (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!low_register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  if (!low_reg_or_int_operand (operands[2], E_SImode)
      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1271 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && ((GET_CODE(operands[3]) != ROTATE && GET_CODE(operands[3]) != ROTATERT)
       || REG_P (operands[2])))))
    return -1;
  return 6987; /* *p *thumb2_shiftsi3_short */
}

 int
recog_368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XVECEXP (x2, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!memory_operand (operands[3], E_SImode)
      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 164 "../../gcc-15.1.0/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, true))))
    return -1;
  return 6620; /* *p *arm_ldrd */
}

 int
recog_372 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x1, 0);
  operands[6] = x10;
  x11 = XEXP (x10, 0);
  operands[7] = x11;
  x12 = XEXP (x3, 0);
  operands[5] = x12;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x13 = XEXP (x4, 0);
  if (!rtx_equal_p (x13, operands[5]))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 16L:
      switch (pattern597 (x6))
        {
        case 0:
          if (pattern619 (x2) != 0)
            return -1;
          x14 = XEXP (x9, 1);
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != PLUS
              || GET_MODE (x15) != E_SImode)
            return -1;
          x16 = XEXP (x15, 1);
          if (GET_CODE (x16) != CONST_INT
              || pattern642 (operands[0]) != 0)
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[5]))
            return -1;
          x20 = XEXP (x8, 1);
          x21 = XEXP (x20, 0);
          x22 = XEXP (x21, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x23 = XEXP (x15, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          switch (pattern647 (x2))
            {
            case 0:
              x24 = XEXP (x6, 1);
              x25 = XEXP (x24, 0);
              if (!rtx_equal_p (x25, operands[5]))
                return -1;
              x26 = XEXP (x18, 1);
              if (XWINT (x26, 0) != 4L)
                return -1;
              x27 = XEXP (x21, 1);
              if (XWINT (x27, 0) != 8L
                  || XWINT (x16, 0) != 12L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 74 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6623; /* *p *ldm4_ia_update */

            case 1:
              if (XWINT (x16, 0) != 16L)
                return -1;
              x24 = XEXP (x6, 1);
              x25 = XEXP (x24, 0);
              x28 = XEXP (x25, 0);
              if (!rtx_equal_p (x28, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 181 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6627; /* *p *ldm4_ib_update */

            default:
              return -1;
            }

        case 1:
          if (pattern621 (x2) != 0)
            return -1;
          x29 = XEXP (x9, 0);
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != PLUS
              || GET_MODE (x30) != E_SImode)
            return -1;
          x31 = XEXP (x30, 1);
          if (GET_CODE (x31) != CONST_INT
              || pattern648 (operands[0]) != 0)
            return -1;
          x32 = XEXP (x7, 0);
          x33 = XEXP (x32, 0);
          x34 = XEXP (x33, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x8, 0);
          x36 = XEXP (x35, 0);
          x37 = XEXP (x36, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          x38 = XEXP (x30, 0);
          if (!rtx_equal_p (x38, operands[5]))
            return -1;
          switch (pattern649 (x2))
            {
            case 0:
              x39 = XEXP (x6, 0);
              x40 = XEXP (x39, 0);
              if (!rtx_equal_p (x40, operands[5]))
                return -1;
              x41 = XEXP (x33, 1);
              if (XWINT (x41, 0) != 4L)
                return -1;
              x42 = XEXP (x36, 1);
              if (XWINT (x42, 0) != 8L
                  || XWINT (x31, 0) != 12L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 125 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6625; /* *p *stm4_ia_update */

            case 1:
              if (XWINT (x31, 0) != 16L)
                return -1;
              x39 = XEXP (x6, 0);
              x40 = XEXP (x39, 0);
              x43 = XEXP (x40, 0);
              if (!rtx_equal_p (x43, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 213 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6629; /* *p *stm4_ib_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case -16L:
      x24 = XEXP (x6, 1);
      switch (GET_CODE (x24))
        {
        case MEM:
          if (pattern546 (x24) != 0
              || pattern619 (x2) != 0
              || pattern642 (operands[0]) != 0)
            return -1;
          x25 = XEXP (x24, 0);
          x28 = XEXP (x25, 0);
          if (!rtx_equal_p (x28, operands[5]))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[5]))
            return -1;
          x20 = XEXP (x8, 1);
          x21 = XEXP (x20, 0);
          x22 = XEXP (x21, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x44 = XEXP (x25, 1);
          switch (XWINT (x44, 0))
            {
            case -12L:
              x26 = XEXP (x18, 1);
              if (XWINT (x26, 0) != -8L)
                return -1;
              x27 = XEXP (x21, 1);
              if (XWINT (x27, 0) != -4L)
                return -1;
              x14 = XEXP (x9, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 251 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6631; /* *p *ldm4_da_update */

            case -16L:
              x26 = XEXP (x18, 1);
              if (XWINT (x26, 0) != -12L)
                return -1;
              x27 = XEXP (x21, 1);
              if (XWINT (x27, 0) != -8L)
                return -1;
              x14 = XEXP (x9, 1);
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != PLUS
                  || GET_MODE (x15) != E_SImode)
                return -1;
              x16 = XEXP (x15, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x23 = XEXP (x15, 0);
              if (!rtx_equal_p (x23, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 323 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6635; /* *p *ldm4_db_update */

            default:
              return -1;
            }

        case REG:
          operands[1] = x24;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x39 = XEXP (x6, 0);
          if (pattern573 (x39) != 0
              || pattern621 (x2) != 0
              || pattern648 (operands[0]) != 0)
            return -1;
          x40 = XEXP (x39, 0);
          x43 = XEXP (x40, 0);
          if (!rtx_equal_p (x43, operands[5]))
            return -1;
          x32 = XEXP (x7, 0);
          x33 = XEXP (x32, 0);
          x34 = XEXP (x33, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x8, 0);
          x36 = XEXP (x35, 0);
          x37 = XEXP (x36, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          x45 = XEXP (x40, 1);
          switch (XWINT (x45, 0))
            {
            case -12L:
              x41 = XEXP (x33, 1);
              if (XWINT (x41, 0) != -8L)
                return -1;
              x42 = XEXP (x36, 1);
              if (XWINT (x42, 0) != -4L)
                return -1;
              x29 = XEXP (x9, 0);
              x30 = XEXP (x29, 0);
              if (!rtx_equal_p (x30, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 283 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6633; /* *p *stm4_da_update */

            case -16L:
              x41 = XEXP (x33, 1);
              if (XWINT (x41, 0) != -12L)
                return -1;
              x42 = XEXP (x36, 1);
              if (XWINT (x42, 0) != -8L)
                return -1;
              x29 = XEXP (x9, 0);
              x30 = XEXP (x29, 0);
              if (GET_CODE (x30) != PLUS
                  || GET_MODE (x30) != E_SImode)
                return -1;
              x31 = XEXP (x30, 1);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x38 = XEXP (x30, 0);
              if (!rtx_equal_p (x38, operands[5])
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 355 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6637; /* *p *stm4_db_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x3, 1);
  if (!minmax_operator (x4, E_SImode))
    return NULL;
  operands[4] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return NULL;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  if (!arm_rhs_operand (operands[3], E_SImode)
      || !
#line 4304 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1]) && reload_completed))
    return NULL;
  return gen_split_26 (insn, operands);
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_SImode))
    return NULL;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_SImode)
      || !
#line 1895 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return NULL;
  return gen_split_2 (insn, operands);
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != NOT
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != NOT
              || GET_MODE (x6) != E_SImode)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!arm_rhs_operand (operands[2], E_SImode))
            return NULL;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          if (!arm_rhs_operand (operands[3], E_SImode))
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[4] = x11;
          if (!s_register_operand (operands[4], E_SImode)
              || !
#line 3898 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_16 (insn, operands);

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x4;
          if (pattern526 (x1) != 0
              || !
#line 10498 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
            return NULL;
          return gen_split_87 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x4;
          if (pattern526 (x1) == 0)
            {
              if (
#line 10560 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       != CCmode)))
                return gen_split_89 (insn, operands);
              if (
#line 10628 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                return gen_split_91 (insn, operands);
            }
          if (GET_CODE (x4) != GE
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x9 = XEXP (x3, 1);
          if (GET_CODE (x9) != NEG
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x12 = XEXP (x9, 0);
          if (!arm_comparison_operator (x12, E_SImode))
            return NULL;
          operands[2] = x12;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!s_register_operand (operands[3], E_SImode))
            return NULL;
          x14 = XEXP (x12, 1);
          operands[4] = x14;
          if (!arm_rhs_operand (operands[4], E_SImode))
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[5] = x11;
          if (!s_register_operand (operands[5], E_SImode)
              || !
#line 11591 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return NULL;
          return gen_split_98 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return NULL;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 2);
  if (GET_CODE (x6) != CONST_INT)
    return NULL;
  operands[3] = x6;
  if (const_int_operand (operands[3], E_SImode))
    {
      x7 = XEXP (x3, 2);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (s_register_operand (operands[1], E_SImode))
            {
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (const_int_operand (operands[2], E_SImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[4] = x10;
                  if (arm_not_operand (operands[4], E_SImode)
                      && 
#line 3189 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)
   && !reg_overlap_mentioned_p (operands[0], operands[4])))
                    return gen_split_9 (insn, operands);
                }
            }
        }
    }
  if (XWINT (x6, 0) != 0L)
    return NULL;
  x7 = XEXP (x3, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x9 = XEXP (x5, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_SImode))
    return NULL;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!arm_not_operand (operands[3], E_SImode)
      || !
#line 3223 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !reg_overlap_mentioned_p (operands[0], operands[3])))
    return NULL;
  return gen_split_10 (insn, operands);
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return NULL;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != SIGN_EXTEND
      || GET_MODE (x8) != E_SImode)
    return NULL;
  x9 = XEXP (x7, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], E_SImode))
    return NULL;
  x10 = XEXP (x8, 0);
  operands[4] = x10;
  if (!memory_operand (operands[4], E_QImode)
      || !
#line 565 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (XEXP (operands[4], 0)) == PLUS
   && rtx_equal_p (operands[0], XEXP (XEXP (operands[4], 0), 0))
   && rtx_equal_p (operands[2], XEXP (XEXP (operands[4], 0), 1))
   && (peep2_reg_dead_p (3, operands[0])
       || rtx_equal_p (operands[0], operands[3]))
   && (peep2_reg_dead_p (3, operands[2])
       || rtx_equal_p (operands[2], operands[3]))))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_36 (insn, operands);
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3)
    return NULL;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != 100
      || GET_MODE (x2) != E_CCmode)
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CCmode
      || !register_operand (operands[1], E_SImode))
    return NULL;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (pattern493 (x5) != 0)
    return NULL;
  if (
#line 10029 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_arch5t && TARGET_32BIT && peep2_regno_dead_p (3, CC_REGNUM)
  && !(TARGET_THUMB2 && optimize_insn_for_size_p ())))
    {
      *pmatch_len_ = 2;
      res = gen_peephole2_10 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (!
#line 10050 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && peep2_regno_dead_p (3, CC_REGNUM)))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_11 (insn, operands);
}

 rtx_insn *
peephole2_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arm_general_register_operand (operands[1], E_SImode))
    return NULL;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!memory_operand (operands[3], E_SImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (2));
  switch (GET_CODE (x5))
    {
    case SET:
      x6 = XEXP (x5, 1);
      if (!commutative_binary_operator (x6, E_SImode))
        return NULL;
      operands[5] = x6;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      if (!arm_general_register_operand (operands[4], E_SImode))
        return NULL;
      x8 = XEXP (x6, 0);
      operands[6] = x8;
      if (!arm_general_register_operand (operands[6], E_VOIDmode))
        return NULL;
      x9 = XEXP (x6, 1);
      operands[7] = x9;
      if (!arm_general_register_operand (operands[7], E_VOIDmode)
          || !
#line 109 "../../gcc-15.1.0/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM
   && (  ((rtx_equal_p(operands[0], operands[6])) && (rtx_equal_p(operands[1], operands[7])))
	||((rtx_equal_p(operands[0], operands[7])) && (rtx_equal_p(operands[1], operands[6]))))
   && (peep2_reg_dead_p (3, operands[0]) || rtx_equal_p (operands[0], operands[4]))
   && (peep2_reg_dead_p (3, operands[1]) || rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_17 (insn, operands);

    case PARALLEL:
      if (pattern566 (x5) != 0
          || !arm_general_register_operand (operands[4], E_SImode))
        return NULL;
      x10 = XVECEXP (x5, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      operands[6] = x12;
      if (!arm_general_register_operand (operands[6], E_VOIDmode))
        return NULL;
      x13 = XEXP (x11, 1);
      operands[7] = x13;
      if (!arm_general_register_operand (operands[7], E_VOIDmode)
          || !
#line 134 "../../gcc-15.1.0/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM
   && (  ((rtx_equal_p(operands[0], operands[6])) && (rtx_equal_p(operands[1], operands[7])))
       ||((rtx_equal_p(operands[0], operands[7])) && (rtx_equal_p(operands[1], operands[6]))))
   && (peep2_reg_dead_p (3, operands[0]) || rtx_equal_p (operands[0], operands[4]))
   && (peep2_reg_dead_p (3, operands[1]) || rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_18 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 6)
    return NULL;
  if (peep2_current_count >= 7)
    {
      res = peephole2_12 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x2 = XEXP (x1, 1);
  operands[6] = x2;
  x3 = PATTERN (peep2_next_insn (2));
  x4 = XEXP (x3, 0);
  if (!s_register_operand (x4, E_SImode))
    return NULL;
  x5 = XEXP (x3, 1);
  if (!const_int_operand (x5, E_SImode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (3));
  x7 = XEXP (x6, 0);
  if (!memory_operand (x7, E_SImode))
    return NULL;
  x8 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x8) != SET)
    return NULL;
  x9 = PATTERN (peep2_next_insn (5));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x11 = PATTERN (peep2_next_insn (1));
  x12 = XEXP (x11, 1);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x12, operands[0]))
        return NULL;
      x13 = XEXP (x11, 0);
      operands[3] = x13;
      if (!memory_operand (operands[3], E_SImode))
        return NULL;
      operands[1] = x4;
      operands[7] = x5;
      operands[4] = x7;
      x14 = XEXP (x6, 1);
      if (!rtx_equal_p (x14, operands[1]))
        return NULL;
      x15 = XEXP (x8, 0);
      operands[2] = x15;
      if (!s_register_operand (operands[2], E_SImode))
        return NULL;
      x16 = XEXP (x8, 1);
      operands[8] = x16;
      if (!const_int_operand (operands[8], E_SImode))
        return NULL;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[2]))
        return NULL;
      *pmatch_len_ = 5;
      return gen_peephole2_26 (insn, operands);

    case CONST_INT:
      operands[7] = x12;
      if (!const_int_operand (operands[7], E_SImode))
        return NULL;
      x13 = XEXP (x11, 0);
      operands[1] = x13;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      operands[2] = x4;
      operands[8] = x5;
      operands[3] = x7;
      x14 = XEXP (x6, 1);
      if (!rtx_equal_p (x14, operands[0]))
        return NULL;
      x15 = XEXP (x8, 0);
      operands[4] = x15;
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      x16 = XEXP (x8, 1);
      if (!rtx_equal_p (x16, operands[1]))
        return NULL;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[2]))
        return NULL;
      *pmatch_len_ = 5;
      return gen_peephole2_27 (insn, operands);

    default:
      return NULL;
    }
}
