/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CC_NZmode
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !mem_noofs_operand (operands[1], i1)
      || !reg_or_int_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!imm_for_neon_rshift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern32 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern32 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern32 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern32 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern32 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2SFmode:
      if (pattern32 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern32 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern68 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern68 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern68 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern32 (x3, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern32 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern59 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern59 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  return 0;
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !s_register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern40 (x3, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern40 (x3, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern40 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern38 (x3, 
E_V2SFmode, 
E_V2SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern38 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern38 (x3, 
E_V8HFmode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern38 (x3, 
E_V4HFmode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_OImode:
      return 1;

    case E_EImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V8QImode:
      return 0;

    case E_V4HImode:
      return 1;

    case E_V4HFmode:
      return 2;

    case E_V4BFmode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V2SFmode:
      return 5;

    case E_DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern41 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern41 (x3, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return pattern117 (x3, 
E_V16QImode, 
E_V8HImode); /* [-1, 1] */
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern68 (x3, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern68 (x3, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern32 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern208 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern201 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern206 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern216 (x3, 
E_V16BImode, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern216 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern209 (x3, 
E_V8BImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern209 (x3, 
E_V4BImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern240 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers == NULL
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !arm_rhs_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_V2SImode:
          if (GET_MODE (x1) != E_V2SImode)
            return -1;
          return 1;

        case E_V4HImode:
          if (GET_MODE (x1) != E_V4HImode)
            return -1;
          return 2;

        case E_V8QImode:
          if (GET_MODE (x1) != E_V8QImode)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern1 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V8HImode:
          if (pattern1 (x1, 
E_V8HImode) != 0)
            return -1;
          return 5;

        case E_V4SImode:
          if (pattern1 (x1, 
E_V4SImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    case VEC_SELECT:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != VEC_SELECT)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x8 = XVECEXP (x4, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XVECLEN (x5, 0) != 2)
            return -1;
          x10 = XVECEXP (x5, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x11 = XVECEXP (x5, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || pattern237 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case 4:
          if (pattern238 (x1) != 0)
            return -1;
          return 8;

        case 8:
          if (pattern239 (x1) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (XVECLEN (x6, 0))
    {
    case 1:
      if (XINT (x6, 1) != 17)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != UNSPEC_VOLATILE
          || XVECLEN (x10, 0) != 5
          || XINT (x10, 1) != 17)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      x12 = XVECEXP (x10, 0, 0);
      operands[3] = x12;
      x13 = XVECEXP (x10, 0, 1);
      operands[4] = x13;
      x14 = XVECEXP (x10, 0, 2);
      operands[5] = x14;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      x15 = XVECEXP (x10, 0, 3);
      operands[6] = x15;
      if (!const_int_operand (operands[6], E_SImode))
        return -1;
      x16 = XVECEXP (x10, 0, 4);
      operands[7] = x16;
      if (!const_int_operand (operands[7], E_SImode))
        return -1;
      operands[8] = x5;
      return pattern261 (x1); /* [-1, 7] */

    case 2:
      if (XINT (x6, 1) != 19)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 100
          || GET_MODE (x11) != E_CCmode)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x17 = XVECEXP (x6, 0, 1);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x18 = XEXP (x9, 0);
      operands[3] = x18;
      operands[4] = x5;
      x7 = XVECEXP (x6, 0, 0);
      switch (GET_CODE (x7))
        {
        case PLUS:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case MINUS:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        case IOR:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        case XOR:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 20; /* [20, 23] */
          return -1;

        case AND:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 24; /* [24, 27] */
          return -1;

        case NOT:
          x19 = XEXP (x7, 0);
          if (GET_CODE (x19) != AND)
            return -1;
          x20 = XEXP (x19, 1);
          operands[1] = x20;
          x21 = XEXP (x19, 0);
          if (!rtx_equal_p (x21, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern264 (x6, 
E_QImode) != 0)
                return -1;
              return 28;

            case E_HImode:
              if (pattern264 (x6, 
E_HImode) != 0)
                return -1;
              return 29;

            case E_SImode:
              if (pattern264 (x6, 
E_SImode) != 0)
                return -1;
              return 30;

            case E_DImode:
              if (!mem_noofs_operand (operands[0], E_DImode)
                  || GET_MODE (x6) != E_DImode
                  || GET_MODE (x7) != E_DImode
                  || GET_MODE (x19) != E_DImode
                  || !s_register_operand (operands[1], E_DImode)
                  || !scratch_operand (operands[3], E_DImode))
                return -1;
              return 31;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern311 (x6, 
E_V2SImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern311 (x6, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern311 (x6, 
E_V8QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2
      || !s_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern331 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern323 (x1, 
E_V4SImode, 
E_SImode, 
101) != 0)
    return -1;
  return 0;
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  if (!arm_comparison_operator (operands[4], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  if (!arm_comparison_operator (x5, E_SImode))
    return -1;
  operands[5] = x5;
  return pattern340 (x1); /* [-1, 0] */
}

int
pattern347 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern350 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern350 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern350 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern350 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern350 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern350 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern365 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[4] = x9;
  if (!mve_imm_32 (operands[4], E_SImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x11 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x13, operands[4]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x6) != E_V16QImode
          || !s_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x6) != E_V8HImode
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x6) != E_V4SImode
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern390 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!shift_nomul_operator (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!shift_amount_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern416 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern425 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern307 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern431 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != i1
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != XOR
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !neon_struct_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_MODE (x2))
    {
    case E_V8QImode:
      return 0;

    case E_V16QImode:
      return 1;

    case E_V4HImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V4HFmode:
      return 6;

    case E_V8HFmode:
      return 7;

    case E_V4BFmode:
      return 8;

    case E_V8BFmode:
      return 9;

    case E_V2SFmode:
      return 10;

    case E_V4SFmode:
      return 11;

    case E_DImode:
      return 12;

    case E_V2DImode:
      return 13;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern480 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern479 (x1) != 0)
    return -1;
  return 0;
}

int
pattern488 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern494 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!memory_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      x6 = PATTERN (peep2_next_insn (2));
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      return 0;

    case CONST_INT:
      operands[5] = x4;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern507 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[1], E_V8HImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!s_register_operand (operands[2], E_V8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || !s_register_operand (operands[1], E_SImode)
      || !s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern524 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern533 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[1], E_V8HImode)
      || !vpr_register_operand (operands[3], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!s_register_operand (operands[2], E_V8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern540 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  return pattern539 (x7, 
i1); /* [-1, 0] */
}

int
pattern552 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[3], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern561 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern570 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern584 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern590 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern602 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern610 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case ASHIFTRT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern622 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern629 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  return 0;
}

int
pattern637 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 1);
  x14 = XEXP (x13, 0);
  if (!rtx_equal_p (x14, operands[3]))
    return -1;
  return 0;
}

int
pattern644 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x9, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

int
pattern654 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CC_RSBmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_CC_RSBmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case SET:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!arm_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 1);
      if (!rtx_equal_p (x10, operands[2])
          || !
#line 2101 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && ~UINTVAL (operands[1]) == UINTVAL (operands[3])))
        return -1;
      return 48; /* rsb_imm_compare */

    case CLOBBER:
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!arm_not_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!scratch_operand (operands[0], E_SImode)
          || !
#line 2113 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 49; /* rsb_imm_compare_scratch */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case SMIN:
        case SMAX:
        case UMIN:
        case UMAX:
          operands[4] = x6;
          if (!minmax_operator (operands[4], E_SImode)
              || pattern550 (x3) != 0
              || !
#line 4301 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1])
   && !(arm_restrict_it && CONST_INT_P (operands[3]))))
            return -1;
          return 126; /* *minmax_arithsi_non_canon */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[4] = x6;
          if (!arm_comparison_operator (operands[4], E_SImode)
              || pattern550 (x3) != 0)
            return -1;
          if (
#line 10136 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 339; /* *cond_sub */
          if (!
#line 868 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          return 1038; /* *thumb2_cond_sub */

        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 132 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 943; /* *thumb_subdi3 */

        default:
          return -1;
        }

    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern292 (x1))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3142; /* atomic_sub_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3147; /* atomic_sub_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3152; /* atomic_sub_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3157; /* atomic_sub_fetchdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!arm_comparison_operator (x4, E_VOIDmode))
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (x5, E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (pattern449 (x1) != 0)
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x8;
              if (!arm_rhs_operand (operands[2], E_SImode))
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              if (
#line 10807 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 351; /* movcond */
              if (!
#line 1012 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
                return -1;
              return 1043; /* *thumb2_movcond */

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (arm_add_operand (operands[3], E_SImode)
                  && GET_CODE (x8) == PLUS
                  && GET_MODE (x8) == E_SImode
                  && 
#line 10917 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 354; /* *ifcompare_move_plus */
              if (!arm_rhs_operand (operands[3], E_SImode))
                return -1;
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode)
                  || !
#line 11061 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 360; /* *ifcompare_move_arith */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 11128 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 362; /* *ifcompare_move_not */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[7] = x8;
              if (!shift_operator (operands[7], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !
#line 11241 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 368; /* *ifcompare_move_shift */

            case NEG:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 11429 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 378; /* *ifcompare_move_neg */

            default:
              return -1;
            }

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          if (pattern449 (x1) != 0)
            return -1;
          x9 = XEXP (x4, 1);
          operands[5] = x9;
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!shiftable_operator (x7, E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x13 = XEXP (x7, 1);
          if (!arm_rhs_operand (x13, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode))
                return -1;
              operands[9] = x4;
              operands[5] = x5;
              operands[6] = x9;
              operands[8] = x7;
              operands[1] = x12;
              operands[2] = x13;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || !
#line 10962 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 356; /* *ifcompare_arith_arith */

            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              operands[6] = x4;
              operands[2] = x5;
              operands[3] = x9;
              operands[7] = x7;
              operands[4] = x12;
              operands[5] = x13;
              if (!
#line 10996 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 358; /* *ifcompare_arith_move */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              operands[5] = x9;
              operands[7] = x7;
              operands[2] = x12;
              operands[3] = x13;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!s_register_operand (operands[1], E_SImode)
                  || !
#line 11361 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 374; /* *ifcompare_arith_not */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x7) != E_SImode
              || pattern449 (x1) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              operands[2] = x12;
              if (!
#line 11163 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 364; /* *ifcompare_not_move */

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              operands[1] = x12;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !
#line 11327 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 372; /* *ifcompare_not_arith */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (!shift_operator (x7, E_SImode)
              || pattern449 (x1) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x13 = XEXP (x7, 1);
          if (!arm_rhs_operand (x13, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              operands[7] = x7;
              operands[2] = x12;
              operands[3] = x13;
              if (!
#line 11198 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 366; /* *ifcompare_shift_move */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[9] = x8;
              if (!shift_operator (operands[9], E_SImode))
                return -1;
              operands[7] = x4;
              operands[5] = x5;
              x9 = XEXP (x4, 1);
              operands[6] = x9;
              operands[8] = x7;
              operands[1] = x12;
              operands[2] = x13;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || !
#line 11286 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 370; /* *ifcompare_shift_shift */

            default:
              return -1;
            }

        case NEG:
          if (GET_MODE (x7) != E_SImode
              || pattern450 (x1) != 0)
            return -1;
          operands[5] = x4;
          operands[3] = x5;
          x9 = XEXP (x4, 1);
          operands[4] = x9;
          if (!arm_add_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          operands[2] = x12;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          operands[1] = x8;
          if (!arm_not_operand (operands[1], E_SImode)
              || !
#line 11393 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 376; /* *ifcompare_neg_move */

        case LABEL_REF:
          x8 = XEXP (x3, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x14 = XEXP (x2, 0);
          if (GET_CODE (x14) != PC)
            return -1;
          operands[4] = x4;
          operands[1] = x5;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!thumb1_cmpneg_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          operands[3] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1271 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 976; /* cbranchsi4_scratch */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x14 = XEXP (x2, 0);
      if (GET_CODE (x14) != PC)
        return -1;
      x16 = XEXP (x5, 0);
      if (!s_register_operand (x16, E_SImode))
        return -1;
      x17 = XEXP (x5, 1);
      if (!reg_or_int_operand (x17, E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case SET:
          if (pnum_clobbers == NULL)
            return -1;
          x18 = XEXP (x6, 1);
          if (GET_CODE (x18) != PLUS
              || GET_MODE (x18) != E_SImode)
            return -1;
          operands[4] = x4;
          operands[2] = x16;
          operands[3] = x17;
          x12 = XEXP (x7, 0);
          operands[5] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!thumb_cbrch_target_operand (operands[0], E_SImode))
            return -1;
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[3])
              || !
#line 1582 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[4]) == EQ
       || GET_CODE (operands[4]) == NE
       || GET_CODE (operands[4]) == GE
       || GET_CODE (operands[4]) == LT)))
            return -1;
          *pnum_clobbers = 1;
          return 982; /* *addsi3_cbranch */

        case CLOBBER:
          operands[3] = x4;
          operands[1] = x16;
          operands[2] = x17;
          x12 = XEXP (x7, 0);
          operands[4] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1661 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[3]) == EQ
       || GET_CODE (operands[3]) == NE
       || GET_CODE (operands[3]) == GE
       || GET_CODE (operands[3]) == LT)))
            return -1;
          return 983; /* *addsi3_cbranch_scratch */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  switch (pattern299 (x1))
    {
    case 0:
      if (pattern422 (x1) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      x10 = XEXP (x2, 1);
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[5] = x11;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          x13 = XEXP (x12, 0);
          x14 = XEXP (x13, 1);
          if (XWINT (x14, 0) != 4L)
            return -1;
          x15 = XEXP (x4, 1);
          x16 = XEXP (x15, 0);
          x17 = XEXP (x16, 1);
          if (XWINT (x17, 0) != 8L)
            return -1;
          x18 = XEXP (x5, 1);
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x23 = XEXP (x19, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && arm_hard_general_register_operand (operands[3], E_SImode)
              && arm_hard_general_register_operand (operands[4], E_SImode)
              && 
#line 37 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
            return 437; /* *ldm4_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !low_register_operand (operands[3], E_SImode)
              || !low_register_operand (operands[4], E_SImode)
              || !
#line 55 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
            return -1;
          return 438; /* *thumb_ldm4_ia */

        case PLUS:
          if (GET_MODE (x11) != E_SImode)
            return -1;
          x24 = XEXP (x11, 1);
          if (GET_CODE (x24) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x25 = XEXP (x11, 0);
          operands[5] = x25;
          if (!s_register_operand (operands[5], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode)
              || !arm_hard_general_register_operand (operands[3], E_SImode)
              || !arm_hard_general_register_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          x13 = XEXP (x12, 0);
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x15 = XEXP (x4, 1);
          x16 = XEXP (x15, 0);
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          switch (XWINT (x24, 0))
            {
            case 4L:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != 8L)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != 12L)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (pattern645 (x19, 
16) != 0
                  || !
#line 160 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 444; /* *ldm4_ib */

            case -12L:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -8L)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -4L)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (!rtx_equal_p (x19, operands[5])
                  || !
#line 231 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 448; /* *ldm4_da */

            case -16L:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -12L)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -8L)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (pattern645 (x19, 
-4) != 0
                  || !
#line 302 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 452; /* *ldm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern480 (x1) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x15 = XEXP (x4, 1);
      operands[3] = x15;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x18 = XEXP (x5, 1);
      operands[4] = x18;
      if (!arm_hard_general_register_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      x26 = XEXP (x6, 0);
      switch (GET_CODE (x26))
        {
        case REG:
        case SUBREG:
          operands[5] = x26;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x3, 0);
          x27 = XEXP (x7, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != 4L)
            return -1;
          x8 = XEXP (x4, 0);
          x29 = XEXP (x8, 0);
          x30 = XEXP (x29, 1);
          if (XWINT (x30, 0) != 8L)
            return -1;
          x9 = XEXP (x5, 0);
          x31 = XEXP (x9, 0);
          if (GET_CODE (x31) != PLUS
              || GET_MODE (x31) != E_SImode)
            return -1;
          x32 = XEXP (x31, 1);
          if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x33 = XEXP (x27, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x34 = XEXP (x29, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x31, 0);
          if (!rtx_equal_p (x35, operands[5])
              || !
#line 108 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
            return -1;
          return 441; /* *stm4_ */

        case PLUS:
          if (GET_MODE (x26) != E_SImode)
            return -1;
          x36 = XEXP (x26, 1);
          if (GET_CODE (x36) != CONST_INT)
            return -1;
          x37 = XEXP (x26, 0);
          operands[5] = x37;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x3, 0);
          x27 = XEXP (x7, 0);
          x33 = XEXP (x27, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x8 = XEXP (x4, 0);
          x29 = XEXP (x8, 0);
          x34 = XEXP (x29, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          switch (XWINT (x36, 0))
            {
            case 4L:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != 8L)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != 12L)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (pattern646 (x31, 
16) != 0
                  || !
#line 196 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 446; /* *stm4_ib */

            case -12L:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != -8L)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -4L)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (!rtx_equal_p (x31, operands[5])
                  || !
#line 266 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 450; /* *stm4_da */

            case -16L:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != -12L)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -8L)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (pattern646 (x31, 
-4) != 0
                  || !
#line 338 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 454; /* *stm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XEXP (x2, 0);
      operands[4] = x6;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x10 = XEXP (x2, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[4]))
        return -1;
      x38 = XEXP (x10, 1);
      switch (XWINT (x38, 0))
        {
        case 12L:
          switch (pattern496 (x3))
            {
            case 0:
              if (pattern421 (x1) != 0)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (GET_CODE (x19) != PLUS
                  || GET_MODE (x19) != E_SImode)
                return -1;
              x20 = XEXP (x19, 1);
              if (GET_CODE (x20) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x23 = XEXP (x19, 0);
              if (!rtx_equal_p (x23, operands[4]))
                return -1;
              switch (pattern633 (x1))
                {
                case 0:
                  x12 = XEXP (x3, 1);
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[4]))
                    return -1;
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != 4L
                      || XWINT (x20, 0) != 8L)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && arm_hard_general_register_operand (operands[3], E_SImode)
                      && 
#line 508 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return 458; /* *ldm3_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !low_register_operand (operands[3], E_SImode)
                      || !
#line 525 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 459; /* *thumb_ldm3_ia_update */

                case 1:
                  if (!arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode)
                      || !arm_hard_general_register_operand (operands[3], E_SImode))
                    return -1;
                  x12 = XEXP (x3, 1);
                  x13 = XEXP (x12, 0);
                  x21 = XEXP (x13, 0);
                  if (!rtx_equal_p (x21, operands[4])
                      || !
#line 600 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 464; /* *ldm3_ib_update */

                default:
                  return -1;
                }

            case 1:
              if (pattern479 (x1) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (GET_CODE (x31) != PLUS
                  || GET_MODE (x31) != E_SImode)
                return -1;
              x32 = XEXP (x31, 1);
              if (GET_CODE (x32) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x4, 1);
              operands[2] = x15;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              x8 = XEXP (x4, 0);
              x29 = XEXP (x8, 0);
              x34 = XEXP (x29, 0);
              if (!rtx_equal_p (x34, operands[4]))
                return -1;
              x35 = XEXP (x31, 0);
              if (!rtx_equal_p (x35, operands[4]))
                return -1;
              switch (pattern635 (x1))
                {
                case 0:
                  x7 = XEXP (x3, 0);
                  x27 = XEXP (x7, 0);
                  if (!rtx_equal_p (x27, operands[4]))
                    return -1;
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != 4L
                      || XWINT (x32, 0) != 8L)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && arm_hard_general_register_operand (operands[3], E_SImode)
                      && 
#line 552 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return 461; /* *stm3_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !low_register_operand (operands[3], E_SImode)
                      || !
#line 567 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 462; /* *thumb_stm3_ia_update */

                case 1:
                  if (!arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode)
                      || !arm_hard_general_register_operand (operands[3], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  x27 = XEXP (x7, 0);
                  x33 = XEXP (x27, 0);
                  if (!rtx_equal_p (x33, operands[4])
                      || !
#line 628 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 466; /* *stm3_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -12L:
          x12 = XEXP (x3, 1);
          switch (GET_CODE (x12))
            {
            case MEM:
              if (pattern422 (x1) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x13 = XEXP (x12, 0);
              x21 = XEXP (x13, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x14 = XEXP (x13, 1);
              switch (XWINT (x14, 0))
                {
                case -8L:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -4L)
                    return -1;
                  x18 = XEXP (x5, 1);
                  x19 = XEXP (x18, 0);
                  if (!rtx_equal_p (x19, operands[4])
                      || !
#line 660 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 468; /* *ldm3_da_update */

                case -12L:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -8L)
                    return -1;
                  x18 = XEXP (x5, 1);
                  x19 = XEXP (x18, 0);
                  if (GET_CODE (x19) != PLUS
                      || GET_MODE (x19) != E_SImode)
                    return -1;
                  x20 = XEXP (x19, 1);
                  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x23 = XEXP (x19, 0);
                  if (!rtx_equal_p (x23, operands[4])
                      || !
#line 722 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 472; /* *ldm3_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x12;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern480 (x1) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x4, 1);
              operands[2] = x15;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x7 = XEXP (x3, 0);
              x27 = XEXP (x7, 0);
              x33 = XEXP (x27, 0);
              if (!rtx_equal_p (x33, operands[4]))
                return -1;
              x8 = XEXP (x4, 0);
              x29 = XEXP (x8, 0);
              x34 = XEXP (x29, 0);
              if (!rtx_equal_p (x34, operands[4]))
                return -1;
              x28 = XEXP (x27, 1);
              switch (XWINT (x28, 0))
                {
                case -8L:
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != -4L)
                    return -1;
                  x9 = XEXP (x5, 0);
                  x31 = XEXP (x9, 0);
                  if (!rtx_equal_p (x31, operands[4])
                      || !
#line 688 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 470; /* *stm3_da_update */

                case -12L:
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != -8L)
                    return -1;
                  x9 = XEXP (x5, 0);
                  x31 = XEXP (x9, 0);
                  if (GET_CODE (x31) != PLUS
                      || GET_MODE (x31) != E_SImode)
                    return -1;
                  x32 = XEXP (x31, 1);
                  if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x35 = XEXP (x31, 0);
                  if (!rtx_equal_p (x35, operands[4])
                      || !
#line 750 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 474; /* *stm3_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2435; /* neon_vrsras_nv8qi */

    case 1:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2439; /* neon_vrsras_nv16qi */

    case 2:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2443; /* neon_vrsras_nv4hi */

    case 3:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2447; /* neon_vrsras_nv8hi */

    case 4:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2451; /* neon_vrsras_nv2si */

    case 5:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2455; /* neon_vrsras_nv4si */

    case 6:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2459; /* neon_vrsras_ndi */

    case 7:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2463; /* neon_vrsras_nv2di */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern46 (x1, 
E_XImode, 
E_OImode))
    {
    case 0:
      if (!
#line 6025 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2909; /* neon_vld4qbv16qi */

    case 1:
      if (!
#line 6025 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2910; /* neon_vld4qbv8hi */

    case 2:
      if (!
#line 6025 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2911; /* neon_vld4qbv8hf */

    case 3:
      if (!(
#line 6025 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2912; /* neon_vld4qbv8bf */

    case 4:
      if (!
#line 6025 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2913; /* neon_vld4qbv4si */

    case 5:
      if (!
#line 6025 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2914; /* neon_vld4qbv4sf */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern36 (x1))
    {
    case 0:
      if (!
#line 2192 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1597; /* neon_vqrdmlshv4hi */

    case 1:
      if (!
#line 2192 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1599; /* neon_vqrdmlshv2si */

    case 2:
      if (!
#line 2192 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1601; /* neon_vqrdmlshv8hi */

    case 3:
      if (!
#line 2192 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1603; /* neon_vqrdmlshv4si */

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!mve_memory_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 3130 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4820; /* mve_vstrq_v16qi */

    case E_V8HImode:
      if (!mve_memory_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 3130 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4821; /* mve_vstrq_v8hi */

    case E_V4SImode:
      if (!mve_memory_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 3130 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4822; /* mve_vstrq_v4si */

    case E_V8HFmode:
      if (!mve_memory_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 3130 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4823; /* mve_vstrq_v8hf */

    case E_V4SFmode:
      if (!mve_memory_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 3130 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4824; /* mve_vstrq_v4sf */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 24 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 687; /* iwmmxt_wabsv2si3 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 24 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 688; /* iwmmxt_wabsv4hi3 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 24 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 689; /* iwmmxt_wabsv8qi3 */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern105 (x1))
    {
    case 0:
      if (!
#line 3718 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2109; /* neon_vcvtuv2sf */

    case 1:
      if (!
#line 3718 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2111; /* neon_vcvtuv4sf */

    case 2:
      if (!
#line 3727 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2113; /* neon_vcvtuv2si */

    case 3:
      if (!
#line 3727 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2115; /* neon_vcvtuv4si */

    case 4:
      if (!
#line 3756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2119; /* neon_vcvtuv4hi */

    case 5:
      if (!
#line 3756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2121; /* neon_vcvtuv8hi */

    case 6:
      if (!
#line 3767 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2123; /* neon_vcvtuv8hf */

    case 7:
      if (!
#line 3767 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2125; /* neon_vcvtuv4hf */

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 852 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1341; /* neon_vrsqrtev8hf */

    case 1:
      if (!
#line 852 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1342; /* neon_vrsqrtev4hf */

    case 2:
      if (!
#line 3202 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2032; /* neon_vrsqrtev2si */

    case 3:
      if (!
#line 3202 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2033; /* neon_vrsqrtev2sf */

    case 4:
      if (!
#line 3202 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2034; /* neon_vrsqrtev4si */

    case 5:
      if (!
#line 3202 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2035; /* neon_vrsqrtev4sf */

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern149 (x1))
    {
    case 0:
      if (!(
#line 2880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return -1;
      return 1928; /* neon_vcadd90v4hf */

    case 1:
      if (register_operand (operands[0], E_V8HFmode)
          && register_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && (
#line 2880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return 1930; /* neon_vcadd90v8hf */
      if (!s_register_operand (operands[0], E_V8HFmode)
          || !s_register_operand (operands[1], E_V8HFmode)
          || !s_register_operand (operands[2], E_V8HFmode)
          || !
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3738; /* mve_vcaddq_rot90_fv8hf */

    case 2:
      if (!
#line 2880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return -1;
      return 1932; /* neon_vcadd90v2sf */

    case 3:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 2880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return 1934; /* neon_vcadd90v4sf */
      if (!s_register_operand (operands[0], E_V4SFmode)
          || !s_register_operand (operands[1], E_V4SFmode)
          || !s_register_operand (operands[2], E_V4SFmode)
          || !
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3744; /* mve_vcaddq_rot90_fv4sf */

    case 4:
      if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3562; /* mve_vcaddq_rot90_v16qi */

    case 5:
      if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3566; /* mve_vcaddq_rot90_v8hi */

    case 6:
      if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3570; /* mve_vcaddq_rot90_v4si */

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern157 (x1))
    {
    case 0:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2716; /* neon_vst1x3qbv8qi */

    case 1:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2717; /* neon_vst1x3qbv16qi */

    case 2:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2718; /* neon_vst1x3qbv4hi */

    case 3:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2719; /* neon_vst1x3qbv8hi */

    case 4:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2720; /* neon_vst1x3qbv2si */

    case 5:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2721; /* neon_vst1x3qbv4si */

    case 6:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2722; /* neon_vst1x3qbv4hf */

    case 7:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2723; /* neon_vst1x3qbv8hf */

    case 8:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2724; /* neon_vst1x3qbv4bf */

    case 9:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2725; /* neon_vst1x3qbv8bf */

    case 10:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2726; /* neon_vst1x3qbv2sf */

    case 11:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2727; /* neon_vst1x3qbv4sf */

    case 12:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2728; /* neon_vst1x3qbdi */

    case 13:
      if (!
#line 5287 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2729; /* neon_vst1x3qbv2di */

    default:
      return -1;
    }
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern165 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V16QImode, 
E_V4x16QImode) != 0
          || !
#line 120 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x16QImode))))
        return -1;
      return 3252; /* mve_vst4qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HImode, 
E_V4x8HImode) != 0
          || !
#line 120 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x8HImode))))
        return -1;
      return 3253; /* mve_vst4qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SImode, 
E_V4x4SImode) != 0
          || !
#line 120 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x4SImode))))
        return -1;
      return 3254; /* mve_vst4qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HFmode, 
E_V4x8HFmode) != 0
          || !
#line 120 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x8HFmode))))
        return -1;
      return 3255; /* mve_vst4qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SFmode, 
E_V4x4SFmode) != 0
          || !
#line 120 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x4SFmode))))
        return -1;
      return 3256; /* mve_vst4qv4sf */

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !
#line 527 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3366; /* mve_vcreateq_fv8hf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !
#line 527 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3367; /* mve_vcreateq_fv4sf */

    default:
      return -1;
    }
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2341; /* neon_vrshrs_nv8qi */

    case 1:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2345; /* neon_vrshrs_nv16qi */

    case 2:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2349; /* neon_vrshrs_nv4hi */

    case 3:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2353; /* neon_vrshrs_nv8hi */

    case 4:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2357; /* neon_vrshrs_nv2si */

    case 5:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2361; /* neon_vrshrs_nv4si */

    case 6:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2365; /* neon_vrshrs_ndi */

    case 7:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2369; /* neon_vrshrs_nv2di */

    default:
      return -1;
    }
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2275; /* neon_vshlsv8qi */

    case 1:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2279; /* neon_vshlsv16qi */

    case 2:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2283; /* neon_vshlsv4hi */

    case 3:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2287; /* neon_vshlsv8hi */

    case 4:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2291; /* neon_vshlsv2si */

    case 5:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2295; /* neon_vshlsv4si */

    case 6:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2299; /* neon_vshlsdi */

    case 7:
      if (!
#line 4498 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2303; /* neon_vshlsv2di */

    default:
      return -1;
    }
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode)
          || !
#line 1750 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 685; /* iwmmxt_wsadbz */

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode)
          || !register_operand (operands[2], E_V4HImode)
          || !
#line 1760 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 686; /* iwmmxt_wsadhz */

    default:
      return -1;
    }
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern131 (x1))
    {
    case 0:
      if (!
#line 952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1390; /* ashlv8qi3_unsigned */

    case 1:
      if (!
#line 952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1391; /* ashlv16qi3_unsigned */

    case 2:
      if (!
#line 952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1392; /* ashlv4hi3_unsigned */

    case 3:
      if (!
#line 952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1393; /* ashlv8hi3_unsigned */

    case 4:
      if (!
#line 952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1394; /* ashlv2si3_unsigned */

    case 5:
      if (!
#line 952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1395; /* ashlv4si3_unsigned */

    case 6:
      if (!
#line 952 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1396; /* ashlv2di3_unsigned */

    default:
      return -1;
    }
}

 int
recog_205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern161 (x1, 
E_EImode, 
E_CImode))
    {
    case 0:
      if (!
#line 5676 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2835; /* neon_vld3qav16qi */

    case 1:
      if (!
#line 5676 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2836; /* neon_vld3qav8hi */

    case 2:
      if (!
#line 5676 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2837; /* neon_vld3qav8hf */

    case 3:
      if (!(
#line 5676 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2838; /* neon_vld3qav8bf */

    case 4:
      if (!
#line 5676 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2839; /* neon_vld3qav4si */

    case 5:
      if (!
#line 5676 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2840; /* neon_vld3qav4sf */

    default:
      return -1;
    }
}

 int
recog_215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2303 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1649; /* neon_vhsubsv8qi */

    case 1:
      if (!
#line 2303 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1651; /* neon_vhsubsv16qi */

    case 2:
      if (!
#line 2303 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1653; /* neon_vhsubsv4hi */

    case 3:
      if (!
#line 2303 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1655; /* neon_vhsubsv8hi */

    case 4:
      if (!
#line 2303 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1657; /* neon_vhsubsv2si */

    case 5:
      if (!
#line 2303 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1659; /* neon_vhsubsv4si */

    default:
      return -1;
    }
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1))
    {
    case 0:
      if (!
#line 542 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3368; /* mve_vcreateq_uv16qi */

    case 1:
      if (!
#line 542 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3370; /* mve_vcreateq_uv8hi */

    case 2:
      if (!
#line 542 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3372; /* mve_vcreateq_uv4si */

    case 3:
      if (!
#line 542 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3374; /* mve_vcreateq_uv2di */

    default:
      return -1;
    }
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1707; /* neon_vceqv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1712; /* neon_vceqv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1727; /* neon_vceqv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1732; /* neon_vceqv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_245 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern200 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!s_register_operand (operands[0], E_TImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_TImode
          || !s_register_operand (operands[2], E_TImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!neon_struct_operand (operands[1], E_HImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8QImode
              || !
#line 5448 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2785; /* neon_vld2_lanev8qi */

        case E_SImode:
          if (!neon_struct_operand (operands[1], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4HImode
              || !
#line 5448 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2786; /* neon_vld2_lanev4hi */

        case E_SFmode:
          if (!neon_struct_operand (operands[1], E_SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4HFmode
              || !
#line 5448 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2787; /* neon_vld2_lanev4hf */

        case E_BFmode:
          if (!neon_struct_operand (operands[1], E_BFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4BFmode
              || !
#line 5448 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2788; /* neon_vld2_lanev4bf */

        case E_V2SImode:
          if (!neon_struct_operand (operands[1], E_V2SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V2SImode
              || !
#line 5448 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2789; /* neon_vld2_lanev2si */

        case E_V2SFmode:
          if (!neon_struct_operand (operands[1], E_V2SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V2SFmode
              || !
#line 5448 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2790; /* neon_vld2_lanev2sf */

        default:
          return -1;
        }

    case E_OImode:
      if (!s_register_operand (operands[0], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_OImode
          || !s_register_operand (operands[2], E_OImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!neon_struct_operand (operands[1], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8HImode
              || !
#line 5472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2791; /* neon_vld2_lanev8hi */

        case E_SFmode:
          if (!neon_struct_operand (operands[1], E_SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8HFmode
              || !
#line 5472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2792; /* neon_vld2_lanev8hf */

        case E_V2SImode:
          if (!neon_struct_operand (operands[1], E_V2SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4SImode
              || !
#line 5472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2793; /* neon_vld2_lanev4si */

        case E_V2SFmode:
          if (!neon_struct_operand (operands[1], E_V2SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4SFmode
              || !
#line 5472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2794; /* neon_vld2_lanev4sf */

        case E_BFmode:
          if (!neon_struct_operand (operands[1], E_BFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8BFmode
              || !(
#line 5472 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2795; /* neon_vld2_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[6] = x4;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x4, 1);
  operands[5] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!arm_add_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x2, 2);
  operands[1] = x8;
  if (!arm_rhs_operand (operands[1], E_SImode)
      || !
#line 10874 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
    return -1;
  *pnum_clobbers = 1;
  return 352; /* *ifcompare_plus_move */
}

 int
recog_272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      x7 = XEXP (x6, 0);
      if (!s_register_operand (x7, E_SImode))
        return -1;
      operands[2] = x7;
      if (GET_CODE (x6) == PLUS
          && GET_MODE (x6) == E_SImode)
        {
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[5] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          if (arm_add_operand (operands[3], E_SImode))
            {
              x10 = XEXP (x2, 2);
              operands[1] = x10;
              if (arm_rhs_operand (operands[1], E_SImode)
                  && 
#line 10890 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 353; /* *if_plus_move */
            }
        }
      operands[5] = x3;
      operands[6] = x6;
      if (!shiftable_operator (operands[6], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      if (!arm_rhs_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          operands[7] = x10;
          if (!shiftable_operator (operands[7], E_SImode))
            return -1;
          x8 = XEXP (x3, 0);
          operands[8] = x8;
          operands[1] = x7;
          operands[2] = x9;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[4] = x12;
          if (!arm_rhs_operand (operands[4], E_SImode)
              || !
#line 10979 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 357; /* *if_arith_arith */

        case NOT:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          x8 = XEXP (x3, 0);
          operands[4] = x8;
          operands[2] = x7;
          operands[3] = x9;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 11377 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 375; /* *if_arith_not */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x6;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case PLUS:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[5] = x8;
          if (!arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_add_operand (operands[3], E_SImode)
              || !
#line 10933 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 355; /* *if_move_plus */

        case NOT:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[3] = x8;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          if (arm_not_operand (operands[1], E_SImode)
              && 
#line 11142 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 363; /* *if_move_not */
          if (!arm_rhs_operand (operands[1], E_SImode)
              || !
#line 11821 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 381; /* *cond_move_not */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[4] = x10;
          if (!shift_operator (operands[4], E_SImode))
            return -1;
          operands[5] = x3;
          x8 = XEXP (x3, 0);
          operands[6] = x8;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_rhs_operand (operands[3], E_SImode)
              || !
#line 11257 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 369; /* *if_move_shift */

        case NEG:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 11443 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 379; /* *if_move_neg */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (!s_register_operand (x7, E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x10;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[3] = x8;
          operands[2] = x7;
          if (!
#line 11177 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 365; /* *if_not_move */

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          operands[6] = x10;
          if (!shiftable_operator (operands[6], E_SImode))
            return -1;
          operands[5] = x3;
          x8 = XEXP (x3, 0);
          operands[4] = x8;
          operands[1] = x7;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_rhs_operand (operands[3], E_SImode)
              || !
#line 11343 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 373; /* *if_not_arith */

        default:
          return -1;
        }

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      if (!shift_operator (x6, E_SImode))
        return -1;
      operands[5] = x3;
      x7 = XEXP (x6, 0);
      if (!s_register_operand (x7, E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      if (!arm_rhs_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x10;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 0);
          operands[6] = x8;
          operands[4] = x6;
          operands[2] = x7;
          operands[3] = x9;
          if (!
#line 11214 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 367; /* *if_shift_move */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[7] = x10;
          if (!shift_operator (operands[7], E_SImode))
            return -1;
          x8 = XEXP (x3, 0);
          operands[8] = x8;
          operands[6] = x6;
          operands[1] = x7;
          operands[2] = x9;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[4] = x12;
          if (!arm_rhs_operand (operands[4], E_SImode)
              || !
#line 11304 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 371; /* *if_shift_shift */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      operands[4] = x3;
      x8 = XEXP (x3, 0);
      operands[3] = x8;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      operands[1] = x10;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 11407 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && !TARGET_COND_ARITH))
        return -1;
      return 377; /* *if_neg_move */

    default:
      return -1;
    }
}

 int
recog_284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return recog_282 (x1, insn, pnum_clobbers);

    case PLUS:
      if (GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (arm_carry_operation (operands[3], E_SImode))
            {
              if (arm_not_operand (operands[2], E_SImode)
                  && 
#line 1338 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return 21; /* addsi3_carryin */
              if (pnum_clobbers != NULL
                  && arm_rhs_operand (operands[2], E_SImode)
                  && 
#line 1405 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                {
                  *pnum_clobbers = 1;
                  return 25; /* *addsi3_carryin_clobercc */
                }
            }
          if (!s_register_operand (operands[2], E_SImode)
              || GET_CODE (x6) != GEU
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!thumb1_cmp_operand (operands[4], E_SImode)
              || !
#line 1807 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 989; /* thumb1_addsi3_addgeu */

        case GEU:
        case LTU:
          operands[3] = x4;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          if (!arm_not_operand (operands[2], E_SImode)
              || !
#line 1369 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 23; /* *addsi3_carryin_alt2 */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (!shift_operator (x4, E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!s_register_operand (x9, E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          if (!shift_amount_operand (x10, E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case GEU:
            case LTU:
              operands[5] = x5;
              if (!arm_carry_operation (operands[5], E_SImode))
                return -1;
              operands[2] = x4;
              operands[3] = x9;
              operands[4] = x10;
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (!s_register_operand (operands[1], E_SImode)
                  || !
#line 1390 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 24; /* *addsi3_carryin_shift */

            case NOT:
              if (GET_MODE (x5) != E_SImode)
                return -1;
              operands[3] = x4;
              operands[1] = x9;
              operands[2] = x10;
              x11 = XEXP (x5, 0);
              operands[4] = x11;
              if (!s_register_operand (operands[4], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[5] = x6;
              if (!arm_carry_operation (operands[5], E_SImode)
                  || !
#line 1749 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 32; /* add_not_shift_cin */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          if (!arm_rhs_operand (operands[2], E_SImode)
              || !
#line 1729 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM || (TARGET_THUMB2 && !CONST_INT_P (operands[2]))))
            return -1;
          return 31; /* *add_not_cin */

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x3;
      if (!arm_carry_operation (operands[2], E_SImode)
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!arm_not_operand (operands[1], E_SImode)
          || !
#line 1356 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 22; /* add0si3_carryin */

    case MULT:
      return recog_283 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern274 (x2))
        {
        case 0:
          if (!
#line 5711 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
            return -1;
          return 178; /* *arm_zero_extendhisi2addsi */

        case 1:
          if (!
#line 5781 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
            return -1;
          return 181; /* *arm_zero_extendqisi2addsi */

        case 2:
          if (!
#line 1111 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1413; /* widen_usumv8qi3 */

        case 3:
          if (!
#line 1111 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1414; /* widen_usumv4hi3 */

        case 4:
          if (!
#line 1111 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1415; /* widen_usumv2si3 */

        case 5:
          if (vect_par_constant_low (operands[2], E_V16QImode)
              && 
#line 1084 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1407; /* vec_sel_widen_usum_lov16qiv8qi3 */
          if (!vect_par_constant_high (operands[2], E_V16QImode)
              || !
#line 1099 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1410; /* vec_sel_widen_usum_hiv16qiv8qi3 */

        case 6:
          if (vect_par_constant_low (operands[2], E_V8HImode)
              && 
#line 1084 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1408; /* vec_sel_widen_usum_lov8hiv4hi3 */
          if (!vect_par_constant_high (operands[2], E_V8HImode)
              || !
#line 1099 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1411; /* vec_sel_widen_usum_hiv8hiv4hi3 */

        case 7:
          if (vect_par_constant_low (operands[2], E_V4SImode)
              && 
#line 1084 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1409; /* vec_sel_widen_usum_lov4siv2si3 */
          if (!vect_par_constant_high (operands[2], E_V4SImode)
              || !
#line 1099 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1412; /* vec_sel_widen_usum_hiv4siv2si3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern274 (x2))
        {
        case 0:
          if (!
#line 5952 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
            return -1;
          return 185; /* *arm_extendhisi2addsi */

        case 1:
          if (!
#line 6046 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
            return -1;
          return 189; /* *arm_extendqisi2addsi */

        case 2:
          if (!
#line 1042 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1404; /* widen_ssumv8qi3 */

        case 3:
          if (!
#line 1042 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1405; /* widen_ssumv4hi3 */

        case 4:
          if (!
#line 1042 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1406; /* widen_ssumv2si3 */

        case 5:
          if (vect_par_constant_low (operands[2], E_V16QImode)
              && 
#line 1014 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1398; /* vec_sel_widen_ssum_lov16qiv8qi3 */
          if (!vect_par_constant_high (operands[2], E_V16QImode)
              || !
#line 1029 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1401; /* vec_sel_widen_ssum_hiv16qiv8qi3 */

        case 6:
          if (vect_par_constant_low (operands[2], E_V8HImode)
              && 
#line 1014 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1399; /* vec_sel_widen_ssum_lov8hiv4hi3 */
          if (!vect_par_constant_high (operands[2], E_V8HImode)
              || !
#line 1029 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1402; /* vec_sel_widen_ssum_hiv8hiv4hi3 */

        case 7:
          if (vect_par_constant_low (operands[2], E_V4SImode)
              && 
#line 1014 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1400; /* vec_sel_widen_ssum_lov4siv2si3 */
          if (!vect_par_constant_high (operands[2], E_V4SImode)
              || !
#line 1029 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1403; /* vec_sel_widen_ssum_hiv4siv2si3 */

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x3;
      if (pattern304 (x2) != 0
          || !
#line 9700 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT))
        return -1;
      return 324; /* *add_shiftsi */

    case VEC_SELECT:
      switch (pattern271 (x2))
        {
        case 0:
          if (!
#line 1129 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1416; /* quad_halves_plusv4si */

        case 1:
          if (!
#line 1142 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 1421; /* quad_halves_plusv4sf */

        case 2:
          if (!
#line 1157 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1424; /* quad_halves_plusv8hi */

        case 3:
          if (!
#line 1176 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1429; /* quad_halves_plusv16qi */

        default:
          return -1;
        }

    case EQ:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != AND)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern465 (x2, 
E_V8QImode) != 0
              || !
#line 2583 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1781; /* neon_vtst_combinev8qi */

        case E_V16QImode:
          if (pattern465 (x2, 
E_V16QImode) != 0
              || !
#line 2583 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1782; /* neon_vtst_combinev16qi */

        case E_V4HImode:
          if (pattern465 (x2, 
E_V4HImode) != 0
              || !
#line 2583 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1783; /* neon_vtst_combinev4hi */

        case E_V8HImode:
          if (pattern465 (x2, 
E_V8HImode) != 0
              || !
#line 2583 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1784; /* neon_vtst_combinev8hi */

        case E_V2SImode:
          if (pattern465 (x2, 
E_V2SImode) != 0
              || !
#line 2583 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1785; /* neon_vtst_combinev2si */

        case E_V4SImode:
          if (pattern465 (x2, 
E_V4SImode) != 0
              || !
#line 2583 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1786; /* neon_vtst_combinev4si */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          switch (XINT (x3, 1))
            {
            case 149:
              switch (pattern351 (x2))
                {
                case 0:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1809; /* neon_vabasv8qi */

                case 1:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1811; /* neon_vabasv16qi */

                case 2:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1813; /* neon_vabasv4hi */

                case 3:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1815; /* neon_vabasv8hi */

                case 4:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1817; /* neon_vabasv2si */

                case 5:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1819; /* neon_vabasv4si */

                default:
                  return -1;
                }

            case 150:
              switch (pattern351 (x2))
                {
                case 0:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1810; /* neon_vabauv8qi */

                case 1:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1812; /* neon_vabauv16qi */

                case 2:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1814; /* neon_vabauv4hi */

                case 3:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1816; /* neon_vabauv8hi */

                case 4:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1818; /* neon_vabauv2si */

                case 5:
                  if (!
#line 2634 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1820; /* neon_vabauv4si */

                default:
                  return -1;
                }

            case 151:
              switch (pattern353 (x2))
                {
                case 0:
                  if (!
#line 2645 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1821; /* neon_vabalsv8qi */

                case 1:
                  if (!
#line 2645 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1823; /* neon_vabalsv4hi */

                case 2:
                  if (!
#line 2645 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1825; /* neon_vabalsv2si */

                default:
                  return -1;
                }

            case 152:
              switch (pattern353 (x2))
                {
                case 0:
                  if (!
#line 2645 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1822; /* neon_vabaluv8qi */

                case 1:
                  if (!
#line 2645 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1824; /* neon_vabaluv4hi */

                case 2:
                  if (!
#line 2645 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1826; /* neon_vabaluv2si */

                default:
                  return -1;
                }

            case 370:
              switch (pattern355 (x2))
                {
                case 0:
                  if (!
#line 2988 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                    return -1;
                  return 1984; /* sdot_prodv2siv8qi */

                case 1:
                  if (!
#line 2988 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                    return -1;
                  return 1986; /* sdot_prodv4siv16qi */

                default:
                  return -1;
                }

            case 371:
              switch (pattern355 (x2))
                {
                case 0:
                  if (!
#line 2988 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                    return -1;
                  return 1985; /* udot_prodv2siv8qi */

                case 1:
                  if (!
#line 2988 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                    return -1;
                  return 1987; /* udot_prodv4siv16qi */

                default:
                  return -1;
                }

            case 372:
              x12 = XVECEXP (x3, 0, 0);
              operands[2] = x12;
              x13 = XVECEXP (x3, 0, 1);
              operands[3] = x13;
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (pattern466 (x2, 
E_V2SImode, 
E_V8QImode) != 0
                      || !
#line 3013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                    return -1;
                  return 1988; /* neon_usdotv2siv8qi */

                case E_V4SImode:
                  if (pattern466 (x2, 
E_V4SImode, 
E_V16QImode) != 0
                      || !
#line 3013 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                    return -1;
                  return 1989; /* neon_usdotv4siv16qi */

                default:
                  return -1;
                }

            case 389:
              if (pattern356 (x2) != 0
                  || !
#line 6623 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                return -1;
              return 3020; /* neon_smmlav16qi */

            case 390:
              if (pattern356 (x2) != 0
                  || !
#line 6623 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                return -1;
              return 3021; /* neon_ummlav16qi */

            case 391:
              if (pattern356 (x2) != 0
                  || !
#line 6623 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                return -1;
              return 3022; /* neon_usmmlav16qi */

            default:
              return -1;
            }

        case 3:
          x12 = XVECEXP (x3, 0, 0);
          operands[2] = x12;
          x13 = XVECEXP (x3, 0, 1);
          operands[3] = x13;
          x14 = XVECEXP (x3, 0, 2);
          operands[4] = x14;
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (XINT (x3, 1))
            {
            case 370:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  switch (pattern513 (x2, 
E_V2SImode, 
E_V8QImode))
                    {
                    case 0:
                      if (!
#line 3028 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1990; /* neon_sdot_lanev8qi */

                    case 1:
                      if (!
#line 3043 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1994; /* neon_sdot_laneqv8qi */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern513 (x2, 
E_V4SImode, 
E_V16QImode))
                    {
                    case 0:
                      if (!
#line 3028 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1992; /* neon_sdot_lanev16qi */

                    case 1:
                      if (!
#line 3043 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1996; /* neon_sdot_laneqv16qi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 371:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  switch (pattern513 (x2, 
E_V2SImode, 
E_V8QImode))
                    {
                    case 0:
                      if (!
#line 3028 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1991; /* neon_udot_lanev8qi */

                    case 1:
                      if (!
#line 3043 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1995; /* neon_udot_laneqv8qi */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern513 (x2, 
E_V4SImode, 
E_V16QImode))
                    {
                    case 0:
                      if (!
#line 3028 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1993; /* neon_udot_lanev16qi */

                    case 1:
                      if (!
#line 3043 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1997; /* neon_udot_laneqv16qi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 372:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  switch (pattern513 (x2, 
E_V2SImode, 
E_V8QImode))
                    {
                    case 0:
                      if (!
#line 3071 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 1998; /* neon_usdot_lanev8qi */

                    case 1:
                      if (!
#line 3086 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2002; /* neon_usdot_laneqv8qi */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern513 (x2, 
E_V4SImode, 
E_V16QImode))
                    {
                    case 0:
                      if (!
#line 3071 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2000; /* neon_usdot_lanev16qi */

                    case 1:
                      if (!
#line 3086 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2004; /* neon_usdot_laneqv16qi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 373:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  switch (pattern513 (x2, 
E_V2SImode, 
E_V8QImode))
                    {
                    case 0:
                      if (!
#line 3071 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 1999; /* neon_sudot_lanev8qi */

                    case 1:
                      if (!
#line 3086 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2003; /* neon_sudot_laneqv8qi */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern513 (x2, 
E_V4SImode, 
E_V16QImode))
                    {
                    case 0:
                      if (!
#line 3071 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2001; /* neon_sudot_lanev16qi */

                    case 1:
                      if (!
#line 3086 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2005; /* neon_sudot_laneqv16qi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode))
        return -1;
      if (
#line 615 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
        return 965; /* *thumb1_movdi_insn */
      if (!
#line 41 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
        return -1;
      return 1084; /* *neon_movdi */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 697 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
        return -1;
      return 966; /* *thumb1_movsi_insn */

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode))
        {
          if (
#line 838 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 967; /* *thumb1_movhi_insn */
          if (
#line 289 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
  && (register_operand (operands[0], HImode)
     || register_operand (operands[1], HImode))))
            return 1016; /* *thumb2_movhi_insn */
        }
      if (pnum_clobbers == NULL
          || !low_register_operand (operands[0], E_HImode)
          || !const_int_operand (operands[1], E_HImode)
          || !
#line 1289 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 1055; /* *thumb2_movhi_shortim */

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 895 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode))))
        return 968; /* *thumb1_movqi_insn */
      if (pnum_clobbers == NULL
          || !low_register_operand (operands[0], E_QImode)
          || !const_int_operand (operands[1], E_QImode)
          || !
#line 1289 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 1054; /* *thumb2_movqi_shortim */

    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !general_operand (operands[1], E_HFmode)
          || !
#line 913 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (	  s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
        return -1;
      return 969; /* *thumb1_movhf */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 969 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], SFmode)
       || register_operand (operands[1], SFmode))))
        return -1;
      return 970; /* *thumb1_movsf_insn */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 993 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
        return -1;
      return 971; /* *thumb_movdf_insn */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 41 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V8QImode)
       || register_operand (operands[1], V8QImode))))
        return -1;
      return 1078; /* *neon_movv8qi */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 41 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))))
        return -1;
      return 1079; /* *neon_movv4hi */

    case E_V4HFmode:
      if (!nonimmediate_operand (operands[0], E_V4HFmode)
          || !general_operand (operands[1], E_V4HFmode)
          || !
#line 41 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4HFmode)
       || register_operand (operands[1], V4HFmode))))
        return -1;
      return 1080; /* *neon_movv4hf */

    case E_V4BFmode:
      if (!nonimmediate_operand (operands[0], E_V4BFmode)
          || !general_operand (operands[1], E_V4BFmode)
          || !
#line 41 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4BFmode)
       || register_operand (operands[1], V4BFmode))))
        return -1;
      return 1081; /* *neon_movv4bf */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 41 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[1], V2SImode))))
        return -1;
      return 1082; /* *neon_movv2si */

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode)
          || !
#line 41 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))))
        return -1;
      return 1083; /* *neon_movv2sf */

    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode))
        return -1;
      if (
#line 88 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))))
        return 1085; /* *neon_movv16qi */
      if (!
#line 23 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3239; /* mve_movv16qi */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode))
        return -1;
      if (
#line 88 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))))
        return 1086; /* *neon_movv8hi */
      if (!
#line 23 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3240; /* mve_movv8hi */

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !general_operand (operands[1], E_V8HFmode))
        return -1;
      if (
#line 88 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[1], V8HFmode))))
        return 1087; /* *neon_movv8hf */
      if (!
#line 23 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3244; /* mve_movv8hf */

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !general_operand (operands[1], E_V8BFmode)
          || !
#line 88 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[1], V8BFmode))))
        return -1;
      return 1088; /* *neon_movv8bf */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode))
        return -1;
      if (
#line 88 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))))
        return 1089; /* *neon_movv4si */
      if (!
#line 23 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3241; /* mve_movv4si */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode))
        return -1;
      if (
#line 88 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[1], V4SFmode))))
        return 1090; /* *neon_movv4sf */
      if (!
#line 23 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3245; /* mve_movv4sf */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode))
        return -1;
      if (
#line 88 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))))
        return 1091; /* *neon_movv2di */
      if (!
#line 23 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3242; /* mve_movv2di */

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !general_operand (operands[1], E_TImode))
        return -1;
      if (
#line 88 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], TImode)
       || register_operand (operands[1], TImode))))
        return 1092; /* *neon_movti */
      if (!
#line 23 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3243; /* mve_movti */

    case E_EImode:
      if (!nonimmediate_operand (operands[0], E_EImode)
          || !general_operand (operands[1], E_EImode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], EImode)
       || register_operand (operands[1], EImode))) && 
#line 141 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(!TARGET_HAVE_MVE)))
        return -1;
      return 1093; /* *neon_movei */

    case E_OImode:
      if (!nonimmediate_operand (operands[0], E_OImode)
          || !general_operand (operands[1], E_OImode)
          || !
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], OImode)
       || register_operand (operands[1], OImode))))
        return -1;
      return 1094; /* *neon_movoi */

    case E_CImode:
      if (!nonimmediate_operand (operands[0], E_CImode)
          || !general_operand (operands[1], E_CImode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], CImode)
       || register_operand (operands[1], CImode))) && 
#line 142 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(!TARGET_HAVE_MVE)))
        return -1;
      return 1095; /* *neon_movci */

    case E_XImode:
      if (!nonimmediate_operand (operands[0], E_XImode)
          || !general_operand (operands[1], E_XImode)
          || !
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], XImode)
       || register_operand (operands[1], XImode))))
        return -1;
      return 1096; /* *neon_movxi */

    case E_V2x16QImode:
      if (!nonimmediate_operand (operands[0], E_V2x16QImode)
          || !general_operand (operands[1], E_V2x16QImode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x16QImode)
       || register_operand (operands[1], V2x16QImode))) && 
#line 143 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1097; /* *neon_movv2x16qi */

    case E_V2x8HImode:
      if (!nonimmediate_operand (operands[0], E_V2x8HImode)
          || !general_operand (operands[1], E_V2x8HImode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x8HImode)
       || register_operand (operands[1], V2x8HImode))) && 
#line 144 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1098; /* *neon_movv2x8hi */

    case E_V2x4SImode:
      if (!nonimmediate_operand (operands[0], E_V2x4SImode)
          || !general_operand (operands[1], E_V2x4SImode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x4SImode)
       || register_operand (operands[1], V2x4SImode))) && 
#line 145 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1099; /* *neon_movv2x4si */

    case E_V2x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V2x8HFmode)
          || !general_operand (operands[1], E_V2x8HFmode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x8HFmode)
       || register_operand (operands[1], V2x8HFmode))) && 
#line 146 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
        return -1;
      return 1100; /* *neon_movv2x8hf */

    case E_V2x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V2x4SFmode)
          || !general_operand (operands[1], E_V2x4SFmode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x4SFmode)
       || register_operand (operands[1], V2x4SFmode))) && 
#line 147 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
        return -1;
      return 1101; /* *neon_movv2x4sf */

    case E_V4x16QImode:
      if (!nonimmediate_operand (operands[0], E_V4x16QImode)
          || !general_operand (operands[1], E_V4x16QImode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x16QImode)
       || register_operand (operands[1], V4x16QImode))) && 
#line 148 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1102; /* *neon_movv4x16qi */

    case E_V4x8HImode:
      if (!nonimmediate_operand (operands[0], E_V4x8HImode)
          || !general_operand (operands[1], E_V4x8HImode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x8HImode)
       || register_operand (operands[1], V4x8HImode))) && 
#line 149 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1103; /* *neon_movv4x8hi */

    case E_V4x4SImode:
      if (!nonimmediate_operand (operands[0], E_V4x4SImode)
          || !general_operand (operands[1], E_V4x4SImode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x4SImode)
       || register_operand (operands[1], V4x4SImode))) && 
#line 150 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1104; /* *neon_movv4x4si */

    case E_V4x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V4x8HFmode)
          || !general_operand (operands[1], E_V4x8HFmode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x8HFmode)
       || register_operand (operands[1], V4x8HFmode))) && 
#line 151 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
        return -1;
      return 1105; /* *neon_movv4x8hf */

    case E_V4x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4SFmode)
          || !general_operand (operands[1], E_V4x4SFmode)
          || !(
#line 184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x4SFmode)
       || register_operand (operands[1], V4x4SFmode))) && 
#line 152 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
        return -1;
      return 1106; /* *neon_movv4x4sf */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode)
          || !
#line 23 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3246; /* mve_movv2df */

    default:
      return -1;
    }
}

 int
recog_305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern401 (x3, 
E_HFmode) != 0
                  || !
#line 1342 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 825; /* fmahf4 */

            case E_SFmode:
              if (pattern401 (x3, 
E_SFmode) != 0
                  || !
#line 1365 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA ))
                return -1;
              return 826; /* fmasf4 */

            case E_DFmode:
              if (pattern401 (x3, 
E_DFmode) != 0
                  || !(
#line 1365 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return -1;
              return 827; /* fmadf4 */

            case E_V2SFmode:
              if (pattern401 (x3, 
E_V2SFmode) != 0)
                return -1;
              if (
#line 629 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH && TARGET_FMA))
                return 1207; /* fmav2sf4 */
              if (!
#line 639 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FMA))
                return -1;
              return 1209; /* fmav2sf4_intrinsic */

            case E_V4SFmode:
              if (pattern401 (x3, 
E_V4SFmode) != 0)
                return -1;
              if (
#line 629 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH && TARGET_FMA))
                return 1208; /* fmav4sf4 */
              if (!
#line 639 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FMA))
                return -1;
              return 1210; /* fmav4sf4_intrinsic */

            case E_V8HFmode:
              if (pattern401 (x3, 
E_V8HFmode) != 0
                  || !
#line 650 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH))
                return -1;
              return 1211; /* fmav8hf4 */

            case E_V4HFmode:
              if (pattern401 (x3, 
E_V4HFmode) != 0
                  || !
#line 650 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH))
                return -1;
              return 1212; /* fmav4hf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern402 (x3, 
E_HFmode) != 0
                  || !
#line 1412 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 831; /* *fnmsubhf4 */

            case E_SFmode:
              if (pattern402 (x3, 
E_SFmode) != 0
                  || !
#line 1423 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA ))
                return -1;
              return 832; /* *fnmsubsf4 */

            case E_DFmode:
              if (pattern402 (x3, 
E_DFmode) != 0
                  || !(
#line 1423 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return -1;
              return 833; /* *fnmsubdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern403 (x3, 
E_HFmode) != 0
                  || !
#line 1377 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 828; /* fmsubhf4_fp16 */

            case E_SFmode:
              if (pattern403 (x3, 
E_SFmode) != 0
                  || !
#line 1401 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA ))
                return -1;
              return 829; /* *fmsubsf4 */

            case E_DFmode:
              if (pattern403 (x3, 
E_DFmode) != 0
                  || !(
#line 1401 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return -1;
              return 830; /* *fmsubdf4 */

            case E_V2SFmode:
              if (pattern403 (x3, 
E_V2SFmode) != 0)
                return -1;
              if (
#line 660 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH && TARGET_FMA))
                return 1213; /* *fmsubv2sf4 */
              if (!
#line 671 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FMA))
                return -1;
              return 1215; /* fmsubv2sf4_intrinsic */

            case E_V4SFmode:
              if (pattern403 (x3, 
E_V4SFmode) != 0)
                return -1;
              if (
#line 660 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH && TARGET_FMA))
                return 1214; /* *fmsubv4sf4 */
              if (!
#line 671 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FMA))
                return -1;
              return 1216; /* fmsubv4sf4_intrinsic */

            case E_V8HFmode:
              if (pattern403 (x3, 
E_V8HFmode) != 0
                  || !
#line 682 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
                return -1;
              return 1217; /* fmsubv8hf4_intrinsic */

            case E_V4HFmode:
              if (pattern403 (x3, 
E_V4HFmode) != 0
                  || !
#line 682 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
                return -1;
              return 1218; /* fmsubv4hf4_intrinsic */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern404 (x3, 
E_HFmode) != 0
                  || !
#line 1434 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 834; /* *fnmaddhf4 */

            case E_SFmode:
              if (pattern404 (x3, 
E_SFmode) != 0
                  || !
#line 1446 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA ))
                return -1;
              return 835; /* *fnmaddsf4 */

            case E_DFmode:
              if (pattern404 (x3, 
E_DFmode) != 0
                  || !(
#line 1446 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return -1;
              return 836; /* *fnmadddf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != FLOAT_EXTEND)
        return -1;
      x6 = XEXP (x3, 2);
      operands[1] = x6;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case VEC_SELECT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          x10 = XEXP (x8, 1);
          operands[4] = x10;
          x11 = XEXP (x5, 0);
          switch (pattern405 (x11))
            {
            case 0:
              if (pattern516 (x3, 
E_V2SFmode, 
E_V4HFmode, 
E_V2HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V4HFmode)
                  && vect_par_constant_low (operands[5], E_V4HFmode)
                  && 
#line 1738 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return 1536; /* vfmal_lowv2sf_intrinsic */
              if (!vect_par_constant_high (operands[4], E_V4HFmode)
                  || !vect_par_constant_high (operands[5], E_V4HFmode)
                  || !
#line 1773 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return -1;
              return 1540; /* vfmal_highv2sf_intrinsic */

            case 1:
              if (pattern516 (x3, 
E_V4SFmode, 
E_V8HFmode, 
E_V4HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V8HFmode)
                  && vect_par_constant_low (operands[5], E_V8HFmode)
                  && 
#line 1738 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return 1537; /* vfmal_lowv4sf_intrinsic */
              if (!vect_par_constant_high (operands[4], E_V8HFmode)
                  || !vect_par_constant_high (operands[5], E_V8HFmode)
                  || !
#line 1773 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return -1;
              return 1541; /* vfmal_highv4sf_intrinsic */

            case 2:
              if (pattern587 (x3, 
E_V2SFmode, 
E_V2HFmode, 
E_V4HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V4HFmode))
                {
                  switch (GET_MODE (operands[3]))
                    {
                    case E_V4HFmode:
                      if (s_register_operand (operands[3], E_V4HFmode)
                          && 
#line 1828 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1544; /* vfmal_lane_lowv2sf_intrinsic */
                      break;

                    case E_V8HFmode:
                      if (s_register_operand (operands[3], E_V8HFmode)
                          && 
#line 1884 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1546; /* vfmal_lane_lowv8hfv2sf_intrinsic */
                      break;

                    default:
                      break;
                    }
                }
              if (!vect_par_constant_high (operands[4], E_V4HFmode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V8HFmode:
                  if (!s_register_operand (operands[3], E_V8HFmode)
                      || !
#line 1921 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1548; /* vfmal_lane_highv8hfv2sf_intrinsic */

                case E_V4HFmode:
                  if (!s_register_operand (operands[3], E_V4HFmode)
                      || !
#line 1950 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1550; /* vfmal_lane_highv2sf_intrinsic */

                default:
                  return -1;
                }

            case 3:
              if (pattern587 (x3, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V8HFmode))
                {
                  switch (GET_MODE (operands[3]))
                    {
                    case E_V8HFmode:
                      if (s_register_operand (operands[3], E_V8HFmode)
                          && 
#line 1828 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1545; /* vfmal_lane_lowv4sf_intrinsic */
                      break;

                    case E_V4HFmode:
                      if (s_register_operand (operands[3], E_V4HFmode)
                          && 
#line 1884 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1547; /* vfmal_lane_lowv4hfv4sf_intrinsic */
                      break;

                    default:
                      break;
                    }
                }
              if (!vect_par_constant_high (operands[4], E_V8HFmode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V4HFmode:
                  if (!s_register_operand (operands[3], E_V4HFmode)
                      || !
#line 1921 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1549; /* vfmal_lane_highv4hfv4sf_intrinsic */

                case E_V8HFmode:
                  if (!s_register_operand (operands[3], E_V8HFmode)
                      || !
#line 1950 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1551; /* vfmal_lane_highv4sf_intrinsic */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != VEC_SELECT)
            return -1;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          x13 = XEXP (x9, 1);
          operands[4] = x13;
          x11 = XEXP (x5, 0);
          switch (pattern405 (x11))
            {
            case 0:
              if (pattern537 (x3, 
E_V2SFmode, 
E_V4HFmode, 
E_V2HFmode) != 0)
                return -1;
              if (vect_par_constant_high (operands[4], E_V4HFmode)
                  && vect_par_constant_high (operands[5], E_V4HFmode)
                  && 
#line 1756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return 1538; /* vfmsl_highv2sf_intrinsic */
              if (!vect_par_constant_low (operands[4], E_V4HFmode)
                  || !vect_par_constant_low (operands[5], E_V4HFmode)
                  || !
#line 1791 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return -1;
              return 1542; /* vfmsl_lowv2sf_intrinsic */

            case 1:
              if (pattern537 (x3, 
E_V4SFmode, 
E_V8HFmode, 
E_V4HFmode) != 0)
                return -1;
              if (vect_par_constant_high (operands[4], E_V8HFmode)
                  && vect_par_constant_high (operands[5], E_V8HFmode)
                  && 
#line 1756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return 1539; /* vfmsl_highv4sf_intrinsic */
              if (!vect_par_constant_low (operands[4], E_V8HFmode)
                  || !vect_par_constant_low (operands[5], E_V8HFmode)
                  || !
#line 1791 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return -1;
              return 1543; /* vfmsl_lowv4sf_intrinsic */

            case 2:
              if (pattern591 (x3, 
E_V2SFmode, 
E_V2HFmode, 
E_V4HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V4HFmode))
                {
                  switch (GET_MODE (operands[3]))
                    {
                    case E_V4HFmode:
                      if (s_register_operand (operands[3], E_V4HFmode)
                          && 
#line 1981 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1552; /* vfmsl_lane_lowv2sf_intrinsic */
                      break;

                    case E_V8HFmode:
                      if (s_register_operand (operands[3], E_V8HFmode)
                          && 
#line 2019 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1554; /* vfmsl_lane_lowv8hfv2sf_intrinsic */
                      break;

                    default:
                      break;
                    }
                }
              if (!vect_par_constant_high (operands[4], E_V4HFmode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V8HFmode:
                  if (!s_register_operand (operands[3], E_V8HFmode)
                      || !
#line 2057 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1556; /* vfmsl_lane_highv8hfv2sf_intrinsic */

                case E_V4HFmode:
                  if (!s_register_operand (operands[3], E_V4HFmode)
                      || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1558; /* vfmsl_lane_highv2sf_intrinsic */

                default:
                  return -1;
                }

            case 3:
              if (pattern591 (x3, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V8HFmode))
                {
                  switch (GET_MODE (operands[3]))
                    {
                    case E_V8HFmode:
                      if (s_register_operand (operands[3], E_V8HFmode)
                          && 
#line 1981 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1553; /* vfmsl_lane_lowv4sf_intrinsic */
                      break;

                    case E_V4HFmode:
                      if (s_register_operand (operands[3], E_V4HFmode)
                          && 
#line 2019 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1555; /* vfmsl_lane_lowv4hfv4sf_intrinsic */
                      break;

                    default:
                      break;
                    }
                }
              if (!vect_par_constant_high (operands[4], E_V8HFmode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V4HFmode:
                  if (!s_register_operand (operands[3], E_V4HFmode)
                      || !
#line 2057 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1557; /* vfmsl_lane_highv4hfv4sf_intrinsic */

                case E_V8HFmode:
                  if (!s_register_operand (operands[3], E_V8HFmode)
                      || !
#line 2087 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1559; /* vfmsl_lane_highv4sf_intrinsic */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_316 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern309 (x3))
        {
        case 0:
          if (!
#line 946 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 615; /* iwmmxt_wpackhss */

        case 1:
          if (!
#line 957 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 616; /* iwmmxt_wpackwss */

        case 2:
          if (!
#line 968 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 617; /* iwmmxt_wpackdss */

        default:
          return -1;
        }

    case US_TRUNCATE:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != US_TRUNCATE)
            return -1;
          switch (pattern309 (x3))
            {
            case 0:
              if (!
#line 979 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 618; /* iwmmxt_wpackhus */

            case 1:
              if (!
#line 990 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 619; /* iwmmxt_wpackwus */

            case 2:
              if (!
#line 1001 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 620; /* iwmmxt_wpackdus */

            default:
              return -1;
            }

        case SS_PLUS:
          if (GET_MODE (x6) != E_V4HImode)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != ZERO_EXTEND
              || GET_MODE (x7) != E_V4HImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != VEC_SELECT
              || GET_MODE (x8) != E_V4QImode)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 4)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x12 = XVECEXP (x9, 0, 2);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x13 = XVECEXP (x9, 0, 3);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_VECTOR
              || XVECLEN (x5, 0) != 4
              || pattern472 (x5, 
E_V4QImode) != 0
              || !register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || GET_MODE (x4) != E_V4QImode)
            return -1;
          x14 = XEXP (x6, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          x15 = XEXP (x8, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_V8QImode)
              || !
#line 433 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 715; /* iwmmxt_waddbhusl */

        default:
          return -1;
        }

    case CONST_VECTOR:
      if (XVECLEN (x4, 0) != 4
          || GET_MODE (x4) != E_V4QImode)
        return -1;
      x16 = XVECEXP (x4, 0, 0);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x17 = XVECEXP (x4, 0, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x18 = XVECEXP (x4, 0, 2);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x4, 0, 3);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x3, 1);
      if (pattern321 (x5, 
E_V4HImode, 
SS_PLUS, 
E_V4QImode, 
US_TRUNCATE) != 0)
        return -1;
      x20 = XEXP (x5, 0);
      x21 = XEXP (x20, 1);
      if (pattern536 (x21, 
E_V4QImode, 
E_V4HImode, 
ZERO_EXTEND) != 0)
        return -1;
      x22 = XEXP (x21, 0);
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != PARALLEL
          || XVECLEN (x23, 0) != 4)
        return -1;
      x24 = XVECEXP (x23, 0, 0);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x25 = XVECEXP (x23, 0, 1);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x26 = XVECEXP (x23, 0, 2);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x27 = XVECEXP (x23, 0, 3);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode)
        return -1;
      x28 = XEXP (x20, 0);
      operands[1] = x28;
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      x29 = XEXP (x22, 0);
      operands[2] = x29;
      if (!register_operand (operands[2], E_V8QImode)
          || !
#line 417 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 714; /* iwmmxt_waddbhusm */

    case REG:
    case SUBREG:
      switch (pattern11 (x3))
        {
        case 0:
          if (!
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2093; /* neon_vcombinev8qi */

        case 1:
          if (!
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2094; /* neon_vcombinev4hi */

        case 2:
          if (!
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2095; /* neon_vcombinev4hf */

        case 3:
          if (!
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2096; /* neon_vcombinev4bf */

        case 4:
          if (!
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2097; /* neon_vcombinev2si */

        case 5:
          if (!
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2098; /* neon_vcombinev2sf */

        case 6:
          if (!
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2099; /* neon_vcombinedi */

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x20 = XEXP (x5, 0);
      operands[2] = x20;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern308 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 6569 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3006; /* vec_pack_trunc_v8hi */

        case E_V8HImode:
          if (pattern308 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 6569 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3007; /* vec_pack_trunc_v4si */

        case E_V4SImode:
          if (pattern308 (x3, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 6569 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3008; /* vec_pack_trunc_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_SImode)
          || !
#line 12384 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_arch6))
        return -1;
      return 411; /* *arm_rev */

    case E_HImode:
      if (!s_register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !s_register_operand (operands[1], E_HImode)
          || !
#line 12569 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_arch6))
        return -1;
      return 413; /* *arm_rev16 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 2854 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1923; /* neon_bswapv4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 2854 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1924; /* neon_bswapv8hi */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 2854 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1925; /* neon_bswapv2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 2854 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1926; /* neon_bswapv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2854 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1927; /* neon_bswapv2di */

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_V8QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFTRT
      || GET_MODE (x4) != E_TImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_CONCAT
      || GET_MODE (x6) != E_V16QImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != MULT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != ZERO_EXTRACT
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x10 = XEXP (x8, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XEXP (x7, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[1] = x13;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x14 = XEXP (x6, 1);
  operands[2] = x14;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x15 = XEXP (x1, 0);
  operands[4] = x15;
  x16 = XEXP (x15, 0);
  operands[5] = x16;
  x17 = XEXP (x8, 0);
  operands[3] = x17;
  if (register_operand (operands[3], E_SImode)
      && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1656 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
    return 6816; /* *p iwmmxt_walignr */
  if (GET_CODE (x17) != REG)
    return -1;
  operands[3] = x15;
  operands[4] = x16;
  if (GET_MODE (x17) != E_SImode)
    return -1;
  switch (REGNO (x17))
    {
    case 96:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1671 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6817; /* *p iwmmxt_walignr0 */

    case 97:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1686 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6818; /* *p iwmmxt_walignr1 */

    case 98:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1701 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6819; /* *p iwmmxt_walignr2 */

    case 99:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1716 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6820; /* *p iwmmxt_walignr3 */

    default:
      return -1;
    }
}

 int
recog_338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 3:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      switch (XINT (x4, 1))
        {
        case 79:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2792 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
            return 6438; /* *p arm_smlawb_insn */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2792 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ)))
            return -1;
          return 6439; /* *p arm_smlawb_setq_insn */

        case 80:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2792 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
            return 6440; /* *p arm_smlawt_insn */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2792 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ)))
            return -1;
          return 6441; /* *p arm_smlawt_setq_insn */

        case 74:
          if (pattern439 (x1, 
E_SImode) != 0
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6077 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6531; /* *p arm_usada8 */

        case 75:
          if (pattern439 (x1, 
E_DImode) != 0
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6088 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6532; /* *p arm_smlald */

        case 76:
          if (pattern439 (x1, 
E_DImode) != 0
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6088 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6533; /* *p arm_smlaldx */

        case 77:
          if (pattern439 (x1, 
E_DImode) != 0
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6088 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6534; /* *p arm_smlsld */

        case 78:
          if (pattern439 (x1, 
E_DImode) != 0
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6088 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6535; /* *p arm_smlsldx */

        case 94:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return 6548; /* *p arm_smlad_insn */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
            return -1;
          return 6549; /* *p arm_smlad_setq_insn */

        case 95:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return 6550; /* *p arm_smladx_insn */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
            return -1;
          return 6551; /* *p arm_smladx_setq_insn */

        case 96:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return 6552; /* *p arm_smlsd_insn */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
            return -1;
          return 6553; /* *p arm_smlsd_setq_insn */

        case 97:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return 6554; /* *p arm_smlsdx_insn */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
            return -1;
          return 6555; /* *p arm_smlsdx_setq_insn */

        case 81:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 105
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          if (!s_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6194 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6564; /* *p arm_sel */

        case 2:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x4, 0, 2);
          operands[2] = x6;
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6755 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM)))
            return -1;
          return 6567; /* *p pic_add_dot_plus_eight */

        case 11:
          if (pattern440 (x1) != 0
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 518 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6711; /* *p iwmmxt_wmacs */

        case 12:
          if (pattern440 (x1) != 0
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 539 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6713; /* *p iwmmxt_wmacu */

        case 9:
          if (GET_MODE (x4) != E_V2SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          if (!register_operand (operands[0], E_V2SImode)
              || !register_operand (operands[1], E_V2SImode))
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          x6 = XVECEXP (x4, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[2]))
            {
            case E_V8QImode:
              if (!register_operand (operands[2], E_V8QImode)
                  || !register_operand (operands[3], E_V8QImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1728 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6821; /* *p iwmmxt_wsadb */

            case E_V4HImode:
              if (!register_operand (operands[2], E_V4HImode)
                  || !register_operand (operands[3], E_V4HImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1740 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6822; /* *p iwmmxt_wsadh */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (XINT (x4, 1))
        {
        case 30:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 104
              || GET_MODE (x5) != E_CCmode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[1] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4419 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM_QBIT)))
            return -1;
          return 6464; /* *p arm_get_apsr */

        case 25:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!mem_and_no_t1_wback_op (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5016 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(unaligned_access)))
            return -1;
          return 6474; /* *p unaligned_loadsi */

        case 26:
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5072 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(unaligned_access)))
                return -1;
              return 6477; /* *p unaligned_storesi */

            case E_HImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_HImode)
                  || GET_MODE (x4) != E_HImode
                  || !s_register_operand (operands[1], E_HImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5087 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(unaligned_access)))
                return -1;
              return 6478; /* *p unaligned_storehi */

            default:
              return -1;
            }

        case 45:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6056 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6500; /* *p arm_sxtb16 */

        case 46:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6056 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6501; /* *p arm_uxtb16 */

        case 38:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x1, 0);
          operands[1] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!memory_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9262 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6580; /* *p probe_stack */

        case 22:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12201 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2)))
            return -1;
          return 6600; /* *p arm_rbit */

        case 17:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x1, 0);
          operands[1] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!register_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12292 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_HARD_TP)))
            return -1;
          return 6601; /* *p load_tp_hard */

        case 15:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x1, 0);
          operands[1] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!register_operand (operands[0], E_DImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 560 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6715; /* *p iwmmxt_clrdi */

        case 8:
          switch (pattern409 (x1, 
E_SImode))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1579 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6809; /* *p iwmmxt_tmovmskb */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1588 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6810; /* *p iwmmxt_tmovmskh */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1597 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6811; /* *p iwmmxt_tmovmskw */

            default:
              return -1;
            }

        case 7:
          switch (pattern409 (x1, 
E_DImode))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1606 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6812; /* *p iwmmxt_waccb */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1615 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6813; /* *p iwmmxt_wacch */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1624 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6814; /* *p iwmmxt_waccw */

            default:
              return -1;
            }

        case 16:
          if (GET_MODE (x4) != E_V8QImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_V8QImode)
            return -1;
          x10 = XEXP (x5, 0);
          if (GET_CODE (x10) != ASHIFTRT
              || GET_MODE (x10) != E_TImode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG
              || maybe_ne (SUBREG_BYTE (x11), 0)
              || GET_MODE (x11) != E_TImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != VEC_CONCAT
              || GET_MODE (x12) != E_V16QImode)
            return -1;
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != MULT
              || GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x13, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          if (!register_operand (operands[0], E_V8QImode))
            return -1;
          x15 = XEXP (x12, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          x16 = XEXP (x12, 1);
          operands[2] = x16;
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          x17 = XEXP (x13, 0);
          operands[3] = x17;
          if (!immediate_operand (operands[3], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1641 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6815; /* *p iwmmxt_waligni */

        case 109:
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (!register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x4) != E_V2SImode
                  || !register_operand (operands[1], E_V2SImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 24 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6825; /* *p iwmmxt_wabsv2si3 */

            case E_V4HImode:
              if (!register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x4) != E_V4HImode
                  || !register_operand (operands[1], E_V4HImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 24 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6826; /* *p iwmmxt_wabsv4hi3 */

            case E_V8QImode:
              if (!register_operand (operands[0], E_V8QImode)
                  || GET_MODE (x4) != E_V8QImode
                  || !register_operand (operands[1], E_V8QImode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 24 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6827; /* *p iwmmxt_wabsv8qi3 */

            default:
              return -1;
            }

        case 108:
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != PLUS)
            return -1;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x18 = XEXP (x5, 1);
          operands[2] = x18;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern557 (x4, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 111 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6833; /* *p addcv4hi3 */

            case E_V2SImode:
              if (pattern557 (x4, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 111 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6834; /* *p addcv2si3 */

            default:
              return -1;
            }

        case 32:
          switch (pattern410 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 )))
                return -1;
              return 6972; /* *p btruncsf2 */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6975; /* *p btruncdf2 */

            default:
              return -1;
            }

        case 35:
          switch (pattern410 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 )))
                return -1;
              return 6973; /* *p nearbyintsf2 */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6976; /* *p nearbyintdf2 */

            default:
              return -1;
            }

        case 36:
          switch (pattern410 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 )))
                return -1;
              return 6974; /* *p rintsf2 */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6977; /* *p rintdf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_336 (x1, insn, pnum_clobbers);

    case 5:
      x9 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x9) != ZERO_EXTRACT
          || GET_MODE (x9) != E_V4HImode)
        return -1;
      x19 = XEXP (x9, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x20 = XEXP (x9, 2);
      if (GET_CODE (x20) != CONST_INT)
        return -1;
      x6 = XVECEXP (x4, 0, 2);
      if (GET_CODE (x6) != ZERO_EXTRACT
          || GET_MODE (x6) != E_V4HImode)
        return -1;
      x21 = XEXP (x6, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x22 = XEXP (x6, 2);
      if (GET_CODE (x22) != CONST_INT)
        return -1;
      x23 = XVECEXP (x4, 0, 3);
      if (GET_CODE (x23) != ZERO_EXTRACT
          || GET_MODE (x23) != E_V4HImode)
        return -1;
      x24 = XEXP (x23, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x25 = XEXP (x23, 2);
      if (GET_CODE (x25) != CONST_INT)
        return -1;
      x26 = XVECEXP (x4, 0, 4);
      if (GET_CODE (x26) != ZERO_EXTRACT
          || GET_MODE (x26) != E_V4HImode)
        return -1;
      x27 = XEXP (x26, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x28 = XEXP (x26, 2);
      if (GET_CODE (x28) != CONST_INT)
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      x8 = XEXP (x7, 0);
      operands[5] = x8;
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x4) != E_V2SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      x29 = XEXP (x9, 0);
      operands[2] = x29;
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      x30 = XEXP (x23, 0);
      operands[3] = x30;
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      x31 = XEXP (x6, 0);
      if (!rtx_equal_p (x31, operands[2]))
        return -1;
      x32 = XEXP (x26, 0);
      if (!rtx_equal_p (x32, operands[3]))
        return -1;
      switch (XINT (x4, 1))
        {
        case 115:
          switch (pattern639 (x4))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 446 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6854; /* *p iwmmxt_wqmiabb */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6855; /* *p iwmmxt_wqmiabt */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 472 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6856; /* *p iwmmxt_wqmiatb */

            case 3:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 485 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6857; /* *p iwmmxt_wqmiatt */

            default:
              return -1;
            }

        case 114:
          switch (pattern639 (x4))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 498 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6858; /* *p iwmmxt_wqmiabbn */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 511 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6859; /* *p iwmmxt_wqmiabtn */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 524 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6860; /* *p iwmmxt_wqmiatbn */

            case 3:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 537 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6861; /* *p iwmmxt_wqmiattn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == PLUS
      && GET_MODE (x4) == E_SImode)
    {
      res = recog_361 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x1, 0);
  operands[5] = x6;
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  operands[1] = x4;
  if (shiftable_operator (operands[1], E_SImode))
    {
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (memory_operand (operands[2], E_SImode))
        {
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          if (memory_operand (operands[3], E_SImode))
            {
              x10 = XEXP (x5, 0);
              operands[4] = x10;
              if (scratch_operand (operands[4], E_SImode)
                  && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11472 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && adjacent_mem_locations (operands[2], operands[3]))))
                return 6594; /* *p *arith_adjacentmem */
            }
        }
    }
  x10 = XEXP (x5, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != E_CCmode)
    return -1;
  operands[4] = x6;
  operands[5] = x7;
  operands[3] = x4;
  if (!thumb_16bit_operator (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode)
      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1256 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && GET_CODE(operands[3]) != PLUS
   && GET_CODE(operands[3]) != MINUS)))
    return -1;
  return 6986; /* *p *thumb2_alusi3_short */
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  switch (pattern443 (x2))
    {
    case 0:
      if (pattern525 (x2) != 0)
        return -1;
      x6 = XEXP (x1, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[6] = x7;
      if (pattern606 (operands[0]) != 0)
        return -1;
      x8 = XEXP (x3, 1);
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[4] = x9;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          x11 = XEXP (x10, 0);
          x12 = XEXP (x11, 1);
          if (XWINT (x12, 0) != 4L)
            return -1;
          x13 = XEXP (x5, 1);
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[4])
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 477 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
            return -1;
          return 6638; /* *p *ldm3_ */

        case PLUS:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x18 = XEXP (x9, 1);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XEXP (x9, 0);
          operands[4] = x19;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          x11 = XEXP (x10, 0);
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 4L:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != 8L)
                return -1;
              x13 = XEXP (x5, 1);
              x14 = XEXP (x13, 0);
              if (pattern638 (x14, 
12) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 582 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6642; /* *p *ldm3_ib */

            case -8L:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -4L)
                return -1;
              x13 = XEXP (x5, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[4])
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 643 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6646; /* *p *ldm3_da */

            case -12L:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -8L)
                return -1;
              x13 = XEXP (x5, 1);
              x14 = XEXP (x13, 0);
              if (pattern638 (x14, 
-4) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 704 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6650; /* *p *ldm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern564 (x2) != 0)
        return -1;
      x6 = XEXP (x1, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[6] = x7;
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[3] = x13;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x20 = XEXP (x3, 0);
      x21 = XEXP (x20, 0);
      switch (GET_CODE (x21))
        {
        case REG:
        case SUBREG:
          operands[4] = x21;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x22 = XEXP (x4, 0);
          x23 = XEXP (x22, 0);
          x24 = XEXP (x23, 1);
          if (XWINT (x24, 0) != 4L)
            return -1;
          x25 = XEXP (x5, 0);
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != PLUS
              || GET_MODE (x26) != E_SImode)
            return -1;
          x27 = XEXP (x26, 1);
          if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x28 = XEXP (x23, 0);
          if (!rtx_equal_p (x28, operands[4]))
            return -1;
          x29 = XEXP (x26, 0);
          if (!rtx_equal_p (x29, operands[4])
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 537 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
            return -1;
          return 6640; /* *p *stm3_ */

        case PLUS:
          if (GET_MODE (x21) != E_SImode)
            return -1;
          x30 = XEXP (x21, 1);
          if (GET_CODE (x30) != CONST_INT)
            return -1;
          x31 = XEXP (x21, 0);
          operands[4] = x31;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x22 = XEXP (x4, 0);
          x23 = XEXP (x22, 0);
          x28 = XEXP (x23, 0);
          if (!rtx_equal_p (x28, operands[4]))
            return -1;
          switch (XWINT (x30, 0))
            {
            case 4L:
              x24 = XEXP (x23, 1);
              if (XWINT (x24, 0) != 8L)
                return -1;
              x25 = XEXP (x5, 0);
              x26 = XEXP (x25, 0);
              if (pattern640 (x26, 
12) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 613 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6644; /* *p *stm3_ib */

            case -8L:
              x24 = XEXP (x23, 1);
              if (XWINT (x24, 0) != -4L)
                return -1;
              x25 = XEXP (x5, 0);
              x26 = XEXP (x25, 0);
              if (!rtx_equal_p (x26, operands[4])
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 673 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6648; /* *p *stm3_da */

            case -12L:
              x24 = XEXP (x23, 1);
              if (XWINT (x24, 0) != -8L)
                return -1;
              x25 = XEXP (x5, 0);
              x26 = XEXP (x25, 0);
              if (pattern640 (x26, 
-4) != 0
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 735 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6652; /* *p *stm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      x20 = XEXP (x3, 0);
      operands[3] = x20;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      x9 = XEXP (x8, 0);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x32 = XEXP (x8, 1);
      switch (XWINT (x32, 0))
        {
        case 8L:
          switch (pattern597 (x4))
            {
            case 0:
              x13 = XEXP (x5, 1);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PLUS
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x22 = XEXP (x4, 0);
              operands[1] = x22;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x25 = XEXP (x5, 0);
              operands[2] = x25;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x17 = XEXP (x14, 0);
              if (!rtx_equal_p (x17, operands[3]))
                return -1;
              x10 = XEXP (x4, 1);
              x11 = XEXP (x10, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x11, operands[3])
                      || XWINT (x15, 0) != 4L
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 880 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6655; /* *p *ldm2_ia_update */

                case PLUS:
                  if (GET_MODE (x11) != E_SImode)
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x15, 0) != 8L)
                    return -1;
                  x16 = XEXP (x11, 0);
                  if (!rtx_equal_p (x16, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 957 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6659; /* *p *ldm2_ib_update */

                default:
                  return -1;
                }

            case 1:
              x25 = XEXP (x5, 0);
              if (GET_CODE (x25) != MEM
                  || GET_MODE (x25) != E_SImode)
                return -1;
              x26 = XEXP (x25, 0);
              if (GET_CODE (x26) != PLUS
                  || GET_MODE (x26) != E_SImode)
                return -1;
              x27 = XEXP (x26, 1);
              if (GET_CODE (x27) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x5, 1);
              operands[2] = x13;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x29 = XEXP (x26, 0);
              if (!rtx_equal_p (x29, operands[3]))
                return -1;
              x22 = XEXP (x4, 0);
              x23 = XEXP (x22, 0);
              switch (GET_CODE (x23))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x23, operands[3])
                      || XWINT (x27, 0) != 4L
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 917 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6657; /* *p *stm2_ia_update */

                case PLUS:
                  if (GET_MODE (x23) != E_SImode)
                    return -1;
                  x24 = XEXP (x23, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x27, 0) != 8L)
                    return -1;
                  x28 = XEXP (x23, 0);
                  if (!rtx_equal_p (x28, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 981 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6661; /* *p *stm2_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -8L:
          x10 = XEXP (x4, 1);
          switch (GET_CODE (x10))
            {
            case MEM:
              if (pattern525 (x2) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x22 = XEXP (x4, 0);
              operands[1] = x22;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x25 = XEXP (x5, 0);
              operands[2] = x25;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x10, 0);
              x16 = XEXP (x11, 0);
              if (!rtx_equal_p (x16, operands[3]))
                return -1;
              x12 = XEXP (x11, 1);
              switch (XWINT (x12, 0))
                {
                case -4L:
                  x13 = XEXP (x5, 1);
                  x14 = XEXP (x13, 0);
                  if (!rtx_equal_p (x14, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1007 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6663; /* *p *ldm2_da_update */

                case -8L:
                  x13 = XEXP (x5, 1);
                  x14 = XEXP (x13, 0);
                  if (GET_CODE (x14) != PLUS
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x15 = XEXP (x14, 1);
                  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1059 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6667; /* *p *ldm2_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x10;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern564 (x2) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x5, 1);
              operands[2] = x13;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x22 = XEXP (x4, 0);
              x23 = XEXP (x22, 0);
              x28 = XEXP (x23, 0);
              if (!rtx_equal_p (x28, operands[3]))
                return -1;
              x24 = XEXP (x23, 1);
              switch (XWINT (x24, 0))
                {
                case -4L:
                  x25 = XEXP (x5, 0);
                  x26 = XEXP (x25, 0);
                  if (!rtx_equal_p (x26, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1031 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6665; /* *p *stm2_da_update */

                case -8L:
                  x25 = XEXP (x5, 0);
                  x26 = XEXP (x25, 0);
                  if (GET_CODE (x26) != PLUS
                      || GET_MODE (x26) != E_SImode)
                    return -1;
                  x27 = XEXP (x26, 1);
                  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x29 = XEXP (x26, 0);
                  if (!rtx_equal_p (x29, operands[3])
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1083 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6669; /* *p *stm2_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (s_register_operand (operands[1], E_SImode)
          && s_register_operand (operands[0], E_SImode))
        {
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (reg_or_int_operand (operands[2], E_SImode)
              && 
#line 962 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_op (INTVAL (operands[2]), PLUS)
   && (reload_completed || !arm_eliminable_register (operands[1]))))
            return gen_split_1 (insn, operands);
        }
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !(
#line 66 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1) && 
#line 87 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
( reload_completed && CONST_INT_P (operands[2])
   && ((operands[1] != stack_pointer_rtx
        && (INTVAL (operands[2]) > 255 || INTVAL (operands[2]) < -255))
       || (operands[1] == stack_pointer_rtx
 	   && INTVAL (operands[2]) > 1020)))))
        return NULL;
      return gen_split_113 (insn, operands);

    case MINUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_int_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!reg_or_int_operand (operands[2], E_SImode)
          || !(
#line 2020 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 2031 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( (CONST_INT_P (operands[1])
       && !const_ok_for_arm (INTVAL (operands[1]))))))
        return NULL;
      return gen_split_3 (insn, operands);

    case AND:
    case IOR:
    case XOR:
      operands[6] = x2;
      if (logical_binary_operator (operands[6], E_DImode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (s_register_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (s_register_operand (operands[1], E_DImode))
                {
                  x5 = XEXP (x2, 1);
                  operands[2] = x5;
                  if (s_register_operand (operands[2], E_DImode)
                      && 
#line 2902 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed
   && ! IS_IWMMXT_REGNUM (REGNO (operands[0]))))
                    return gen_split_4 (insn, operands);
                }
            }
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return NULL;
      switch (GET_CODE (x2))
        {
        case AND:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !
#line 3031 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
	|| const_ok_for_arm (~INTVAL (operands[2]))
	|| (arm_arch_thumb2
	    && satisfies_constraint_Dj (operands[2])
	    && (rtx_equal_p (operands[0], operands[1])
		|| !reload_completed)))))
                return NULL;
              return gen_split_6 (insn, operands);

            case IOR:
              if (GET_MODE (x4) != E_SImode)
                return NULL;
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) != NOT
                  || GET_MODE (x5) != E_SImode)
                return NULL;
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              if (!arm_rhs_operand (operands[2], E_SImode))
                return NULL;
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !(
#line 3910 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 3912 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
                return NULL;
              return gen_split_17 (insn, operands);

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              operands[1] = x4;
              if (!arm_comparison_operator (operands[1], E_SImode))
                return NULL;
              x7 = XEXP (x4, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (!cc_register (operands[2], E_VOIDmode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (!s_register_operand (operands[3], E_SImode))
                return NULL;
              if ((
#line 9815 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 9817 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_78 (insn, operands);
              if (!(
#line 618 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 620 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_146 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !
#line 3744 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
        || (TARGET_THUMB2 && const_ok_for_arm (~INTVAL (operands[2]))))))
                return NULL;
              return gen_split_14 (insn, operands);

            case AND:
              if (pattern361 (x2) != 0
                  || !
#line 5817 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[3])
       == (GET_MODE_MASK (GET_MODE (operands[5]))
           & (GET_MODE_MASK (GET_MODE (operands[5]))
	      << (INTVAL (operands[2])))))))
                return NULL;
              return gen_split_35 (insn, operands);

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              if (!arm_comparison_operator (x4, E_SImode))
                return NULL;
              x7 = XEXP (x4, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x6 = XEXP (x4, 0);
              if (!cc_register (x6, E_VOIDmode))
                return NULL;
              operands[2] = x6;
              operands[1] = x4;
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (s_register_operand (operands[3], E_SImode))
                {
                  if ((
#line 9844 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 9848 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed
   && REGNO (operands [0]) != REGNO (operands[3]))))
                    return gen_split_79 (insn, operands);
                  if ((
#line 646 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it) && 
#line 651 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( reload_completed
    && REGNO (operands [0]) != REGNO (operands[3]))))
                    return gen_split_147 (insn, operands);
                }
              operands[3] = x6;
              operands[2] = x4;
              operands[1] = x5;
              if (!s_register_operand (operands[1], E_SImode)
                  || !(
#line 677 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it) && 
#line 679 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_148 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !
#line 3849 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_arm (INTVAL (operands[2]))))
                return NULL;
              return gen_split_15 (insn, operands);

            case AND:
              if (pattern361 (x2) != 0
                  || !
#line 5817 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[3])
       == (GET_MODE_MASK (GET_MODE (operands[5]))
           & (GET_MODE_MASK (GET_MODE (operands[5]))
	      << (INTVAL (operands[2])))))))
                return NULL;
              return gen_split_36 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          if (!s_register_operand (operands[1], E_DImode)
              || !s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 2922 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_5 (insn, operands);

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x2) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return NULL;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (arm_comparison_operator (operands[1], E_SImode)
                  && 
#line 8140 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return gen_split_73 (insn, operands);
              if (arm_comparison_operator_mode (operands[1], E_SImode)
                  && (
#line 396 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it) && 
#line 398 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( true)))
                return gen_split_143 (insn, operands);
            }
          if (!low_register_operand (operands[0], E_SImode)
              || !arm_comparison_operator_mode (operands[1], E_SImode)
              || !(
#line 416 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it) && 
#line 418 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( reload_completed)))
            return NULL;
          return gen_split_144 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_VOIDmode)
              || !
#line 5622 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_29 (insn, operands);

        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!s_register_operand (operands[1], E_HImode)
                  || !
#line 5678 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(!TARGET_THUMB2 && !arm_arch6))
                return NULL;
              return gen_split_31 (insn, operands);

            case E_QImode:
              if (!s_register_operand (operands[1], E_QImode)
                  || !
#line 5742 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(!arm_arch6))
                return NULL;
              return gen_split_32 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_VOIDmode)
              || !
#line 5640 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_30 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !
#line 5917 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(!arm_arch6))
                return NULL;
              return gen_split_38 (insn, operands);

            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && 
#line 6011 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(!arm_arch6))
                return gen_split_39 (insn, operands);
              if (!memory_operand (operands[1], E_QImode)
                  || !
#line 512 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed))
                return NULL;
              return gen_split_118 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_2 (x1, insn);

    case UNSPEC:
      if (XVECLEN (x2, 0) != 2)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x9 = XVECEXP (x2, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x2, 0, 1);
      operands[2] = x10;
      switch (XINT (x2, 1))
        {
        case 27:
          if (GET_MODE (x2) != E_SImode
              || !s_register_operand (operands[0], E_SImode)
              || !(
#line 6690 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(flag_pic) && 
#line 6692 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
            return NULL;
          return gen_split_67 (insn, operands);

        case 343:
          if (GET_MODE (x2) != E_V16QImode
              || !s_register_operand (operands[0], E_V16QImode))
            return NULL;
          switch (pattern415 ())
            {
            case 0:
              if (!(
#line 4748 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 4750 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
                return NULL;
              return gen_split_173 (insn, operands);

            case 1:
              if (!(
#line 4779 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 4781 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
                return NULL;
              return gen_split_174 (insn, operands);

            default:
              return NULL;
            }

        case 171:
          if (GET_MODE (x2) != E_OImode
              || !s_register_operand (operands[0], E_OImode)
              || !s_register_operand (operands[1], E_V16QImode)
              || !s_register_operand (operands[2], E_V16QImode)
              || !(
#line 4814 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 4816 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_175 (insn, operands);

        default:
          return NULL;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      if (arm_comparison_operator_mode (operands[1], E_SImode))
        {
          x5 = XEXP (x2, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x2, 0);
                  operands[2] = x4;
                  if (cc_register (operands[2], E_VOIDmode)
                      && 
#line 8094 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                    return gen_split_71 (insn, operands);
                }
            }
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      if (GET_MODE (x2) == E_SImode)
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (s_register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              switch (GET_CODE (x2))
                {
                case LTU:
                  if (thumb1_cmp_operand (operands[2], E_SImode)
                      && 
#line 1791 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return gen_split_130 (insn, operands);
                  break;

                case LEU:
                  if (s_register_operand (operands[2], E_SImode)
                      && 
#line 1819 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
  && !reg_overlap_mentioned_p (operands[0], operands[1])
  && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    return gen_split_131 (insn, operands);
                  break;

                case GEU:
                  if (thumb1_cmp_operand (operands[2], E_SImode)
                      && 
#line 1832 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
  && !reg_overlap_mentioned_p (operands[0], operands[1])
  && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    return gen_split_132 (insn, operands);
                  break;

                default:
                  break;
                }
            }
        }
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[1] = x2;
      if (!arm_comparison_operator_mode (operands[1], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!cc_register (operands[2], E_VOIDmode)
          || !
#line 328 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return NULL;
      return gen_split_140 (insn, operands);

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!arm_comparison_operator_mode (operands[1], E_SImode))
            return NULL;
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x2) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return NULL;
          if (s_register_operand (operands[0], E_SImode))
            {
              if ((
#line 8119 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_borrow_operation (operands[1], SImode)) && 
#line 8121 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( true)))
                return gen_split_72 (insn, operands);
              if ((
#line 344 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && !arm_restrict_it
   && !arm_borrow_operation (operands[1], SImode)) && 
#line 348 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( true)))
                return gen_split_141 (insn, operands);
            }
          if (!low_register_operand (operands[0], E_SImode)
              || !(
#line 365 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && arm_restrict_it
   && !arm_borrow_operation (operands[1], SImode)) && 
#line 369 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( reload_completed)))
            return NULL;
          return gen_split_142 (insn, operands);

        case REG:
        case SUBREG:
          if (!s_register_operand (operands[1], E_DFmode)
              || !s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 906 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE && reload_completed
   && arm_general_register_operand (operands[0], DFmode)))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (!arm_comparison_operator (x4, E_VOIDmode))
        return NULL;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x4, 0);
      if (!cc_register (x6, E_VOIDmode))
        return NULL;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x5;
          x11 = XEXP (x2, 2);
          switch (GET_CODE (x11))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x11;
              if (!arm_not_operand (operands[2], E_SImode))
                return NULL;
              operands[3] = x4;
              operands[4] = x6;
              if (!arm_not_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 8506 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 8520 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_74 (insn, operands);
              if (!(
#line 442 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 462 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_145 (insn, operands);

            case NEG:
              if (GET_MODE (x11) != E_SImode)
                return NULL;
              operands[4] = x4;
              operands[3] = x6;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x12 = XEXP (x11, 0);
              operands[2] = x12;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 11443 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 11445 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
                return NULL;
              return gen_split_97 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          operands[4] = x4;
          operands[3] = x6;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return NULL;
          x11 = XEXP (x2, 2);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 11407 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && !TARGET_COND_ARITH) && 
#line 11409 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
            return NULL;
          return gen_split_96 (insn, operands);

        default:
          return NULL;
        }

    case CTZ:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !(
#line 12213 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2) && 
#line 12215 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
        return NULL;
      return gen_split_104 (insn, operands);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 100)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      switch (GET_MODE (x3))
        {
        case E_CCFPmode:
          switch (pattern362 (x2, 
E_CCFPmode))
            {
            case 0:
              if (!
#line 1751 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return NULL;
              return gen_split_107 (insn, operands);

            case 1:
              if (!
#line 1781 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return NULL;
              return gen_split_109 (insn, operands);

            default:
              return NULL;
            }

        case E_CCFPEmode:
          switch (pattern362 (x2, 
E_CCFPEmode))
            {
            case 0:
              if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return NULL;
              return gen_split_108 (insn, operands);

            case 1:
              if (!
#line 1796 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return NULL;
              return gen_split_110 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      x11 = XEXP (x2, 2);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 220 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return NULL;
      return gen_split_115 (insn, operands);

    case VEC_CONCAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern11 (x2))
        {
        case 0:
          if (!(
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_166 (insn, operands);

        case 1:
          if (!(
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_167 (insn, operands);

        case 2:
          if (!(
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_168 (insn, operands);

        case 3:
          if (!(
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_169 (insn, operands);

        case 4:
          if (!(
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_170 (insn, operands);

        case 5:
          if (!(
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_171 (insn, operands);

        case 6:
          if (!(
#line 3649 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_172 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      if (GET_MODE (x2) != E_V2DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V2DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!neon_struct_operand (operands[1], E_DImode)
          || !(
#line 5204 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 5206 "../../gcc-15.1.0/gcc/config/arm/neon.md"
( reload_completed)))
        return NULL;
      return gen_split_176 (insn, operands);

    default:
      return NULL;
    }
}
